library test1;
{ Gladiators Software, 1999-2006}

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\plg.pas}
{$ENDIF}
{$IMAGEBASE $00400000}
uses
  Windows,
  messages,
  ShellAPI,
  FNxxx in '..\SDK\FNxxx.pas',
  AstonSDK in '..\SDK\AstonSDK.pas',
  st_api in '..\SDK\st_api.pas',
  Drawpng in '..\SDK\Drawpng.pas',
  AstonEx in '..\SDK\AstonEx.pas';
const
 szName:Pchar = 'Test plug-in';
 szhelp:Pchar = 'Test plug-in';
 szSection:Pchar = 'Test_PLG1';
 szPicKey = 'PicPath';
 szPicKeyHint = 'Picture';
 KeyCount = 1;
 Keys:array[1..KeyCount] of TKey = (
  (szKey: szPicKey; nType:KEY_BITMAP; szHint: szPicKeyHint;
       vDefault: 0; res1:0; res2:0)
  );

var
  PluginInfo:TPluginInfo;
  AData: TAstonData;
  ii:AstonWND;
  pic1,pic2,pic3:TPicture;
  dc:HDC;
  i,j,k:integer;
  w:HWND;
  pp:Ppaint;
  Pic_path:array[0..MAX_PATH]of CHAR;
//---------------------------------------------------------------------
procedure GetDefPicture(result, pic:Pchar);
var
 i:integer;
begin
  GetModuleFileName(AData.AppInstance, result, MAX_PATH);
  for i:=lstrlen(result)-1 downto 0 do
   if result[i] = '\' then
   begin
     result[i+1] := #0;
     break;
   end;
  lstrcat(result, pic);
end;

//---------------------------------------------------------------------
procedure ShowError(text:Pchar);
begin
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);   // disable recycle
  MessageBox(0, text, 'Error', MB_ICONWARNING or MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);   // enable recycle
end;

//---------------------------------------------------------------------
//---------------------------------------------------------------------
procedure LoadConfig();   // read Config
var
  CFG:TCFG;
begin
  OpenCFGr(AData.PluginsCFG, @CFG);
  FindSection(szSection, 0, @CFG);
  GetCFGString(szPicKey, #0, Pic_path, MAX_PATH, @CFG);
  if IsPSTREmpty(@Pic_path[0]) then
  begin
    GetDefPicture(Pic_path, 'Pic\frame.jpg'); //  default picture, for test
  end;
  CloseCFGr(@CFG);
end;

//---------------------------------------------------------------------

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
begin
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));
  LoadConfig();
  ii:= AstonWND(CreateAstonWND(0,0, 0, 2, AWS_LAYERED or AWS_FADESTYLE, nil, 0, 0));
  if (ii = nil) then
  begin
   ShowError('Aston window wasn''t created');
   exit;
  end;
  if (ii.GetVer <19200) then   // check version
  begin
    ShowError('Old version AstonEx.dll! Please update Aston');
    exit;
  end;
  i := ii.SetBG(Pic_path); // add  background (zero layer)
  if (i<0) then ShowError('Picture "pic\frame.jpg" not found!');  // i = layer index
  ii.Show(1);
end;
//---------------------------------------------------------------------

procedure DoneModule;stdcall;
var
 w:HWND;
begin
   w := ii.wnd;
   DestroyWindow(w); // free all layers
   Pointer(ii) := nil; // set pointer = nil  
end;
//---------------------------------------------------------------------

function GetPluginInfo():PPluginInfo;stdcall;
begin
  PluginInfo.cbSize:= SizeOf(TPluginInfo);
  PluginInfo.szName:= szName;
  PluginInfo.szDescription:= szhelp;
  PluginInfo.szSection:= szSection;
  PluginInfo.nKeyCount:= KeyCount;
  PluginInfo.Keys:= @Keys;
  result:= @PluginInfo;
end; 

exports
  InitGlobalModule,
  GetPluginInfo,
  DoneModule;
end.
