library test2;
{ Gladiators Software, 1999-2006}

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\plg.pas}
{$ENDIF}
{$IMAGEBASE $00400000}
uses
  Windows,
  messages,
  ShellAPI,
  FNxxx in '..\SDK\FNxxx.pas',
  AstonSDK in '..\SDK\AstonSDK.pas',
  st_api in '..\SDK\st_api.pas',
  Drawpng in '..\SDK\Drawpng.pas',
  AstonEx in '..\SDK\AstonEx.pas';
const
 szName:Pchar = 'Test plug-in';
 szhelp:Pchar = 'Test plug-in';
 szSections:Pchar = 'Test_PLG';
 szPicKey = 'picture';
 szPicKeyHint = 'Picture';
 KeyCount = 1;
 Keys:array[1..KeyCount] of TKey = (
  (szKey: szPicKey; nType:KEY_BITMAP; szHint: szPicKeyHint;
       vDefault: 0; res1:0; res2:0)
  );

var
  PluginInfo:TPluginInfo;
  AData: TAstonData;
  ii:AstonWND;
  pic, pic1,pic2,pic3:TPicture;
  c,index,j,k,s,b:integer;
  w:HWND;
  r:TRect;
//---------------------------------------------------------------------
procedure ShowError(text:Pchar);
begin
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);   // disable recycle
  MessageBox(0, text, 'Error', MB_ICONWARNING or MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);   // enable recycle
end;

//---------------------------------------------------------------------
procedure GetDefPicture(result, pic:Pchar);
var
 i:integer;
begin
  GetModuleFileName(AData.AppInstance, result, MAX_PATH);
  for i:=lstrlen(result)-1 downto 0 do
   if result[i] = '\' then
   begin
     result[i+1] := #0;
     break;
   end;
  lstrcat(result, pic);
end;

//---------------------------------------------------------------------
//---------------------------------------------------------------------

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
 path:array[0..MAX_PATH] of CHAR;
begin
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));
  ii:= AstonWND(CreateAstonWND(0,0, 0, 2, AWS_LAYERED or AWS_FADESTYLE, nil, 0, 10));
  if (ii = nil) then
  begin
   ShowError('Aston window wasn''t created');
   exit;
  end;
  if (ii.GetVer <19200) then   // check version
  begin
    ShowError('old version of AstonEx.dll! Please update Aston');
    exit;
  end;
  GetDefPicture(path, 'pic\frame.jpg');
  index := ii.SetBG(path); // add  background (zero layer)
  if (index<0) then
    ShowError('Picture "%AstonPath%\pic\frame.jpg" is not found! Please copy folder with pictures to %AstonPath%\Pic\' ); // index = layer index

 //---------------------------------------------------------------
  ii.MoveWindow(100,100);   // set a new position for the window

  //---------------------------------------------------------------
  SetRect(r, 200,50,400,70);
  ii.DrawTextOnLayer(index, 'Hello Aston developers', @r,
                     GetStockObject(SYSTEM_FONT), DT_LEFT, $0000FF, true, 0);

  //---------------------------------------------------------------

  GetDefPicture(path, 'pic\cd.ankz');
  j := ii.AddLayer(0,0,0, path, LAYER_DRAG, 0);
  if (j<0) then ShowError('Picture "%AstonPath%\Pic\cd.ankz" is not found!');

   //---------------------------------------------------------------

  k := ii.CreateCustomLayer(0,100,100,50,70, LAYER_DRAWWALLPAPER or LAYER_LAYERED,0);

  //---------------------------------------------------------------

  w := ii.CreateChildWnd(WS_EX_TOOLWINDOW, 'EDIT', 'edit control', WS_VISIBLE or WS_BORDER or ES_MULTILINE or ES_AUTOVSCROLL, 250,100, 150,80,0, HINSTANCE, nil);

  //---------------------------------------------------------------
  RtlZeroMemory(@pic, sizeof(TPicture));
  GetDefPicture(path, 'pic\XPClock.png');
  pic.FileName := path;
  LoadImageEx(@pic);
  if pic.IconType > 0 then
  begin
    c := ii.AddLayerPic(0, 0,280, @pic, LAYER_DRAGITEM);
    ii.AddHintOnLayer(c, 'Drag me!');    // add hint to the layer
  end
  else
    ShowError('Picture "%AstonPath%\Pic\XPClock.png" is not found!');
  pic.FileName := nil;
    
 //---------------------------------------------------------------

  RtlZeroMemory(@pic1, sizeof(TPicture));
  RtlZeroMemory(@pic2, sizeof(TPicture));
  RtlZeroMemory(@pic3, sizeof(TPicture));
  GetDefPicture(path, 'pic\AA-play1.png');
  pic1.FileName := path;
  LoadImageEx(@pic1);
  GetDefPicture(path, 'pic\AA-play2.png');
  pic2.FileName := path;
  LoadImageEx(@pic2);
  GetDefPicture(path, 'pic\AA-play3.png');
  pic3.FileName := path;
  LoadImageEx(@pic3);

  ii.AddLayerPic3(0, 200,200, @pic1, @pic2, @pic3, 0);
  
  pic1.FileName := nil;
  pic2.FileName := nil;
  pic3.FileName := nil;

 //---------------------------------------------------------------
  GetDefPicture(path, 'pic\pos_bar.png');
  s := ii.AddLayer(0,100,40,path, 0, 0);
  GetDefPicture(path, 'pic\VSliderDot.png');
  b := ii.AddLayer(0,0,0,path, 0, 0);

  ii.MakeScrollBar(s,b,10, 120, 50,0);

 //---------------------------------------------------------------
  ii.Show(1);
end;
//---------------------------------------------------------------------

procedure DoneModule;stdcall;
begin
   DestroyWindow(ii.wnd); // free all layers
   Pointer(ii) := nil; // You must set ii = nil otherwise AV !!
   FreePicture(@pic1);
   FreePicture(@pic2);
   FreePicture(@pic3);
end;
//---------------------------------------------------------------------

function GetPluginInfo():PPluginInfo;stdcall;
begin
  PluginInfo.cbSize:= SizeOf(TPluginInfo);
  PluginInfo.szName:= szName;
  PluginInfo.szDescription:= szhelp;
  PluginInfo.szSection:= szSections;
  PluginInfo.nKeyCount:= KeyCount;
  PluginInfo.Keys:= @Keys;
  result:= @PluginInfo;
end; 

exports
  InitGlobalModule,
  GetPluginInfo,
  DoneModule;
end.
