library test3;
{ Gladiators Software, 1999-2006}

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\plg.pas}
{$ENDIF}
{$IMAGEBASE $00400000}
uses
  Windows,
  messages,
  ShellAPI,
  FNxxx in '..\SDK\FNxxx.pas',
  AstonSDK in '..\SDK\AstonSDK.pas',
  st_api in '..\SDK\st_api.pas',
  Drawpng in '..\SDK\Drawpng.pas',
  AstonEx in '..\SDK\AstonEx.pas';
const
 szName:Pchar = 'Test plug-in';
 szhelp:Pchar = 'Test plug-in';
 szSection:Pchar = 'Test_PLG';
 szXY = 'XY';
 szXYHint = 'Coordinates';
 szZOrderHint = 'Z-Order';
 szZOrder = 'ZOrder';
 TPos = 2;
 TPosT:array[0..TPos] of PChar=('Desktop','Normal','Always on top');

 KeyCount = 2;
 Keys:array[1..KeyCount] of TKey = (
  (szKey: szXY; nType:KEY_POINT; szHint: szXYHint;
       vDefault: 0; res1:0; res2:0),
  (szKey: szZOrder; nType:KEY_LIST; szHint: szZOrderHint;
       vDefault: 1; res1:TPos; res2:0)
  );

var
  PluginInfo:TPluginInfo;
  AData: TAstonData;
  ii:AstonWND;
  pic1,pic2,pic3:TPicture;
  btn, index,j,k,s,b:integer;
  pp:Ppaint;
  CFG:TCFG;
  xy:TPoint;
  ZOrder:integer;
//---------------------------------------------------------------------
procedure LoadConfig();   // read Config
begin
  OpenCFGr(AData.PluginsCFG, @CFG);
  FindSection(szSection, 0, @CFG);
  xy.x := 50; // default coordinates
  xy.y := 50;
  GetCFGPoint(szXY,  xy, @CFG);
  ZOrder := GetCFGInt(szZOrder, 2, @CFG);

  CloseCFGr(@CFG);
end;

//---------------------------------------------------------------------
procedure GetDefaultPicture(result, pic:Pchar);
var
 i:integer;
begin
  GetModuleFileName(AData.AppInstance, result, MAX_PATH);
  for i:=lstrlen(result)-1 downto 0 do
   if result[i] = '\' then
   begin
     result[i+1] := #0;
     break;
   end;
  lstrcat(result, pic);
end;
//---------------------------------------------------------------------
procedure ShowError(text:Pchar);
begin
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);   // disable recycle
  MessageBox(0, text, 'Error', MB_ICONWARNING or MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);   // enable recycle
end;

//---------------------------------------------------------------------
procedure DrawWindowCoordinates(wnd:HWND);
var
 st:array[0..64]of CHAR;
 r:TRECT;
begin
          GetWindowRect(wnd, r);
          pp := ii.LayerPaint_Begin(k);
          wvsprintf(st, '%i x %i', @r);
          SetRectEmpty(r);
          r.Right := pp.size.cx;
          r.Bottom := pp.size.cy;
          ii.DrawText(pp.dc, st, @r, GetStockObject(SYSTEM_FONT), DT_LEFT, $0000ff, true, 0); 
          ii.LayerPaint_End(pp);
          ii.RedRaw();
end;
//---------------------------------------------------------------------
//---------------------------------------------------------------------
function WindowProc(Window: HWnd; Msg:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
var
 st:array[0..64]of CHAR;
 r:TRECT;
 CFG:TCFG;
 i:integer;
 p:TPoint;
begin
    case Msg of
WM_MOVE:
    begin
       DrawWindowCoordinates(Window);
    end;
WM_EXITSIZEMOVE: // end window dragging and save window position
      begin
          GetWindowRect(window, r);
          RtlZeroMemory(@CFG, sizeof(TCFG));
          OpenCFGw(AData.PluginsCFG, @CFG);
          FindSection(szSection, 1, @CFG);
          p.x := r.left;
          p.y := r.top;
          SetCFGPoint(szXY, p, @CFG);
          CloseCFGw(AData.PluginsCFG, false, @CFG);
      end;


WM_KEYDOWN:
        begin
          pp := ii.LayerPaint_Begin(k);
          lstrcpy(st, 'KEYDOWN: ');
          i := lstrlen(st);
          st[i] := CHAR(wParam);
          st[i+1] := #0;
          SetRectEmpty(r);
          r.Right := pp.size.cx;
          r.Bottom := pp.size.cy;   // r = layer rect  
          ii.DrawText(pp.dc, st, @r, GetStockObject(SYSTEM_FONT), DT_LEFT, $0000ff, true, 0);
          ii.LayerPaint_End(pp);
          ii.RedRaw();
        end;

WM_LBUTTONDOWN:  // wParam - layer index
        begin
            if wParam = btn then
            begin
              MessageBox(Window, 'Hello Aston developers!', 'Hello', MB_TOPMOST);
            end;
        
        end;
                
WM_HSCROLL: // WParam = scrollbar position, LParam - scroll index
            // show scrollbar position
        begin
          wvsprintf(st, '%i', @WParam);
          SetRect(r,0,0,100,100);
          pp := ii.LayerPaint_Begin(j);
          ii.DrawText(pp.dc, st, @r, GetStockObject(SYSTEM_FONT), DT_LEFT, $0000ff, true, 0);
          ii.LayerPaint_End(pp);
          ii.RedRaw();
        end;

    end;

 result := 0; // RETURN 0 !!!!
end;

//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
 path:array[0..MAX_PATH]of CHAR;
begin
  if AstonData.cbsize<SizeOf(TAstonData) then exit;
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));
  LoadConfig();

  ii:= AstonWND(CreateAstonWND(xy.x,xy.y, AData.Desktop, ZOrder, AWS_LAYERED or AWS_FADESTYLE, @WindowProc, AData.Desktop, 10));   // create window
  if (ii = nil) then
  begin
   ShowError('Aston window wasn''t created');
   exit;
  end;
  if (ii.GetVer <19200) then   // check version
  begin
    ShowError('Old version AstonEx.dll Please update Aston');
    DestroyWindow(ii.wnd()); //  destroy window
    Pointer(ii) := nil; 
    exit;
  end;

  GetDefaultPicture(path, 'Pic\frame.jpg');
  index := ii.SetBG(path); // add  background (zero layer)
  if (index<0) then ShowError('Picture "%AstonPath%\pic\frame.jpg" is not found!');

  //---------------------------------------------------------------

  k := ii.CreateCustomLayer(0,0,-20,100,20, LAYER_LAYERED,0);   // create a layer for drawing window coordinates
  DrawWindowCoordinates(ii.wnd());

  //---------------------------------------------------------------

  RtlZeroMemory(@pic1, sizeof(TPicture));
  RtlZeroMemory(@pic2, sizeof(TPicture));
  RtlZeroMemory(@pic3, sizeof(TPicture));
  GetDefaultPicture(path, 'Pic\AA-play1.png');
  pic1.FileName := path;
  LoadImageEx(@pic1);
  GetDefaultPicture(path, 'Pic\AA-play2.png');
  pic2.FileName := path;
  LoadImageEx(@pic2);
  GetDefaultPicture(path, 'Pic\AA-play3.png');
  pic3.FileName := path;
  LoadImageEx(@pic3);

  btn := ii.AddLayerPic3(0, 200,20, @pic1, @pic2, @pic3, 0);   // button with 3 states

  pic1.FileName := nil;
  pic2.FileName := nil;
  pic3.FileName := nil;

 //---------------------------------------------------------------
  GetDefaultPicture(path, 'Pic\pos_bar.png');
  s := ii.AddLayer(0,10,40,path, 0, 0);
  GetDefaultPicture(path, 'Pic\VSliderDot.png');
  b := ii.AddLayer(0,0,0,path, 0, 0);

  ii.MakeScrollBar(s,b,10, 120, 50,0);

  j := ii.CreateCustomLayer(0, 135,35, 30,20, LAYER_LAYERED,0);  // layer for drawing scrollbar position

 //---------------------------------------------------------------

  ii.Show(1);
end;
//---------------------------------------------------------------------

procedure DoneModule;stdcall;
begin
   DestroyWindow(ii.wnd); // release all layers
   Pointer(ii) := nil;    // You must set ii = nil otherwise AV !!
   FreePicture(@pic1);
   FreePicture(@pic2);
   FreePicture(@pic3);
end;
//---------------------------------------------------------------------

function GetPluginInfo():PPluginInfo;stdcall;
begin
  PluginInfo.cbSize:= SizeOf(TPluginInfo);
  PluginInfo.szName:= szName;
  PluginInfo.szDescription:= szhelp;
  PluginInfo.szSection:= szSection;
  PluginInfo.nKeyCount:= KeyCount;
  PluginInfo.Keys:= @Keys;
  Keys[2].res2:=integer(@TPosT);
  result:= @PluginInfo;
end; 

exports
  InitGlobalModule,
  GetPluginInfo,
  DoneModule;
end.
