library DeskChld;

uses
  Windows,
  Messages,
  FNxxx in '..\..\SDK\FNxxx.pas',
  AstonSDK in '..\..\SDK\AstonSDK.pas',
  st_api in '..\..\SDK\st_api.pas';

{---------------------------------------------------------------------}

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\..\plg.pas}
{$ENDIF}

{$IMAGEBASE $00400000}


{---------------------------------------------------------------------}
const
 szClassName = 'Desktop Plugin Sample';
 szXPos = 'XPos';
 szYPos = 'YPos';

var
 AData: TAstonData;
 ChildWindow:hWnd=0;
 ClientRC:TRect;
 XPos, YPos: integer;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure SavePos;
var
  CFG:TCFG;
  r:TRect;
begin
  OpenCFGw(AData.PluginsCFG, @CFG);
  FindSection(szClassName, SECTION_CREATE_ALWAYS, @CFG);
  GetWindowRect(ChildWindow, r);
  XPos:=r.Left;
  YPos:=r.Top;
  SetCFGInt(szXPos, XPos, @CFG);
  SetCFGInt(szYPos, YPos, @CFG);
  CloseCFGw(AData.PluginsCFG, false, @CFG);
end;
{---------------------------------------------------------------------}
function WindowProc(Window: HWnd; Message:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
var
  DC: hDC;
  ps: TPaintStruct;
  r, r2:Trect;
  uFlags:UINT;
begin
  result := 0;
  case Message of
    WM_PAINT:
    begin
      DC:=BeginPaint(Window, ps);
      GetClientRect(Window, ClientRC);
      GetWindowRect(Window, r);
      SetRect(r2, 0,0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
      uFlags:= DPEx_CORRECTBRUSH;
      with AData.WallPaperInfo do
      begin
        if TileWallpaper<>0 then uFlags:= uFlags or DPEx_TILED;
        if WallpaperStyle=0 then uFlags:= uFlags or DPEx_CENTERED;
        DrawSkin(DC, DC, ClientRC, r, r2, Wallpaper, DesktopBrush, uFlags);
      end;

      DrawEdge(DC, ClientRC, BDR_SUNKENOUTER, BF_RECT);
      InflateRect(ClientRC, -8, -8);
      DrawEdge(DC, ClientRC, BDR_RAISEDINNER, BF_RECT);
      EndPaint(Window, ps);
      exit;
    end;
    WM_ERASEBKGND:
    begin
      result:= 1;
      exit;
    end;
    WM_ENTERSIZEMOVE:
    begin
      SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) and not WS_EX_TRANSPARENT);
    end;
    WM_MOVING:
    begin
      InvalidateRect(Window, nil, false);
    end;
    WM_EXITSIZEMOVE:
    begin
      SavePos;
      SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) or WS_EX_TRANSPARENT);
      InvalidateRect(Window, nil, false);
    end;
    WM_NCHITTEST:
    begin
      DefWindowProc(Window, Message, WParam, LParam);
      result:=HTCAPTION;
      exit;
    end;
  end;
  result := DefWindowProc(Window, Message, WParam, LParam);
end;

{---------------------------------------------------------------------}
procedure ReadConfig;
var
  CFG:TCFG;
begin
  OpenCFGr(AData.PluginsCFG, @CFG);

  FindSection(szClassName, 0, @CFG);
  XPos:=GetCFGInt(szXPos, 0, @CFG);
  CheckInt(XPos, 0, GetSystemMetrics(SM_CXSCREEN)-8, 0);
  YPos:=GetCFGInt(szYPos, 1, @CFG);
  CheckInt(YPos, 0, GetSystemMetrics(SM_CYSCREEN)-8, 0);
  CloseCFGr(@CFG);
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  WindowClass:TWndClass;
begin

  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));

  RtlZeroMemory(@WindowClass, sizeOf(TWndClass));
  WindowClass.style:=CS_HREDRAW or CS_VREDRAW;
  WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
  WindowClass.hInstance := hInstance;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.lpszClassName:= szClassName;
  if RegisterClass(WindowClass) = 0 then exit;


  ReadConfig;

  ChildWindow:= CreateWindowEx(WS_EX_TRANSPARENT,
    szClassName,
    nil,
    WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_CLIPCHILDREN,
    XPos, YPos,
    64, 48,
    AData.Desktop,
    0,
    hInstance,
    nil);

  AData.Node.Wnd:= ChildWindow;
  GetClientRect(ChildWindow, ClientRC);
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure DoneModule; stdcall;
begin
  if ChildWindow<>0 then
  begin
    DestroyWindow(ChildWindow);
    ChildWindow:=0;
  end;
  UnregisterClass(szClassName, hInstance);
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

exports
  InitGlobalModule,
  DoneModule;
end.
