library ShutDown;

{ Gladiators Software, 1999-2002}


//how to detect ATX feature????

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\..\plg.pas}
{$ENDIF}

{$IMAGEBASE $00400000}

uses
  Windows,
  Messages,
  ShellAPI,
  FNxxx in '..\..\SDK\FNxxx.pas',
  AstonSDK in '..\..\SDK\AstonSDK.pas',
  st_api in '..\..\SDK\st_api.pas';

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{$r icon.res}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
const
  szName:Pchar = 'Aston Tray Shutdown';
  szHelp:PChar = 'Aston Tray Shutdown 1.6'#13#10+
  ' 1999-2002 Gladiators Software'#13#10+
  'Press and hold down the "Ctrl" key to'#13#10+
  'forces processes to terminate.'#13#10+
  'Warning!'#13#10+
  'This can cause the applications to lose data.'#13#10+
  'You should only use this key in an emergency.';

  CM_ICONMESSAGE = WM_USER+1;

  SeDown:Pchar = 'SeShutdownPrivilege';

  szATX = 'ATX poweroff';
  KeyCount = 1;
  Keys: array[1..KeyCount] of TKey = (
    (szKey:szATX; nType:KEY_BOOL or KEY_NOTHEME;  szHint: szATX;
     vDefault: 1; res1:0; res2:0));

var
  AData: TAstonData;
  ChildWindow:hWnd=0;
  SmallIcon:hIcon;
  ta:TNOTIFYICONDATA;
  Added:boolean = false;
  ATX: boolean;
{---------------------------------------------------------------------}
  PluginInfo:TPluginInfo;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure AdjustPrivileges(pp: PChar);
var
  hToken: THandle;
  tkp: TOKEN_PRIVILEGES;
begin
  if AData.osver.dwPlatformId <> VER_PLATFORM_WIN32_NT then exit;
  if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
    exit;
  LookupPrivilegeValue(nil, pp, tkp.Privileges[0].Luid);
  tkp.PrivilegeCount:= 1;
  tkp.Privileges[0].Attributes:= SE_PRIVILEGE_ENABLED;
  AdjustTokenPrivileges(hToken, false, tkp, 0, nil, nil);
  CloseHandle(hToken);
end;

{---------------------------------------------------------------------}
procedure DoAction(lParam: longint);
var
  Flags: integer;
begin
  case lParam of
    WM_LBUTTONDOWN:
    begin
      if ATX then Flags:= EWX_POWEROFF
             else Flags:= EWX_SHUTDOWN;
    end;
    WM_RBUTTONDOWN:
    begin
      Flags:= EWX_REBOOT;
    end;
    else
      exit;
  end;
  AdjustPrivileges(SeDown);
  if GetAsyncKeyState(VK_CONTROL) < 0 then Flags:= Flags or EWX_FORCE;
  ExitWindowsEx(Flags, 0);
end;

{---------------------------------------------------------------------}
function WindowProc(Window: HWnd; Message:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
begin
  result := 0;
  case Message of
    CM_ICONMESSAGE:
    begin
      DoAction(lParam);
      exit;
    end;
  end;
  result := DefWindowProc(Window, Message, WParam, LParam);
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure ReadConfig;
var
  CFG:TCFG;
begin
  OpenCFGr(AData.PluginsCFG, @CFG);
  FindSection(szName, 0, @CFG);
  ATX:= GetCFGBool(szATX, true, @CFG);
  CloseCFGr(@CFG);
end;
{----------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  WindowClass:TWndClass;
begin
  if AstonData.cbsize < SizeOf(TAstonData) then exit;
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));

  RtlZeroMemory(@WindowClass, sizeOf(TWndClass));
  WindowClass.hInstance := HInstance;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.lpszClassName:= szName;
  if RegisterClass(WindowClass) = 0 then exit;

  ReadConfig;
  
  ChildWindow:= CreateWindowEx(0,
     szName,
     nil,
     WS_CHILD,
     0, 0,
     0, 0,
     AData.TaskBar,
     0,
     hInstance,
     nil);

  AData.Node.Wnd:= ChildWindow;

  SmallIcon:= LoadImage(hInstance, PChar(1), IMAGE_ICON, 16, 16, LR_SHARED);

  ta.cbSize:= SizeOf(TNOTIFYICONDATA);
  ta.Wnd:= ChildWindow;
  ta.uID:= 1;

  ta.uFlags:= NIF_ICON or NIF_MESSAGE or NIF_TIP;
  ta.uCallbackMessage:= CM_ICONMESSAGE;
  ta.hIcon:= SmallIcon;
  strcopy(ta.szTip, 'Left-click - shutdown'#13#10+
                    'Right-click - reboot');
  Added:= AData.AddTrayIcon(@ta)<>0;
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure DoneModule; stdcall;
begin
  if Added then
    AData.RemoveTrayIcon(@ta);
  Added:= false;
  if ChildWindow<>0 then
  begin
    DestroyWindow(ChildWindow);
    ChildWindow:=0;
  end;
  UnregisterClass(szName, hInstance);
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
function GetPluginInfo:PPluginInfo;stdcall;
begin
  PluginInfo.cbSize:= SizeOf(TPluginInfo);
  PluginInfo.szName:= szName;
  PluginInfo.szDescription:= szhelp;
  PluginInfo.szSection:= szName;
  PluginInfo.nKeyCount:= KeyCount;
  PluginInfo.Keys:= @Keys;
  result:= @PluginInfo;
end;
{---------------------------------------------------------------------}
exports
  InitGlobalModule,
  DoneModule,
  GetPluginInfo;
end.
