library TaskChld;

uses
  Windows,
  Messages,
  FNxxx in '..\..\SDK\FNxxx.pas',
  AstonSDK in '..\..\SDK\AstonSDK.pas',
  st_api in '..\..\SDK\st_api.pas';


{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\..\plg.pas}
{$ENDIF}

{$IMAGEBASE $00400000}

const
  szName:PChar = 'Aston Plugin Sample';
var
  AData: TAstonData;
  ChildWindow:hWnd=0;
{----------------------------------------------------------------}
{----------------------------------------------------------------}
function WindowProc(Window: HWnd; Message:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
var
  DC: hDC;
  ps: TPaintStruct;
  r:TRect;
begin
  result := 0;
  case Message of
    WM_PAINT:
    begin
      DC:=BeginPaint(Window, ps);
      GetClientRect(Window, r);
      DrawEdge(DC, r, BDR_SUNKENOUTER, BF_RECT or BF_MIDDLE);
      EndPaint(Window, ps);
      exit;
    end;
  end;
  result := DefWindowProc(Window, Message, WParam, LParam);
end;

{----------------------------------------------------------------}
procedure ReadConfig;
{var
 CFG:TCFG;}
begin
{ OpenCFGr(AData.PluginsCFG, @CFG);
 CloseCFGr(@CFG);}
end;

{----------------------------------------------------------------}

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  WindowClass:TWndClass;
  DockInfo: TDockInfo;
begin
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));

  RtlZeroMemory(@WindowClass, sizeOf(TWndClass));
  WindowClass.style:=CS_HREDRAW or CS_VREDRAW;
  WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
  WindowClass.hbrBackground:=COLOR_BTNFACE+1;
  WindowClass.hInstance := HInstance;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.lpszClassName:= szName;
  if RegisterClass(WindowClass) = 0 then exit;


  ReadConfig;

  ChildWindow:= CreateWindowEx(0,
    szName,
    nil,
    WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_CLIPCHILDREN,
    0, 0,
    0, 0,
    AData.TaskBar,
    0,
    hInstance,
    nil);

  AData.Node.Wnd:= ChildWindow;

  with DockInfo do
  begin
    Wnd:=ChildWindow;
    Parent:= AData.Taskbar;
    SetRect(rc_Client, 0,0, 32, AData.Ring1.ButtonHeight);
    Align:= 1;
    Vert:=false;
    Flat:=false;
    Priority:=1;
  end;
  SendMessage(AData.MainWindow, CM_DOCK, 0, longint(@DockInfo));
end;

{----------------------------------------------------------------}

procedure DoneModule; stdcall;
begin
  if ChildWindow<>0 then
  begin
    DestroyWindow(ChildWindow);
    ChildWindow:=0;
  end;
  UnregisterClass(szName, hInstance);
end;

{----------------------------------------------------------------}

exports
  InitGlobalModule,
  DoneModule;
end.
