library ToolWnd;

{$IFDEF Debug}
{$E .tbp}
{$ELSE}
{$I ..\..\tbp.pas}
{$ENDIF}

{$IMAGEBASE $00400000}

uses
  Windows,
  Messages,
  ShellAPI,
  FNxxx in '..\..\SDK\FNxxx.pas',
  AstonSDK in '..\..\SDK\AstonSDK.pas',
  st_api in '..\..\SDK\st_api.pas',
  ComCon in '..\..\SDK\ComCon.pas';

var
  hSDKWnd:hWnd = 0;
  AData:TToolData;
var
  ti:TTOOLINFO;
  szName: PChar = 'Aston Toolbar Plugin';
  ClientRect:TRect;
  SizeX, SizeY: integer;

function WndProcSDK(Window: HWnd; Message:UINT; wParam: WParam; lParam: LParam): Longint;  stdcall;
var
  ps:TPAINTSTRUCT;
  dc:hDC;
  i:integer;
  p:TPoint;
begin
  if not AData.HideFlag^ then{auto-hide}
    NotifyTip(AData.ToolTip, Window, message, wParam, lParam);
  result:=0;

  case Message of
  WM_MBUTTONUP:
  begin
    PostMessage(AData.MainWindow, CM_POPUPMAINMENU, 0, 0);
    exit;
  end;
  WM_PAINT:
  begin
    DC:=BeginPaint(Window, ps);
    with AData do
    if Pressed^=Position then
    begin
     DrawEdge(DC, ClientRect, BDR_SUNKENOUTER, BF_RECT or BF_MIDDLE);
    end
      else
    if Focus^=Position then
    begin
     DrawEdge(DC, ClientRect, BDR_RAISEDINNER, BF_RECT or BF_MIDDLE);
    end
      else
    begin
     DrawEdge(DC, ClientRect, BDR_RAISEDINNER, BF_RECT or BF_FLAT or BF_MIDDLE);
    end;
    EndPaint(Window, ps);
    exit;
  end;
  WM_MOUSEMOVE:
  with AData do
  if Focus^<>Position then
  begin
   SendMessage(AData.ToolContainer[AData.iID], CM_TOOLPLUGINMOUSEMOVE, 0, 0);
   InvalidateRect(Window, nil, false);
   UpdateWindow(Window);
   exit;
  end;
  CM_PLUGINMOUSELEAVE:
  begin
   InvalidateRect(Window, nil, false);
   UpdateWindow(Window);
   exit;
  end;
  WM_LBUTTONDOWN:
  begin
     SetCapture(Window);
     with AData do
      Pressed^:=Position;
     InvalidateRect(Window, nil, false);
     exit;
  end;

  WM_LBUTTONUP:with AData do
  begin
     ReleaseCapture;
     i:=Pressed^;
     if i<0 then exit;
     Pressed^:=-1;
     InvalidateRect(Window, nil, false);

     {--fake-----------------------}
     p.x:=LOWORD(lParam);
     p.y:=HIWORD(lParam);
     if PtInRect(ClientRect, p) then
     begin
       SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);
       MessageBox(0, 'Hello!', szName, MB_OK or MB_TOPMOST or MB_ICONINFORMATION);
       SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);
     end;
     {------------------------------}
     exit;
  end;
  WM_NOTIFY:
  begin
   case PNMHDR(lParam).code of
    TTN_SHOW:
    begin
     result:= longint(SetWindowPos(PNMHDR(lParam).hwndFrom, HWND_TOPMOST, 0,0,0,0, SWP_NOSIZE or
      SWP_NOMOVE or SWP_NOACTIVATE));
    end;
   end;
   exit;
  end;
 end;
 result:=DefWindowProc(Window, Message, wParam, lParam);
end;
{----------------------------------------------------------------}
procedure InitToolbarModule(ad:PToolData);stdcall;
var
  WindowClass: TWndClass;
begin

  RtlZeroMemory(@WindowClass, sizeof(TWNDCLASS));
  WindowClass.hInstance := hInstance;
  WindowClass.lpfnWndProc := @WndProcSDK;
  WindowClass.hCursor := LoadCursor(0, idc_Arrow);
  WindowClass.lpszClassName := szName;
  if RegisterClass(WindowClass)=0 then
  begin
   exit;
  end;

  RtlMoveMemory(@AData, ad, SizeOf(TToolData));
  SizeX:=AData.Ring1.ToolSizeX[AData.iID];
  SizeY:=AData.Ring1.ToolSizeY[AData.iID];

  with AData do
  begin
   hSDKWnd := CreateWindowEx(
		    0,
		    szName,
		    nil,
		    WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS
                     or WS_CLIPCHILDREN,
		    0,AData.Position*SizeY,
		    SizeX,SizeY,
		    AData.ToolContainer[AData.iID],
		    0,
                    hInstance,
		    nil);
   if hSDKWnd = 0 then exit;     
   Node.Wnd:=hSDKWnd;
   Node.NodeType:= Node.NodeType or NODE_FLAT;
  end;
  GetClientRect(hSDKWnd, ClientRect);

  ti.cbSize:= SizeOf(TTOOLINFO);
  ti.uFlags:= TTF_CENTERTIP;
  ti.hwnd:= hSDKWnd;
  ti.uId:= 1;
  ti.Rect:=ClientRect;
  InflateRect(ti.Rect, -1, -1);
  ti.hInst:= hInstance;
  ti.lpszText:= szName;
  SendMessage(AData.ToolTip, TTM_ADDTOOL, 0,
              LPARAM(@ti));
end;
{----------------------------------------------------------------}
procedure DoneModule;stdcall;
begin
  if hSDKWnd<>0 then
  begin
    SendMessage(AData.ToolTip, TTM_DELTOOL, 0, LPARAM(@ti));
    DestroyWindow(hSDKWnd);
    hSDKWnd:= 0;
  end;
  UnregisterClass(szName, hInstance);{do not remove}
end;

exports
  InitToolbarModule,
  DoneModule;
end.
