library InVis;


uses
  Windows,
  Messages,
  ShellAPI,
  FNxxx in '..\..\SDK\FNxxx.pas',
  AstonSDK in '..\..\SDK\AstonSDK.pas',
  st_api in '..\..\SDK\st_api.pas';


{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\..\plg.pas}
{$ENDIF}

{$IMAGEBASE $00400000}

{--icon---------------------------------------------------------------}
{$r b3.res}
{---------------------------------------------------------------------}
const
  szName:PChar = 'Aston Plugin Sample';
  szHello:PChar = 'Hello!';
  CM_ICONMESSAGE = WM_USER+1;
var
  AData: TAstonData;
  ChildWindow:hWnd=0;
  SmallIcon:hIcon;
  ta:TNOTIFYICONDATA;
  Added:boolean=false;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure ShowMenu;
var
  Menu:hMenu;
  TP:TTPMPARAMS;
  p:TPoint;
begin
  Menu:= CreatePopupMenu;
  AppendMenu(Menu, MF_STRING, 100, szHello);

  SetForeWndFix(AData.TaskBar, AData.osver);
  SetFocus(ChildWindow);

  TP.cbSize:= SizeOf(TTPMPARAMS);
  GetWindowRect(AData.TaskBar, TP.rcExclude);
  GetCursorPos(p);
  TrackPopupMenuEx(Menu, TPM_RIGHTBUTTON,
      p.x,p.y, ChildWindow, @TP);
  DestroyMenu(Menu);
  PostMessage(ChildWindow, WM_NULL, 0, 0);
end;

{---------------------------------------------------------------------}
function WindowProc(Window: HWnd; Message:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
begin
  result := 0;
  case Message of
    CM_ICONMESSAGE:
    begin
      if (lParam = WM_LBUTTONDOWN)or (lParam = WM_RBUTTONDOWN) then
        ShowMenu;
    end;
    WM_COMMAND:
    begin
      case LoWord(wParam) of
        100:
        begin
          SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);{avoid AV}
          MessageBox(0, szHello, szName, MB_OK or MB_TOPMOST or MB_ICONINFORMATION);
          SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);
        end;
      end;
      exit;
    end;
  end;
  result := DefWindowProc(Window, Message, WParam, LParam);
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure ReadConfig;
{var
 CFG:TCFG;}
begin
{ OpenCFGr(AData.PluginsCFG, @CFG);
 CloseCFGr(@CFG);}
end;


{---------------------------------------------------------------------}
procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  WindowClass:TWndClass;
begin
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));

  RtlZeroMemory(@WindowClass, sizeOf(TWndClass));
  WindowClass.style:=CS_HREDRAW or CS_VREDRAW;
  WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
  WindowClass.hbrBackground:=COLOR_BTNFACE+1;
  WindowClass.hInstance := HInstance;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.lpszClassName:= szName;
  if RegisterClass(WindowClass) = 0 then exit;


  ReadConfig;

  ChildWindow:= CreateWindowEx(0,
    szName,
    nil,
    WS_CHILD,
    0, 0,
    0, 0,
    AData.TaskBar,
    0,
    hInstance,
    nil);

  AData.Node.Wnd:=ChildWindow;

  SmallIcon:= LoadImage(hInstance, PChar(1), IMAGE_ICON, 16, 16, 0);

  ta.cbSize:= SizeOf(TNOTIFYICONDATA);
  ta.Wnd:= ChildWindow;
  ta.uID:= 1;

  ta.uFlags:=NIF_ICON or NIF_MESSAGE or NIF_TIP;
  ta.uCallbackMessage:= CM_ICONMESSAGE;
  ta.hIcon:=SmallIcon;
  lstrcpy(ta.szTip, szHello);
  Added:= AData.AddTrayIcon(@ta)<>0;
end;

{---------------------------------------------------------------------}
procedure DoneModule; stdcall;
begin
  if Added then
    AData.RemoveTrayIcon(@ta);
  Added:= false;
  if ChildWindow<>0 then
  begin
    DestroyWindow(ChildWindow);
    ChildWindow:=0;
  end;
  if SmallIcon<>0 then
    DestroyIcon(SmallIcon);
  SmallIcon:=0;
  UnregisterClass(szName, hInstance);
end;

{---------------------------------------------------------------------}
exports
  InitGlobalModule,
  DoneModule;
end.
