unit AstonEx;
interface
uses
  Windows,
  AstonSDK,
  Messages;

(*
Aston 1.9.2 SDK
(c) Gladiatros Software, 1999-2006
*)

const
  AstonExDll = 'AstonEx.dll';
  LAYER_DEFAULT           = 0;
  LAYER_NOANIMATION       = 1;
  LAYER_TRANSPARENT       = 2;
  LAYER_DRAG              = 4;
  LAYER_DRAGITEM          = 8;
  LAYER_NOBOUNDRECT       = 16;
  LAYER_DRAWWALLPAPER     = 32;
  LAYER_LAYERED           = 64;
  LAYER_3PIC_STRETCH      = 128;
  ZIP_OK = 0;
  
  AWS_LAYERED            = 1;
  AWS_DRAWWALLPAPER      = 2;
  AWS_NOAUTORESIZE       = 4;
  AWS_FADESTYLE          = 8;
  AWS_LOCKPOS            = 16;
  AWS_HIDEONMOUSEMOVE    = 32;
  AWS_GHOSTMODE          = 64;

  SCROLL_HOR             = 4;
  SCROLL_VERT            = 8;


type

Tpaint = record
   dc:HDC;
   bits: pointer;                    
   size:Tsize;
   index:integer;
end;
Ppaint = ^Tpaint;


AstonWND = interface
    function wnd():HWND;stdcall;
    function GetVer():UINT;stdcall;	
    procedure Show(ShowFlag:integer);stdcall;
    procedure RedRaw();stdcall;
    procedure SetFixedSize(w,h:integer);stdcall;
    procedure MoveWindow(x,y:integer);stdcall;
    function  SetBG(pic:PChar):integer;stdcall;
    procedure SetANKState(index,newstate:integer);stdcall;
    function  AddLayer(index, x, y:integer; pic_path:PChar; flag, trans:integer):integer;stdcall;
    function  RemoveLayer(index:integer):bool;stdcall;
    function  CreateCustomLayer(index, x, y, w, h, flag, trans:integer):integer;stdcall;
    function  SetANKFrame(index, newframe:integer):bool;stdcall;
    function  SetLayerFlag(index, flag:integer):bool;stdcall;
    function  GetLayerFlag(index:integer):integer;stdcall;
    function  LayerPaint_Begin(index:integer):Ppaint;stdcall;
    procedure LayerPaint_End(ps:Ppaint);stdcall;
    procedure DrawText(dc:HDC; text:PCHAR; r:PRECT; font:HFONT; flag:DWORD;fontColor:COLORREF; shadow:bool;shadow_color: COLORREF);stdcall;
    procedure DrawTextOnLayer(index:integer; text:PCHAR; r:PRECT; font:HFONT; flag:DWORD;fontColor:COLORREF; shadow:bool;shadow_color: COLORREF);stdcall;
    function CreateChildWnd(dwExStyle:DWORD; lpClassName,lpWindowName:Pchar;
                            dwStyle:DWORD;x, y, nWidth,nHeight:integer;
                            hMenu:HMENU;hInstance:Cardinal;lpParam:pointer):HWND;stdcall;
    function  GetLayerRect(index:integer; rect:PRECT):bool;stdcall;
    function  SetLayerRect(index:integer; rect:PRECT):bool;stdcall;
    procedure Free();stdcall;
    function  AddLayerPic(index, x, y:integer; pic:PPicture; flag:integer):integer;stdcall;
    function  AddLayerPic3(index, x, y:integer; pic1, pic2, pic3:PPicture; flag:integer):integer;stdcall;
    procedure MoveLayer(index, x, y:integer; NoSend:boolean);stdcall;
    procedure AddHintOnLayer(index:integer; Hint:PCHAR);stdcall;
    function  AddLayer3Pic(index, x, y, w, h:integer; path_3pic:Pchar; flag, transparency:integer):integer;stdcall;
    function  GetLayerPic(index:integer):PPicture;stdcall;
    function  LayerOnPoint(index:integer; p:TPOINT):bool;stdcall;
    procedure SetUserData(dwNewLong:longint);stdcall;
    function  GetUserData():longint;stdcall;
    procedure SetDebugMode(flag:bool);stdcall;
    function  MakeScrollBar(scrollbar, slider, min, max, pos, flag:integer):bool;stdcall;
    function  GetScrollBar(scrollbar:integer; var min, max, pos:integer):bool;stdcall;
    function  SetScrollBar(scrollbar, min, max, pos, flag:integer):bool;stdcall;
end;

function CreateAstonWND(x, y:integer; parent:HWND; zorder:integer; flag:integer;proc:POINTER; desktop:HWND; transparent:integer):pointer; cdecl; external AstonExDll name 'CreateAstonWND';
procedure ADrawText(dc:HDC; text:PCHAR; r:PRECT; font:HFONT; flag:DWORD;fontColor:COLORREF; shadow:bool;shadow_color: COLORREF);cdecl; external AstonExDll name 'ADrawText';
procedure CalcTextRect(text:PChar;  r:Prect; font:HFONT; flag:DWORD; shadow:BOOL); cdecl; external AstonExDll name 'CalcTextRect';
function DrawWnd(dc:HDC; wnd:HWND; size:integer):TSmallPoint;cdecl; external AstonExDll name 'DrawWnd';
implementation

end.
 