unit AstonSDK;

(*
Aston 1.9.2 SDK
(c) Gladiatros Software, 1999-2006
*)

interface

uses
  Windows,
  ShellAPI;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
const
  PICTURE_ICO          = 1;
  PICTURE_BMP          = 2;
{ PICTURE_ANI          = 3;}
  PICTURE_SYSIMAGELIST = 4;
  PICTURE_BMP_W_O_MASK = 5;
  PICTURE_ANI_FIX      = 6;
  PICTURE_ANK          = 7;
  PICTURE_BMP_ALPHA    = 8;
  PICTURE_3PIC         = 9;

  PICTURE_CORRUPT      = -1;
  PICTURE_INTERNAL     = $ff;
{-1.9.2--------------------------------------------------------------------}
sz3PicLeft : Pchar = 'Left';
sz3PicStretch : Pchar = 'Stretch';
sz3PicTiled : Pchar = 'Tiled';
sz3PicRight : Pchar = 'Right';
sz3PicGlassLeft : Pchar = 'Glass-Left';
sz3PicGlassRight : Pchar = 'Glass-Right';
sz3PicGlassTiled : Pchar = 'Glass-Tiled';

SEE_MASK_HMONITOR   = $00200000;
szAutoHideTrayIcons:Pchar = 'AutoHideTrayIcons';

szAutoHideDelay:Pchar = 'AutoHideDelay';
szXPprev:Pchar = 'XPprev';

{---------------------------------------------------------------------}
type
  TwoBitmaps = record
    Handle, Mask: hBitmap;
  end;
  PBitmapArray = ^TBitmapArray;
  TBitmapArray = array [0..9999] of TwoBitmaps;
  PFramesArray = ^TFramesArray;
  TFramesArray = array [0..9999] of integer;

  PAnima = ^TAnima;
  TAnima = record
    aBitmaps: PBitmapArray;
    aBitmapCount:integer;
    aFrames:PFramesArray;
  end;
{---------------------------------------------------------------------}
  PAnima2 = ^TAnima2;
  TAnima2 = record
    pAnim: PAnima;
    aShared, pAnimShared: bool;

    BMPframes: integer;
    Frames:PFramesArray;
    FrameCount: integer;
    Interval: integer;
    Loop: integer;
    Sound, FileName: Pchar;
    ALPHAbits: PBYTE;
    ALPHAwidth, ALPHAheight: integer;

//    _Hint: Pchar;
//    _textrc: TRect;
  end;
{---------------------------------------------------------------------}
const
  MAX_ANK = 4;
  MAX_3PIC = 7;
  MAX_MONITORS = 11;
type
  PAnk = ^TAnk;
  TAnk = record
    anks: array[0..MAX_ANK-1] of TAnima2;
    dwRes: DWORD;
  end;
{---------------------------------------------------------------------}
  PPicture=^TPicture;
  TPicture=record
    IconType:integer;
    Handle, Mask:HGDIOBJ;
    Width, Height:integer;
    CurrentFrame, Frames: integer;{ani}
    FileName:PChar;
    DefFileName:PChar;
    IconIndex:WORD;
    Options:UINT;
    Shared:BOOL;
    dwReserved:DWORD;
  end;
{---------------------------------------------------------------------}
  P3Pic=^T3Pic;
  T3Pic=record
    pic:array[0..MAX_3PIC-1]of TPicture;
  end;
{---------------------------------------------------------------------}
  PFont = ^TFont;
  TFont = packed record
    fFaceName: array[0..LF_FACESIZE - 1] of Char;
    Size:integer;
    Options: UINT;{bold-italic-underline = 111h}
    Charset:integer;{wvsprintf(p, ',%i,%03x,%i', @Font.Size)}
    Shared:BOOL;
    Handle:hFont;
    dwReserved:DWORD;
  end;
{---------------------------------------------------------------------}
// Arial,9,100,1,FF00FF,1,000000
  PFontEx = ^TFontEx;
  TFontEx = packed record
    fFaceName: array[0..LF_FACESIZE - 1] of Char;
    Size:integer;
    Options: UINT;{bold-italic-underline = 111h}
    Charset:integer;{wvsprintf(p, ',%i,%03x,%i', @Font.Size)}
    Shared:BOOL;
    Handle:hFont;
    Color:COLORREF;
    Shadow:bool;
    ShadowColor:COLORREF;
    dwReserved1:DWORD;
    dwReserved2:DWORD;
    dwReserved3:DWORD;
  end;

{---------------------------------------------------------------------}
  PNode = ^TNode;
  TNode=record
    NodeType:UINT;
    Glyph,
    HilitedGlyph,
    ClickedGlyph:TPicture;
    Path, WorkDir:PChar;
    Param:PChar;
    nCmdShow:integer;
    Hint:PChar;
    Modify, Key: byte;{hotkey}
    X,Y:integer;
    textr:TRect;
    Instance:Hinst;
    Wnd:HWND;
    dwReserved:DWORD;
  end;

  PNodeList = ^TNodeList;
  TNodeList = array[1..9999] of TNode;
{---------------------------------------------------------------------}
  PCFG = ^TCFG;
  TCFG = record
    FileHandle: THandle;
    FileMapping:THandle;
    Text:PChar; {not sz!!!!! do not use lstr*( functions}
    TextGrow: integer; {+}
    FileSize: DWORD; {  == sizeof(Text)}

    Section, Pos1, Pos2:PChar;{not szChar}
    Modified:integer;{0 - based}
  end;{config file}

{---------------------------------------------------------------------}
const
  szStates:array[0..MAX_ANK-1] of Pchar = (
    'NORMAL',
    'MOUSEOVER',
    'MOUSELEAVE',
    'CLICK');

  szInterval:Pchar = 'INTERVAL';
  szLoop:Pchar = 'LOOP';
  szCount:Pchar = 'COUNT';//for bmp only
  szSlide:Pchar = 'FRAMES';
  szFile:Pchar = 'FILE';
  szTextrc:Pchar = 'TEXTRC';

  ANK_NORMAL = 0;
  ANK_OVER = 1;
  ANK_LEAVE = 2;
  ANK_CLICK = 3;
  ANK_OVERLEAVE = 4;
  ANK_LEAVEOVER = 5;
  ANK_STOP = 6;
//  ANK_UP = 4;
{---------------------------------------------------------------------}
type
  PDockInfo = ^TDockInfo;
  TDockInfo = record
    Wnd,
    Parent: HWND;
    rc_Client: TRect;
    Align: integer;
    Vert:bool;
    Flat:bool;{reserved}
    Priority: integer;
  end;

  PDock = ^TDock;
  TDock = array[1..999] of TDockInfo;

  TWallInfo = record
  path:PChar;
  Style:integer;
  end;

  PRing1 = ^TRing1;
  TRing1 = record
    cbsize: integer; {ver}
{-[aston]-----------------------------------------}
    ToolSlideShow_:bool;
    ToolDelay:integer;
    PopupDelay: integer;
    ShowToolHints:bool;
    AutoRun: bool;
    AudioRun: bool;
    AlwaysOnTop_: bool;
    ProcessStartUp, ProcessINI:bool;
    RestoreWallpaper:bool;
    SlideSteps:integer;
{-[desktop]--------------------------------------}
    ShowDragCursor:bool;
    DragSens:integer;
    IconColor,
    HiliteColor,
    FocusColor:integer;
    TransparentIconText,
    DblClk,
    HTMLStyle:bool;
    Wallpaper:array[0..MAX_PATH] of char;
    DesktopFont: TFont;
{---[taskbar]------------------------------------}
    BarSlideShow:bool;

    BarTextColor,
    BarColor, 
    ActiveTextColor,
    InactiveTextColor,
    MinTextColor:TColorRef;
    BarSize:integer;
    TaskbarPos:integer;{0-left, 1-top, 2-right, 3-bottom}
    BarAutoHide:bool;
    BarSkin:array[0..3] of TPicture;
    SysIcon:bool;
    ButtonHeight: integer;
    ActiveFont, InactiveFont, MinFont: TFont;
    TaskOptions:UINT;
    TaskBarShowDelay:integer;
    TaskBarSlideSteps:integer;

    szBarTip: array[0..MAX_PATH] of char;
    StartBmp:TPicture;
{---[systray]------------------------------------}
    MinToTray: bool;{not used :-(}
    TrayBkColor:TColorRef;
    TrayIconSize:integer;
    TrayPos: integer;
{---[hotkey]----------------------}
    HotKey: PNodeList;
    HotCount:integer;
    HotMax: integer;
{-----[plugins]---------------------------}
    Modules:PNodeList;
    ModCount, ModMax: integer;
{--[icons]--------------------------------------------------}
    DesktopIcons:PNodeList;
    IconMax,
    IconCount:integer;
{--[toolbars]-------------------------------------------------}
    ToolSizeX, ToolSizeY:array[0..1] of integer;
    ToolCaption:array[0..1] of integer;{0-no caption, 1-caption, 2-only caption}
    AfterBmp:array[0..1] of TPicture;
    ZYOffset,
    ZXOffset,
    YYOffset,
    YXOffset,
    XYOffset,
    XXOffset:array[0..1] of integer;
    ToolAutoHide:array[0..1] of bool;
    ToolYPos:array[0..1] of integer;
    ResizeDesktop:array[0..1] of bool;
    PushOffset:array[0..1] of integer;
{-----[really wharf]----------------------------------------------}
    Tools:array[0..1] of PNodeList;
    ToolCount:array[0..1] of integer;
    ToolMax:array[0..1] of integer;
{----------------------------------}
    MainMenu:PNodeList;
    MenuCount:integer;
    MenuMax:integer;
{----[litestep emul]---------------------}
    lm78Unit,
    lm78MaxCpu,
    lm78MaxMb,
    lm78Cpu,
    vwmVelocity,
    vwmDistance,
    usClock,
    vwmNoGathering,
    vwmNoAuto:integer;
    pixmapDir,
    defaultBmp:array[0..MAX_PATH] of char;
    vwmBackColor,
    vwmSelBackColor,
    vwmForeColor,
    vwmBorderColor:integer;
    lsPath:array[0..MAX_PATH] of char;
    lsapi:bool;
{----[???]-----------------------------}
    TopDesktop:bool;
    ContextMenuOpt:UINT;

{-----[Env]------------------------------}
    Environment: PNodeList;
    EnvCount,
    EnvMax:integer;
{-----------------------}
    TraySkin:TPicture;
    TraySkinAlign:integer;
{----------------------------------------}
{ver 1.3}
    TaskbarSkinAlign:integer;
    WarnOnStartup:bool;
    IgnoreShape: bool;
{ver 1.4}
    DisableToolbar: array[0..1] of bool;
{ver 1.5}
    StartBmpH, StartBmpP: TPicture;
    LoadObj, HideTrayIcons: bool;
    ShadowColor: TColorRef;
    EnableShadows: bool;
{ver 1.6}
    ToolTrans: array[0..1] of integer;
    TaskTrans: integer;
    XPLngIcon: bool;
{ver 1.7}
    XPStyleTray:PNodeList;
    XPSTCount:integer;
    XPSTMax:integer;
    XPLButton:boolean;
{ver 1.8}
    TopSkinBmp:array[0..1] of TPicture;
    ToolSlideShow2:array[0..1] of bool;
    AlwaysOnTop2:array[0..1] of bool;
    bLockTaskbar: bool;
    TipFont: TFont;
{1.8.2}
    SetShell: integer;
    DontSeparateIE: bool;
    DontSeparateE: bool;
    DontProcessStartReg: bool;
{1.9.0}
    bUseXPShadows: bool;
    nAlphaBlitNT,
      nAlphaBlit9x: integer;
    bUseMmKbdDll: bool;
{1.9.1}
   TrayIcon:TPicture;
   TrayIconHide:TPicture;
{1.9.2}
    DisableTransparency:bool;
    TaskBarIconOffset:integer;
    Wallpapers:array[1..MAX_MONITORS] of TWallInfo;
    AutoHideTrayIcons:bool;
    AutoHideDelay:integer;
    XPprev:integer;
  end;

{---------------------------------------------------------------------}
  PWallPaperInfo = ^TWallPaperInfo;
  TWallPaperInfo = record
    WallPaper:PPicture;
    WallpaperStyle:integer;
    TileWallpaper:integer;
    DesktopBrush: hBrush;
  end;
{---------------------------------------------------------------------}
  PToolData=^TToolData;
  TToolData=record
    cbsize: integer; 
    Node: pNode;
    Ring1: PRing1;
    osver:POSVersionInfo;

    MainPath, AstonCFG, PluginsCFG:PChar;

    MainWindow,
    Desktop, Taskbar, ToolTip,
    TrayWnd:hWnd;
    TasksWnd:hWnd;
    ToolBar:array[0..1] of hWnd;
    ToolContainer:array[0..1] of hWnd;
 
    MemoryDC:hDC;

    iID: integer;{0 - left, 1 - right}
    Position: integer;{0 - based}
    HideFlag: pbool;
    Focus, Pressed, AutoPressed: pinteger;

    WallPaperInfo:TWallPaperInfo;
    AppInstance: THandle;
  end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
  PAstonData=^TAstonData;
  TAstonData=record
    cbsize: integer; 
    Node: pNode;
    Ring1: PRing1;
    osver:POSVersionInfo;

    MainPath, AstonCFG, PluginsCFG:PChar;

    MainWindow,
    Desktop, Taskbar, ToolTip,
    TrayWnd:hWnd;
    TasksWnd:hWnd;
    ToolBar:array[0..1] of hWnd;
    ToolContainer:array[0..1] of hWnd;
 
    MemoryDC:hDC;
    BarBrush: hBrush;
    TaskBarHideFlag: pbool;

    WallPaperInfo:TWallPaperInfo;
    AppInstance: THandle;
{ver 1.5}
    AddTrayIcon:function(const pnid: pointer):longint;{any of *NOTIFYICONDATA*}
    ModifyTrayIcon:function(const pnid: pointer):longint;
    RemoveTrayIcon:function(const pnid: pointer):longint;
  end;

  InitToolModule  = procedure(ad:PToolData);stdcall;
  InitAstonModule = procedure(ad:PAstonData);stdcall;
  DoneModule      = procedure; stdcall; { :-/ }

const
  szInitToolModule:PChar  = 'InitToolbarModule';
  szInitAstonModule:PChar = 'InitGlobalModule';
  szDoneModule:PChar      = 'DoneModule';

  szMainClass = 'Aston';
  szAston:PChar = szMainClass;
  szDeskClass:PChar = 'Progman';
  szDeskClass2:PChar = 'Desktop';
  szSecondDeskClass2:PChar = 'MultiDesktop';
  szFakeDeskClass:PChar = 'Fix FullScreen'; 
  szBarClass:PChar = 'Shell_TrayWnd';
  szTrayClass:PChar = 'TrayNotifyWnd';
  szTasksClass:PChar = 'MSTaskSwWClass';


  szToolBarClass:PChar='YWindowCaption';
  szToolContainerClass:PChar='YWindow';
  szPopupClass:PChar='XWindow';
  szZClass:PChar='ZWindow';


  szDeskName:PChar = 'Program Manager';

  DefAstonRC:PChar='aston.rc';
  DefTipFileName:PChar='tips.rc';
  DefPluginsFileName:PChar='plugins.rc';
  szUsers:Pchar = 'Users\';

  DefLSRC:PChar='step.rc';

  APIdll = 'starter.dll';
  szPrintMon:PChar = 'printmon.exe Millenium';
{ szRasMon:PChar = 'rasmon.exe Millenium'; obsolete}
  szAstonExe:PChar = 'aston.exe';
  szShellSwpExe:PChar = 'shellswp.exe';
  szLomaster:PChar = 'a-master.exe';
  szWizard:PChar = 'thwizard.exe';
  szRundll32:PChar = 'rundll32.exe';
  szExploreWClass:PChar = 'ExploreWClass';
  szCabinetWClass:Pchar ='CabinetWClass';
  szExplorer:Pchar = 'explorer.exe';
  szproperties:Pchar = 'properties';
  szexplore:Pchar = 'explore';
  szWallpaperA:Pchar='Wallpaper';
  szConnectionsTray:Pchar = 'Connections Tray';
  szTaskManager: Pchar = 'TaskMgr.exe';
  szTrayIcons: Pchar = 'TrayIcons';
{---------------------------------------------------------------------}
  szPrintMonClass:PChar = 'AstonPrintMon';
{---------------------------------------------------------------------}
  NODE_TYPE                          = UINT($FF);{mask}
{ program or document}
  NODE_FILE			                     = $1;
{ run dialog}
  NODE_RUN    			                 = $2;
{ shutdown dialog}
  NODE_SHUTDOWN 		                 = $3;
{ Recycle (reload config)}
  NODE_RECYCLE 			                 = $4;
{ Toolbar plugin}
  NODE_ASTONTOOLPLUGIN 		           = $5;
{ run ScreenSaver}
  NODE_SAVER 			                   = $6;
{ show / hide Desktop}
  NODE_DESKTOP_ON_TOP 		           = $7;
{ minimize active window}
  NODE_MINIMIZE			                 = $8;
{ remove from start menu dialog}
  NODE_REMOVE_FROM_MENU		           = $9;
{ add to start menu dialog}
  NODE_ADD_TO_MENU 		               = $A;
{ call "start menu"}
  NODE_MAINMENU			                 = $B;
{ Clear Recent}
  NODE_CLEARRECENT 		               = $C;
{ desk.cpl dialog}
  NODE_SCREENPROPERTIES 	           = $D;
{ empty}
  NODE_FAKE 			                   = $E;
{ files find}
  NODE_FINDFILES 		                 = $F;
{ comp fild}
  NODE_FINDCOMP			                 = $10;
{ logoff dialog (win 98) or logoff}
  NODE_LOGOFF 			                 = $11;
{ a-master}
  NODE_MASTER 			                 = $12;
{ About}
  NODE_ABOUT 			                   = $14;
{ Ls Emul}
  NODE_LSTOOLPLUGIN 		             = $15;
{ Suspends Mode}
  NODE_SUSPENDS 			               = $16;

(*--Menu only---*)
{ PopupFolder (r=Folder)}
  NODE_MENU_FOLDER 		               = $17;
{ PopupFolder w/o sub-folders}
  NODE_MENU_FOLDER_NO_SUB 	         = $18;
{ !programs}
  NODE_MENU_PROGRAMS 		         = $19;
{ !programs (common)}
  NODE_MENU_COMMON_PROGRAMS 	       = $1A;
{ !recent}
  NODE_MENU_RECENT 		               = $1B;
{ new menu in menuex}
  NODE_MENU_MENU 		                 = $1C;
{ common only}
  NODE_MENU_COMMON_MENU 	           = $1D;
{ cascade control panel}
  NODE_MENU_CPL   		               = $1E;

{---------------------------------------------------------------------}
  NODE_FAKE_THEME                    = $1F;
{---------------------------------------------------------------------}

{menu again}
  NODE_PIDL 			                   = $20;
{cascade desktop}
  NODE_MENU_DESKTOP 		             = $21;

{ NODE_MENU_FAVORITES                = $22; not implemented yet}

(*---explore folder------------------*)
{CSIDL_PROGRAMS}
  NODE_CSIDL_PROGRAMS		             = $30;
{CSIDL_COMMON_PROGRAMS}
  NODE_CSIDL_COMMON_PROGRAMS	       = $31;
{CSIDL_STARTMENU}
  NODE_CSIDL_STARTMENU 		           = $32;
{CSIDL_COMMON_STARTMENU}
  NODE_CSIDL_COMMON_STARTMENU 	     = $33;
{CSIDL_SENDTO}
  NODE_CSIDL_SENDTO 		             = $34;
{CSIDL_RECENT}
  NODE_CSIDL_RECENT		               = $35;
{CSIDL_DESKTOPDIRECTORY}
  NODE_CSIDL_DESKTOPDIRECTORY 	     = $36;
{CSIDL_COMMON_DESKTOPDIRECTORY}
  NODE_CSIDL_COMMON_DESKTOPDIRECTORY = $37;
{CSIDL_FAVORITES}
  NODE_CSIDL_FAVORITES 	             = $38;
{CSIDL_COMMON_FAVORITES}
  NODE_CSIDL_COMMON_FAVORITES 	     = $39;
{CSIDL_PERSONAL}
  NODE_CSIDL_PERSONAL 		           = $3A;
(*--open in explorer---------------*)
{CSIDL_CONTROLS}
  NODE_CSIDL_CONTROLS 		           = $3B;
{CSIDL_PRINTERS}
  NODE_CSIDL_PRINTERS 		           = $3C;
{CSIDL_BITBUCKET}
  NODE_CSIDL_BITBUCKET 		           = $3D;
{CSIDL_DRIVES}
  NODE_CSIDL_DRIVES 		             = $3E;{my comp!!!}
{CSIDL_NETWORK}
  NODE_CSIDL_NETWORK 		             = $3F;
{CSIDL_FONTS}
  NODE_CSIDL_FONTS 		               = $40;
{CSIDL_INTERNET_CACHE}
  NODE_CSIDL_INTERNET_CACHE 	       = $41;
{CSIDL_HISTORY}
  NODE_CSIDL_HISTORY 		             = $42;
{CSIDL_INTERNET}
  NODE_CSIDL_INTERNET 		           = $43;

{ lockstation (2k) / switch user (XP)}
  NODE_LOCKWS         		           = $70;
{ show/hide tray}
  NODE_HIDETRAYICONS  		           = $71;
  NODE_SETUPTRAYICONS  		           = $72;

{quit aston}
  NODE_DEBUG_CLOSE    		           = $FF;
{---------------------------------------------------------------------}
{flags:}
  NODE_LOADMASK         = UINT($fff);

  NODE_ICONBOUNDRECT    = UINT($100);
  NODE_REAL_THEME       = UINT($200);
  NODE_LOCKED           = UINT($400);
  NODE_DISABLED         = UINT($800);

{internal}
{-plugins------------------------------------------------}
  NODE_LEVEL1           = UINT($1000);
  NODE_LEVEL2           = UINT($2000);
  NODE_LEVEL3           = UINT($4000);

{--system events----------------------------!!-----------}
  NODE_WM_DISPLAYCHANGE_REGISTER   = UINT($10000);
  NODE_WM_SETTINGCHANGE_REGISTER   = UINT($20000);
  NODE_WM_TIMECHANGE_REGISTER      = UINT($40000);
  NODE_WM_DEVICECHANGE_REGISTER    = UINT($80000);
  NODE_WM_DEVMODECHANGE_REGISTER   = UINT($100000);
  NODE_WM_SYSCOLORCHANGE_REGISTER  = UINT($200000);
  NODE_CM_SWITCHDESKTOP_REGISTER   = UINT($400000);
{------------------------}

  NODE_REGISTERMAINMENU            = UINT($1000000);
  NODE_FLAT                        = UINT($2000000);
  NODE_TOOLPOPUP                   = UINT($4000000) or NODE_FLAT;
  NODE_USERCOMMONMENU              = UINT($8000000);

{--------------------------------------------------------}
  maxbarsize = integer(24);{size of taskbar, in pixels}
  _FrameSize_ = 2;{taskbar's border}


{timers (track mouse event)}
  dElapse = UINT(70);
  dElapseNT = UINT(140);
  Elapse = UINT(160);

  RecycleTimerID = UINT($b5);
  TrayTimerID    = UINT($b4);
  TaskTimerID    = UINT($b3);
  ID_CHECKFULLSCREEN  = UINT(3);
  ID_REDRAW      = UINT(4);

  BarTimerID     = UINT($b2);
  DesktopTimerID = UINT($b1);
  ToolTimerID    = UINT($b0);


{config file}
  szShell:PChar='Shell';
  szTool:array[0..1]of PChar=('ToolLeft','ToolRight');
  szBarSize:PChar='BarSize';
  szYPos:PChar='YPos';
  szAutoHide:PChar='AutoHide';
  szCaption:PChar='Caption';
  szIcons:PChar='Icons';
  szBarPos:PChar='Taskbar';
  szDesktop:PChar='Desktop';
  szHideTray: PChar = 'HideTray';
  szTraySec:PChar = 'SysTray';
  szMainMenu:PChar = 'MainMenu';
  szX:PChar='X';
  szY:PChar='Y';
  szT:PChar='T';
  szR:PChar='R';
  szH:PChar='H';
  szS:PChar='S';
  szD:PChar='D';
  sz1:PChar='1';
  sz2:PChar='2';
  sz3:PChar='3';

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{-----messages------------------------------------------}
  WM_USERM = UINT($7FFF);
  CM_GETPLUGINMEMSIZE = WM_USERM-3;{_Send_ This Message!!! Do not Post!!!}
  CM_RESTOREPLUGINMEM = WM_USERM-1;{Do not Post!!!}
  CM_SAVEPLUGINMEM = WM_USERM-2;{Do not Post - Memory leak !!!}


  CM_PLUGINMOUSELEAVE = WM_USERM-5;

  CM_RECYCLE = WM_USERM - $C;
  CM_SCREENSETUP = WM_USERM - $D;
  CM_PRINTERS = WM_USERM - $11;

  CM_EXECUTENODE = WM_USERM - $E;{lParam = PNode;}

  CM_POPUPMAINMENU = WM_USERM - $12;{wParam = 1 - <Win> popup menu near start button,
                                              2 - show menu always, not hide}
  CM_TIMEDATESETUP = WM_USERM - $13;


{--INTERNAL!!!!----------------------}
  CM_SHELLHOOK = WM_USERM - $F;

  CM_ASTONICON = WM_USERM - $21;

{----plugins-------------------}
  CM_TOOLPLUGINPOPUP  = WM_USERM - $16;
  CM_TOOLPLUGINMOUSEMOVE  = WM_USERM - $17;

  CM_DOCK  = WM_USERM - $18;
  CM_UNDOCK  = WM_USERM - $19;
  CM_TASKBARSIZECHANGE = WM_USERM - $1A;
  CM_DOCKSIZECHANGE = WM_USERM - $1B;

  CM_ENTERMODAL = WM_USERM - $1D;
  CM_LEAVEMODAL = WM_USERM - $1E;


  CM_TOOLPLUGINHOTKEY = WM_USERM - $22;

  CM_FORCETOOLPLUGINPOPUP = WM_USERM - $23;{wParam = Position, lParam = Node.Wnd, result - succ/fail (1/0)}
  CM_FORCETOOLPLUGINHIDE = WM_USERM - $26;{wParam = Position, result - succ/fail (1/0)}
  CM_ISTOOLPLUGINACTIVE = WM_USERM - $24;

  CM_SWITCHTOTASKBAR = WM_USERM - $25;

  CM_SETUPASTON = WM_USERM - $26;{lParam - CmdParam}

  CM_WALLPAPER = WM_USERM - $27;{no parameters}
  CM_WALLPAPERSETUP = WM_USERM - $28;{no parameters}
  CM_SETPICTURE = WM_USERM - $29;{wParam = 0|PICTURE_ANI_FIX, lParam = 0 (Clear) | PPicture (PICTURE_ANI_FIX only)}

  CM_UPDATEICONS = WM_USERM - $30;
  CM_DELAYEDRECYCLE = WM_USERM - $33;
  CM_WALLPAPERSTYLE = WM_USERM - $35;//'fixfullscreen' window
  CM_SETUPTRAY = WM_USERM - $36;
  CM_HITIMER = WM_USERM - $37;
  CM_RECYCLE_PART0 = WM_USERM - $38;
  CM_RECYCLE_PART1 = WM_USERM - $39;
  CM_RECYCLE_PART2 = WM_USERM - $3a;

  CM_COINITIALIZE  = WM_USERM - $40;
  CM_GETFULLSCREEN = WM_USERM - $41;//todo: wParam = HMONITOR
  CM_SWITCHDESKTOP = WM_USERM - $42;//NT/2k/XP switch desktop event

  CM_MINIMIZE_NOTIFY = $400 + 70;//notify about minimize task for make screen shot 
{---------------------------------------------------------------------}
{---LoadImageEx options-----------------------------------------------}
  PIC_AUTODETECT = UINT(0);

  BMP_NOMASK     = UINT(1);
  PIC_NOCACHE    = UINT(2);
  BMP_USE_W_H    = UINT(4) or BMP_NOMASK;
  PIC_SHELLICON  = UINT(8) or PIC_NOCACHE;
  ICO_USE_W_H    = UINT($10);
  BMP_PALETTE    = UINT($20);
  BMP_STRETCH_HALFTONE    = UINT($40);
  ANK_PREVIEW    = UINT($80);
  PIC_NOPREALPHA = UINT($100);
{---------------------------------------------------------------------}
type
  PKey = ^TKey;{plugin setup}
  TKey = record
    szKey: PChar;
    nType: integer;
    szHint:PChar;
    vDefault: DWORD;
    res1, res2: integer;
  end;

  PKeyTable = ^TKeyTable;
  TKeyTable = array[1..999] of TKey;

  ParrayPChar = ^TarrayPChar;
  TarrayPChar = array[0..999] of PChar;

  PPluginInfo = ^TPluginInfo;
  TPluginInfo = record
    cbSize: integer;
    szName:PChar;
    szDescription:PChar;
    szSection:PChar;
    nKeyCount:UINT;
    Keys:PKeyTable;
  end;

const
  KEY_BOOL       = 1;
  KEY_INT        = 2;
  KEY_INT_RANGE  = 3;
  KEY_HEX        = 4;
  KEY_HEX_RANGE  = 5;
  KEY_COLOR      = 6;
  KEY_STRING     = 7;
  KEY_PATH       = 8;
  KEY_FOLDER     = 9;
  KEY_BOOLEAN    = 10;
  KEY_SCROLLBAR  = 11;
  KEY_FONT       = 12;
  KEY_BITMAP     = 14;
  KEY_UPDOWNCONTROL= 15;
  KEY_LIST       = 16;

{-1.8.x---------------------------------------------------------------}
  KEY_TREE       = 17;//res1 - max level
  KEY_SEPARATOR  = 18;
  KEY_CAPTION    = 19;
{---------------------------------------------------------------------}
  KEY_STATIC_ICON= 20;
  KEY_PICTURE    = 21;  
{-1.9.1---------------------------------------------------------------}
  KEY_RECT	     = 22;
  KEY_PRINT_FONT = 23;
  KEY_PIC_LIST   = 24;
{-1.9.2---------------------------------------------------------------}
  KEY_TRANSPARENCY = 25;
  KEY_TAB          = 26;
  KEY_PICTURE_EX   = 27;
  KEY_FONT_EX      = 28;
  KEY_POINT        = 29;  
{---------------------------------------------------------------------}
  KEY_MASK       = $FF;
  KEY_NOTHEME    = $100;
{---------------------------------------------------------------------}
{-menu IDs------------------------------------------------------------}
{-from explorer.exe-----------------------------------------}
  menuid_Cascade        = UINT(403);
  menuid_TileHorizontal = UINT(404);
  menuid_TileVertical   = UINT(405);

  menuid_MinimizeAll    = UINT(415);
  menuid_Undo           = UINT(416);
  menuid_TaskMgr        = 420;
{---------------------------------------------------------------------}
{--ContextMenuOpt-----------------------------------------------}
  CONTEXTMENU_NOSETUP       = UINT($1);
  CONTEXTMENU_NORECYCLE     = UINT($10);
  CONTEXTMENU_NOSCREENSETUP = UINT($100);
  CONTEXTMENU_NOWINARRANGE  = UINT($1000);
  CONTEXTMENU_NOWINMINALL   = UINT($10000);
  CONTEXTMENU_NODESKTOP     = UINT($100000);
CONTEXTMENU_NOSETUPTRAYICON = UINT($1000000);
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
  SECTION_CREATE_ALWAYS = UINT(1);
{---------------------------------------------------------------------}
  FONT_BOLD      = UINT($100);
  FONT_ITALIC    = UINT($010);
  FONT_UNDERLINE = UINT($001);
  FONT_NOCLEARTYPE = UINT($1000);
{--taskbar options-------------------------}
  TASK_MINACTIVEONCLICK  = UINT($1);
  TASK_HIDEBUTTONS       = UINT($10);
  TASK_EXPLORERLIKEHINTS = UINT($100);
  TASK_MENUNEARSTART     = UINT($1000);
  TASK_NOWINKEY          = UINT($10000);
  TASK_NOBEVEL           = UINT($100000);
  TASK_NOTOPMOST         = UINT($1000000);
{---------------------------------------------------------------------}
  double_buffer_size = 256;
{---------------------------------------------------------------------}
{DrawSkin flags}
{---------------------------------------------------------------------}
  DPEx_TILED    = UINT(1);
  DPEx_CENTERED = UINT(2);
  DPEx_CORRECTBRUSH = UINT(4);
  DPEx_STRETCHED    = UINT(8);
  DPEx_STRETCHED_RATIO = UINT(16);
  DPEx_STRETCHED_RATIO_OIB = UINT(32);
{---------------------------------------------------------------------}
  MaxRCFileSize = $2ffff;
  MaxGrow = $1fff;
{---------------------------------------------------------------------}
  szsort0:PChar = 'sort0';
  szsort1:PChar = 'sort1';
  szsort2:PChar = 'sort2';
  szsort3:PChar = 'sort3';
  szsort4:PChar = 'sort4';
{--ls emu----------------------------------------}
   magicDWord:longint= $49474541;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
type
  ICONIMAGE = packed record
    Width: UINT;
    Height: UINT;
    Colors: UINT;               { Width, Height and bpp}
    lpBits: PByte;              { ptr to DIB bits}
    dwNumBytes: DWORD;          { how many bytes?}
  end;
  PICONIMAGE = ^ICONIMAGE;

  MEMICON = record
    nNumImages: UINT;
    IconImages: array [0..Pred(1)] of ICONIMAGE;
  end;
  PMEMICON = ^MEMICON;

  TModuleEx = record
    hLibrary: THandle;
    pData: Pbyte;{win 3.11 - 16 bit only}
    size: integer;
  end;

  ICODIRENTRY = packed record
    bWidth: BYTE; { Width of the image}
    bHeight: BYTE; { Height of the image (times 2)}
    bColorCount: BYTE; { Number of colors in image (0 if >=8bpp)}
    bReserved: BYTE;
    wPlanes: WORD; { Color Planes}
    wBitCount: WORD; { Bits per pixel}
    dwBytesInRes: DWORD; { how many bytes in this resource?}
    dwImageOffset: DWORD; { where in the file is this image}
  end;
  PICODIRENTRY = ^ICODIRENTRY;{in *.ICO file}

  ICODIRENTRIES = array[0..999] of ICODIRENTRY;
  PICODIRENTRIES = ^ICODIRENTRIES;
HZIP = THANDLE;
ZIPENTRY = record
 index:integer;
 name:array[0..MAX_PATH-1]of CHAR;
 attr:DWORD;
 atime,ctime,mtime:FILETIME;
 comp_size,
 unc_size:longint;
end;
PZIPENTRY = ^ZIPENTRY;
implementation
end.
