unit ComCon;


(*
Aston 1.9.2 SDK
(c) Gladiatros Software, 1999-2006
*)


interface

uses
 Windows,
 Messages;

const
 comctl ='comctl32.dll';

type
  tagINITCOMMONCONTROLSEX = packed record
    dwSize: DWORD;             // size of this structure
    dwICC: DWORD;              // flags indicating which classes to be initialized
  end;
  PInitCommonControlsEx = ^TInitCommonControlsEx;
  TInitCommonControlsEx = tagINITCOMMONCONTROLSEX;

const
  ICC_LISTVIEW_CLASSES   = $00000001; // listview, header
  ICC_TREEVIEW_CLASSES   = $00000002; // treeview, tooltips
  ICC_BAR_CLASSES        = $00000004; // toolbar, statusbar, trackbar, tooltips
  ICC_TAB_CLASSES        = $00000008; // tab, tooltips
  ICC_UPDOWN_CLASS       = $00000010; // updown
  ICC_PROGRESS_CLASS     = $00000020; // progress
  ICC_HOTKEY_CLASS       = $00000040; // hotkey
  ICC_ANIMATE_CLASS      = $00000080; // animate
  ICC_WIN95_CLASSES      = $000000FF;
  ICC_DATE_CLASSES       = $00000100; // month picker, date picker, time picker, updown
  ICC_USEREX_CLASSES     = $00000200; // comboex
  ICC_COOL_CLASSES       = $00000400; // rebar (coolbar) control
  ICC_INTERNET_CLASSES   = $00000800;
  ICC_PAGESCROLLER_CLASS = $00001000; // page scroller
  ICC_NATIVEFNTCTL_CLASS = $00002000; // native font control

//function InitCommonControlsEx(var ICC: TInitCommonControlsEx): Bool;stdcall;
procedure InitCommonControls();

const
  TBN_FIRST                = 0-700;       { toolbar }
  TBN_LAST                 = 0-720;

  SBN_FIRST               = 0-880;       { status bar }
  SBN_LAST                = 0-899;


  TTN_FIRST                = 0-520;       { tooltips }
  TTN_LAST                 = 0-549;

{ ====== COMMON CONTROL STYLES ================ }

const
  CCS_TOP                 = $00000001;
  CCS_NOMOVEY             = $00000002;
  CCS_BOTTOM              = $00000003;
  CCS_NORESIZE            = $00000004;
  CCS_NOPARENTALIGN       = $00000008;
  CCS_ADJUSTABLE          = $00000020;
  CCS_NODIVIDER           = $00000040;
  CCS_VERT                = $00000080;
  CCS_LEFT                = (CCS_VERT or CCS_TOP);
  CCS_RIGHT               = (CCS_VERT or CCS_BOTTOM);
  CCS_NOMOVEX             = (CCS_VERT or CCS_NOMOVEY);


{ ====== TOOLTIPS CONTROL ========================== }

const
  {$EXTERNALSYM TOOLTIPS_CLASS}
  TOOLTIPS_CLASS = 'tooltips_class32';

  {$EXTERNALSYM LPSTR_TEXTCALLBACKA}
  LPSTR_TEXTCALLBACKA = LPSTR(-1);
  {$EXTERNALSYM LPSTR_TEXTCALLBACKW}
  LPSTR_TEXTCALLBACKW = LPWSTR(-1);

  {$EXTERNALSYM LPSTR_TEXTCALLBACK}
  LPSTR_TEXTCALLBACK = LPSTR_TEXTCALLBACKA;

type
  PToolInfoA = ^TToolInfoA;
  PToolInfoW = ^TToolInfoW;
  PToolInfo = PToolInfoA;
  {$EXTERNALSYM tagTOOLINFOA}
  tagTOOLINFOA = packed record
    cbSize: UINT;
    uFlags: UINT;
    hwnd: HWND;
    uId: UINT;
    Rect: TRect;
    hInst: THandle;
    lpszText: PAnsiChar;
    lParam: LPARAM;
  end;
  {$EXTERNALSYM tagTOOLINFOW}
  tagTOOLINFOW = packed record
    cbSize: UINT;
    uFlags: UINT;
    hwnd: HWND;
    uId: UINT;
    Rect: TRect;
    hInst: THandle;
    lpszText: PWideChar;
    lParam: LPARAM;
  end;
  {$EXTERNALSYM tagTOOLINFO}
  tagTOOLINFO = tagTOOLINFOA;
  TToolInfoA = tagTOOLINFOA;
  TToolInfoW = tagTOOLINFOW;
  TToolInfo = TToolInfoA;
  {$EXTERNALSYM TOOLINFOA}
  TOOLINFOA = tagTOOLINFOA;
  {$EXTERNALSYM TOOLINFOW}
  TOOLINFOW = tagTOOLINFOW;
  {$EXTERNALSYM TOOLINFO}
  TOOLINFO = TOOLINFOA;

const
  {$EXTERNALSYM TTS_ALWAYSTIP}
  TTS_ALWAYSTIP           = $01;
  {$EXTERNALSYM TTS_NOPREFIX}
  TTS_NOPREFIX            = $02;

  {$EXTERNALSYM TTF_IDISHWND}
  TTF_IDISHWND            = $0001;

  // Use this to center around trackpoint in trackmode
  // -OR- to center around tool in normal mode.
  // Use TTF_ABSOLUTE to place the tip exactly at the track coords when
  // in tracking mode.  TTF_ABSOLUTE can be used in conjunction with TTF_CENTERTIP
  // to center the tip absolutely about the track point.

  {$EXTERNALSYM TTF_CENTERTIP}
  TTF_CENTERTIP           = $0002;
  {$EXTERNALSYM TTF_RTLREADING}
  TTF_RTLREADING          = $0004;
  {$EXTERNALSYM TTF_SUBCLASS}
  TTF_SUBCLASS            = $0010;
  {$EXTERNALSYM TTF_TRACK}
  TTF_TRACK               = $0020;
  {$EXTERNALSYM TTF_ABSOLUTE}
  TTF_ABSOLUTE            = $0080;
  {$EXTERNALSYM TTF_TRANSPARENT}
  TTF_TRANSPARENT         = $0100;
  {$EXTERNALSYM TTF_DI_SETITEM}
  TTF_DI_SETITEM          = $8000;       // valid only on the TTN_NEEDTEXT callback

  {$EXTERNALSYM TTDT_AUTOMATIC}
  TTDT_AUTOMATIC          = 0;
  {$EXTERNALSYM TTDT_RESHOW}
  TTDT_RESHOW             = 1;
  {$EXTERNALSYM TTDT_AUTOPOP}
  TTDT_AUTOPOP            = 2;
  {$EXTERNALSYM TTDT_INITIAL}
  TTDT_INITIAL            = 3;

  {$EXTERNALSYM TTM_ACTIVATE}
  TTM_ACTIVATE            = WM_USER + 1;
  {$EXTERNALSYM TTM_SETDELAYTIME}
  TTM_SETDELAYTIME        = WM_USER + 3;

  {$EXTERNALSYM TTM_ADDTOOLA}
  TTM_ADDTOOLA             = WM_USER + 4;
  {$EXTERNALSYM TTM_DELTOOLA}
  TTM_DELTOOLA             = WM_USER + 5;
  {$EXTERNALSYM TTM_NEWTOOLRECTA}
  TTM_NEWTOOLRECTA         = WM_USER + 6;
  {$EXTERNALSYM TTM_GETTOOLINFOA}
  TTM_GETTOOLINFOA         = WM_USER + 8;
  {$EXTERNALSYM TTM_SETTOOLINFOA}
  TTM_SETTOOLINFOA         = WM_USER + 9;
  {$EXTERNALSYM TTM_HITTESTA}
  TTM_HITTESTA             = WM_USER + 10;
  {$EXTERNALSYM TTM_GETTEXTA}
  TTM_GETTEXTA             = WM_USER + 11;
  {$EXTERNALSYM TTM_UPDATETIPTEXTA}
  TTM_UPDATETIPTEXTA       = WM_USER + 12;
  {$EXTERNALSYM TTM_ENUMTOOLSA}
  TTM_ENUMTOOLSA           = WM_USER + 14;
  {$EXTERNALSYM TTM_GETCURRENTTOOLA}
  TTM_GETCURRENTTOOLA      = WM_USER + 15;

  {$EXTERNALSYM TTM_ADDTOOLW}
  TTM_ADDTOOLW             = WM_USER + 50;
  {$EXTERNALSYM TTM_DELTOOLW}
  TTM_DELTOOLW             = WM_USER + 51;
  {$EXTERNALSYM TTM_NEWTOOLRECTW}
  TTM_NEWTOOLRECTW         = WM_USER + 52;
  {$EXTERNALSYM TTM_GETTOOLINFOW}
  TTM_GETTOOLINFOW         = WM_USER + 53;
  {$EXTERNALSYM TTM_SETTOOLINFOW}
  TTM_SETTOOLINFOW         = WM_USER + 54;
  {$EXTERNALSYM TTM_HITTESTW}
  TTM_HITTESTW             = WM_USER + 55;
  {$EXTERNALSYM TTM_GETTEXTW}
  TTM_GETTEXTW             = WM_USER + 56;
  {$EXTERNALSYM TTM_UPDATETIPTEXTW}
  TTM_UPDATETIPTEXTW       = WM_USER + 57;
  {$EXTERNALSYM TTM_ENUMTOOLSW}
  TTM_ENUMTOOLSW           = WM_USER + 58;
  {$EXTERNALSYM TTM_GETCURRENTTOOLW}
  TTM_GETCURRENTTOOLW      = WM_USER + 59;
  {$EXTERNALSYM TTM_WINDOWFROMPOINT}
  TTM_WINDOWFROMPOINT      = WM_USER + 16;
  {$EXTERNALSYM TTM_TRACKACTIVATE}
  TTM_TRACKACTIVATE        = WM_USER + 17;  // wParam = TRUE/FALSE start end  lparam = LPTOOLINFO
  {$EXTERNALSYM TTM_TRACKPOSITION}
  TTM_TRACKPOSITION        = WM_USER + 18;  // lParam = dwPos
  {$EXTERNALSYM TTM_SETTIPBKCOLOR}
  TTM_SETTIPBKCOLOR        = WM_USER + 19;
  {$EXTERNALSYM TTM_SETTIPTEXTCOLOR}
  TTM_SETTIPTEXTCOLOR      = WM_USER + 20;
  {$EXTERNALSYM TTM_GETDELAYTIME}
  TTM_GETDELAYTIME         = WM_USER + 21;
  {$EXTERNALSYM TTM_GETTIPBKCOLOR}
  TTM_GETTIPBKCOLOR        = WM_USER + 22;
  {$EXTERNALSYM TTM_GETTIPTEXTCOLOR}
  TTM_GETTIPTEXTCOLOR      = WM_USER + 23;
  {$EXTERNALSYM TTM_SETMAXTIPWIDTH}
  TTM_SETMAXTIPWIDTH       = WM_USER + 24;
  {$EXTERNALSYM TTM_GETMAXTIPWIDTH}
  TTM_GETMAXTIPWIDTH       = WM_USER + 25;
  {$EXTERNALSYM TTM_SETMARGIN}
  TTM_SETMARGIN            = WM_USER + 26;  // lParam = lprc
  {$EXTERNALSYM TTM_GETMARGIN}
  TTM_GETMARGIN            = WM_USER + 27;  // lParam = lprc
  {$EXTERNALSYM TTM_POP}
  TTM_POP                  = WM_USER + 28;
  {$EXTERNALSYM TTM_UPDATE}
  TTM_UPDATE               = WM_USER + 29;

  {$EXTERNALSYM TTM_ADDTOOL}
  TTM_ADDTOOL             = TTM_ADDTOOLA;
  {$EXTERNALSYM TTM_DELTOOL}
  TTM_DELTOOL             = TTM_DELTOOLA;
  {$EXTERNALSYM TTM_NEWTOOLRECT}
  TTM_NEWTOOLRECT         = TTM_NEWTOOLRECTA;
  {$EXTERNALSYM TTM_GETTOOLINFO}
  TTM_GETTOOLINFO         = TTM_GETTOOLINFOA;
  {$EXTERNALSYM TTM_SETTOOLINFO}
  TTM_SETTOOLINFO         = TTM_SETTOOLINFOA;
  {$EXTERNALSYM TTM_HITTEST}
  TTM_HITTEST             = TTM_HITTESTA;
  {$EXTERNALSYM TTM_GETTEXT}
  TTM_GETTEXT             = TTM_GETTEXTA;
  {$EXTERNALSYM TTM_UPDATETIPTEXT}
  TTM_UPDATETIPTEXT       = TTM_UPDATETIPTEXTA;
  {$EXTERNALSYM TTM_ENUMTOOLS}
  TTM_ENUMTOOLS           = TTM_ENUMTOOLSA;
  {$EXTERNALSYM TTM_GETCURRENTTOOL}
  TTM_GETCURRENTTOOL      = TTM_GETCURRENTTOOLA;

  {$EXTERNALSYM TTM_RELAYEVENT}
  TTM_RELAYEVENT          = WM_USER + 7;
  {$EXTERNALSYM TTM_GETTOOLCOUNT}
  TTM_GETTOOLCOUNT        = WM_USER +13;


type
  PTTHitTestInfoA = ^TTTHitTestInfoA;
  PTTHitTestInfoW = ^TTTHitTestInfoW;
  PTTHitTestInfo = PTTHitTestInfoA;
  {$EXTERNALSYM _TT_HITTESTINFOA}
  _TT_HITTESTINFOA = packed record
    hwnd: HWND;
    pt: TPoint;
    ti: TToolInfoA;
  end;
  {$EXTERNALSYM _TT_HITTESTINFOW}
  _TT_HITTESTINFOW = packed record
    hwnd: HWND;
    pt: TPoint;
    ti: TToolInfoW;
  end;
  {$EXTERNALSYM _TT_HITTESTINFO}
  _TT_HITTESTINFO = _TT_HITTESTINFOA;
  TTTHitTestInfoA = _TT_HITTESTINFOA;
  TTTHitTestInfoW = _TT_HITTESTINFOW;
  TTTHitTestInfo = TTTHitTestInfoA;
  {$EXTERNALSYM TTHITTESTINFOA}
  TTHITTESTINFOA = _TT_HITTESTINFOA;
  {$EXTERNALSYM TTHITTESTINFOW}
  TTHITTESTINFOW = _TT_HITTESTINFOW;
  {$EXTERNALSYM TTHITTESTINFO}
  TTHITTESTINFO = TTHITTESTINFOA;


const
  {$EXTERNALSYM TTN_NEEDTEXTA}
  TTN_NEEDTEXTA            = TTN_FIRST - 0;
  {$EXTERNALSYM TTN_NEEDTEXTW}
  TTN_NEEDTEXTW            = TTN_FIRST - 10;

  {$EXTERNALSYM TTN_NEEDTEXT}
  TTN_NEEDTEXT            = TTN_NEEDTEXTA;

  {$EXTERNALSYM TTN_SHOW}
  TTN_SHOW                = TTN_FIRST - 1;
  {$EXTERNALSYM TTN_POP}
  TTN_POP                 = TTN_FIRST - 2;

type
  {$EXTERNALSYM tagNMTTDISPINFOA}
  tagNMTTDISPINFOA = packed record
    hdr: TNMHdr;
    lpszText: PAnsiChar;
    szText: array[0..79] of AnsiChar;
    hinst: HINST;
    uFlags: UINT;
    lParam: LPARAM;
  end;
  {$EXTERNALSYM tagNMTTDISPINFOW}
  tagNMTTDISPINFOW = packed record
    hdr: TNMHdr;
    lpszText: PWideChar;
    szText: array[0..79] of WideChar;
    hinst: HINST;
    uFlags: UINT;
    lParam: LPARAM;
  end;
  {$EXTERNALSYM tagNMTTDISPINFO}
  tagNMTTDISPINFO = tagNMTTDISPINFOA;
  PNMTTDispInfoA = ^TNMTTDispInfoA;
  PNMTTDispInfoW = ^TNMTTDispInfoW;
  PNMTTDispInfo = PNMTTDispInfoA;
  TNMTTDispInfoA = tagNMTTDISPINFOA;
  TNMTTDispInfoW = tagNMTTDISPINFOW;
  TNMTTDispInfo = TNMTTDispInfoA;

  {$EXTERNALSYM tagTOOLTIPTEXTA}
  tagTOOLTIPTEXTA = tagNMTTDISPINFOA;
  {$EXTERNALSYM tagTOOLTIPTEXTW}
  tagTOOLTIPTEXTW = tagNMTTDISPINFOW;
  {$EXTERNALSYM tagTOOLTIPTEXT}
  tagTOOLTIPTEXT = tagTOOLTIPTEXTA;
  {$EXTERNALSYM TOOLTIPTEXTA}
  TOOLTIPTEXTA = tagNMTTDISPINFOA;
  {$EXTERNALSYM TOOLTIPTEXTW}
  TOOLTIPTEXTW = tagNMTTDISPINFOW;
  {$EXTERNALSYM TOOLTIPTEXT}
  TOOLTIPTEXT = TOOLTIPTEXTA;
  TToolTipTextA = tagNMTTDISPINFOA;
  TToolTipTextW = tagNMTTDISPINFOW;
  TToolTipText = TToolTipTextA;
  PToolTipTextA = ^TToolTipTextA;
  PToolTipTextW = ^TToolTipTextW;
  PToolTipText = PToolTipTextA;



{ ====== UPDOWN CONTROL ========================== }

const
  {$EXTERNALSYM UPDOWN_CLASS}
  UPDOWN_CLASS = 'msctls_updown32';

type
  PUDAccel = ^TUDAccel;
  {$EXTERNALSYM _UDACCEL}
  _UDACCEL = packed record
    nSec: UINT;
    nInc: UINT;
  end;
  TUDAccel = _UDACCEL;
  {$EXTERNALSYM UDACCEL}
  UDACCEL = _UDACCEL;

const
  {$EXTERNALSYM UD_MAXVAL}
  UD_MAXVAL               = $7fff;
  {$EXTERNALSYM UD_MINVAL}
  UD_MINVAL               = -UD_MAXVAL;

  {$EXTERNALSYM UDS_WRAP}
  UDS_WRAP                = $0001;
  {$EXTERNALSYM UDS_SETBUDDYINT}
  UDS_SETBUDDYINT         = $0002;
  {$EXTERNALSYM UDS_ALIGNRIGHT}
  UDS_ALIGNRIGHT          = $0004;
  {$EXTERNALSYM UDS_ALIGNLEFT}
  UDS_ALIGNLEFT           = $0008;
  {$EXTERNALSYM UDS_AUTOBUDDY}
  UDS_AUTOBUDDY           = $0010;
  {$EXTERNALSYM UDS_ARROWKEYS}
  UDS_ARROWKEYS           = $0020;
  {$EXTERNALSYM UDS_HORZ}
  UDS_HORZ                = $0040;
  {$EXTERNALSYM UDS_NOTHOUSANDS}
  UDS_NOTHOUSANDS         = $0080;
  {$EXTERNALSYM UDS_HOTTRACK}
  UDS_HOTTRACK            = $0100;


  {$EXTERNALSYM UDM_SETRANGE}
  UDM_SETRANGE            = WM_USER+101;
  {$EXTERNALSYM UDM_GETRANGE}
  UDM_GETRANGE            = WM_USER+102;
  {$EXTERNALSYM UDM_SETPOS}
  UDM_SETPOS              = WM_USER+103;
  {$EXTERNALSYM UDM_GETPOS}
  UDM_GETPOS              = WM_USER+104;
  {$EXTERNALSYM UDM_SETBUDDY}
  UDM_SETBUDDY            = WM_USER+105;
  {$EXTERNALSYM UDM_GETBUDDY}
  UDM_GETBUDDY            = WM_USER+106;
  {$EXTERNALSYM UDM_SETACCEL}
  UDM_SETACCEL            = WM_USER+107;
  {$EXTERNALSYM UDM_GETACCEL}
  UDM_GETACCEL            = WM_USER+108;
  {$EXTERNALSYM UDM_SETBASE}
  UDM_SETBASE             = WM_USER+109;
  {$EXTERNALSYM UDM_GETBASE}
  UDM_GETBASE             = WM_USER+110;
  {$EXTERNALSYM UDM_SETRANGE32}
  UDM_SETRANGE32          = WM_USER+111;
  {$EXTERNALSYM UDM_GETRANGE32}
  UDM_GETRANGE32          = WM_USER+112; // wParam & lParam are LPINT


{ ====== STATUS BAR CONTROL ================= }

const
  SBARS_SIZEGRIP          = $0100;


const
  STATUSCLASSNAME = 'msctls_statusbar32';

const
  SB_SETTEXTA             = WM_USER+1;
  SB_GETTEXTA             = WM_USER+2;
  SB_GETTEXTLENGTHA       = WM_USER+3;
  SB_SETTIPTEXTA          = WM_USER+16;
  SB_GETTIPTEXTA          = WM_USER+18;

  SB_SETTEXTW             = WM_USER+11;
  SB_GETTEXTW             = WM_USER+13;
  SB_GETTEXTLENGTHW       = WM_USER+12;
  SB_SETTIPTEXTW          = WM_USER+17;
  SB_GETTIPTEXTW          = WM_USER+19;

  SB_SETTEXT             = SB_SETTEXTA;
  SB_GETTEXT             = SB_GETTEXTA;
  SB_GETTEXTLENGTH       = SB_GETTEXTLENGTHA;
  SB_SETTIPTEXT          = SB_SETTIPTEXTA;
  SB_GETTIPTEXT          = SB_GETTIPTEXTA;

  SB_SETPARTS             = WM_USER+4;
  SB_GETPARTS             = WM_USER+6;
  SB_GETBORDERS           = WM_USER+7;
  SB_SETMINHEIGHT         = WM_USER+8;
  SB_SIMPLE               = WM_USER+9;
  SB_GETRECT              = WM_USER + 10;
  SB_ISSIMPLE             = WM_USER+14;
  SB_SETICON              = WM_USER+15;
  SB_GETICON              = WM_USER+20;

  SBT_OWNERDRAW            = $1000;
  SBT_NOBORDERS            = $0100;
  SBT_POPOUT               = $0200;
  SBT_RTLREADING           = $0400;
  SBT_TOOLTIPS             = $0800;


{ ====== TOOLBAR CONTROL =================== }

const
  TOOLBARCLASSNAME = 'ToolbarWindow32';

type
  PTBButton = ^TTBButton;
  _TBBUTTON = packed record
    iBitmap: Integer;
    idCommand: Integer;
    fsState: Byte;
    fsStyle: Byte;
    bReserved: array[1..2] of Byte;
    dwData: Longint;
    iString: Integer;
  end;
  TTBButton = _TBBUTTON;

  {$EXTERNALSYM tagNMTOOLBARA}
  tagNMTOOLBARA = packed record
    hdr: TNMHdr;
    iItem: Integer;
    tbButton: TTBButton;
    cchText: Integer;
    pszText: PAnsiChar;
  end;
  {$EXTERNALSYM tagNMTOOLBARW}
  tagNMTOOLBARW = packed record
    hdr: TNMHdr;
    iItem: Integer;
    tbButton: TTBButton;
    cchText: Integer;
    pszText: PWideChar;
  end;
  {$EXTERNALSYM tagNMTOOLBAR}
  tagNMTOOLBAR = tagNMTOOLBARA;
  PNMToolBarA = ^TNMToolBarA;
  PNMToolBarW = ^TNMToolBarW;
  PNMToolBar = PNMToolBarA;
  TNMToolBarA = tagNMTOOLBARA;
  TNMToolBarW = tagNMTOOLBARW;
  TNMToolBar = TNMToolBarA;

  
  PColorMap = ^TColorMap;
  _COLORMAP = packed record
    cFrom: TColorRef;
    cTo: TColorRef;
  end;
  TColorMap = _COLORMAP;
  COLORMAP = _COLORMAP;

const

  CMB_MASKED              = $02;

  TBSTATE_CHECKED         = $01;
  TBSTATE_PRESSED         = $02;
  TBSTATE_ENABLED         = $04;
  TBSTATE_HIDDEN          = $08;
  TBSTATE_INDETERMINATE   = $10;
  TBSTATE_WRAP            = $20;
  TBSTATE_ELLIPSES        = $40;
  TBSTATE_MARKED          = $80;

  TBSTYLE_BUTTON          = $00;
  TBSTYLE_SEP             = $01;
  TBSTYLE_CHECK           = $02;
  TBSTYLE_GROUP           = $04;
  TBSTYLE_CHECKGROUP      = TBSTYLE_GROUP or TBSTYLE_CHECK;
  TBSTYLE_DROPDOWN        = $08;
  TBSTYLE_AUTOSIZE        = $0010; // automatically calculate the cx of the button
  TBSTYLE_NOPREFIX        = $0020; // if this button should not have accel prefix

  TBSTYLE_TOOLTIPS        = $0100;
  TBSTYLE_WRAPABLE        = $0200;
  TBSTYLE_ALTDRAG         = $0400;
  TBSTYLE_FLAT            = $0800;
  TBSTYLE_LIST            = $1000;
  TBSTYLE_CUSTOMERASE     = $2000;
  TBSTYLE_REGISTERDROP    = $4000;
  TBSTYLE_TRANSPARENT     = $8000;
  TBSTYLE_EX_DRAWDDARROWS = $00000001;


const

  TB_ENABLEBUTTON         = WM_USER + 1;
  TB_CHECKBUTTON          = WM_USER + 2;
  TB_PRESSBUTTON          = WM_USER + 3;
  TB_HIDEBUTTON           = WM_USER + 4;
  TB_INDETERMINATE        = WM_USER + 5;
  TB_MARKBUTTON           = WM_USER + 6;
  TB_ISBUTTONENABLED      = WM_USER + 9;
  TB_ISBUTTONCHECKED      = WM_USER + 10;
  TB_ISBUTTONPRESSED      = WM_USER + 11;
  TB_ISBUTTONHIDDEN       = WM_USER + 12;
  TB_ISBUTTONINDETERMINATE = WM_USER + 13;
  TB_ISBUTTONHIGHLIGHTED   = WM_USER + 14;
  TB_SETSTATE             = WM_USER + 17;
  TB_GETSTATE             = WM_USER + 18;
  TB_ADDBITMAP            = WM_USER + 19;

type
  PTBAddBitmap = ^TTBAddBitmap;
  tagTBADDBITMAP = packed record
    hInst: THandle;
    nID: UINT;
  end;
  TTBAddBitmap = tagTBADDBITMAP;
  TBADDBITMAP = tagTBADDBITMAP;

const
  HINST_COMMCTRL = THandle(-1);

  IDB_STD_SMALL_COLOR     = 0;
  IDB_STD_LARGE_COLOR     = 1;
  IDB_VIEW_SMALL_COLOR    = 4;
  IDB_VIEW_LARGE_COLOR    = 5;
  IDB_HIST_SMALL_COLOR    = 8;
  IDB_HIST_LARGE_COLOR    = 9;


  TB_ADDBUTTONSA          = WM_USER + 20;
  TB_INSERTBUTTONA        = WM_USER + 21;
  TB_DELETEBUTTON         = WM_USER + 22;
  TB_GETBUTTON            = WM_USER + 23;
  TB_BUTTONCOUNT          = WM_USER + 24;
  TB_COMMANDTOINDEX       = WM_USER + 25;

type
  PTBSaveParamsA = ^TTBSaveParamsA;
  PTBSaveParamsW = ^TTBSaveParamsW;
  PTBSaveParams = PTBSaveParamsA;
  tagTBSAVEPARAMSA = packed record
    hkr: THandle;
    pszSubKey: PAnsiChar;
    pszValueName: PAnsiChar;
  end;
  tagTBSAVEPARAMSW = packed record
    hkr: THandle;
    pszSubKey: PWideChar;
    pszValueName: PWideChar;
  end;
  tagTBSAVEPARAMS = tagTBSAVEPARAMSA;
  TTBSaveParamsA = tagTBSAVEPARAMSA;
  TTBSaveParamsW = tagTBSAVEPARAMSW;
  TTBSaveParams = TTBSaveParamsA;
  TBSAVEPARAMSA = tagTBSAVEPARAMSA;
  TBSAVEPARAMSW = tagTBSAVEPARAMSW;
  TBSAVEPARAMS = TBSAVEPARAMSA;

const
  TB_SAVERESTOREA          = WM_USER + 26;
  TB_ADDSTRINGA            = WM_USER + 28;
  TB_GETBUTTONTEXTA        = WM_USER + 45;
  TBN_GETBUTTONINFOA       = TBN_FIRST-0;
  TB_SAVERESTOREW          = WM_USER + 76;
  TB_ADDSTRINGW            = WM_USER + 77;
  TB_GETBUTTONTEXTW        = WM_USER + 75;
  TBN_GETBUTTONINFOW       = TBN_FIRST-20;

  TB_SAVERESTORE          = TB_SAVERESTOREA;
  TB_ADDSTRING            = TB_ADDSTRINGA;
  TB_GETBUTTONTEXT        = TB_GETBUTTONTEXTA;
  TBN_GETBUTTONINFO       = TBN_GETBUTTONINFOA;

  TB_CUSTOMIZE            = WM_USER + 27;
  TB_GETITEMRECT          = WM_USER + 29;
  TB_BUTTONSTRUCTSIZE     = WM_USER + 30;
  TB_SETBUTTONSIZE        = WM_USER + 31;
  TB_SETBITMAPSIZE        = WM_USER + 32;
  TB_AUTOSIZE             = WM_USER + 33;
  TB_GETTOOLTIPS          = WM_USER + 35;
  TB_SETTOOLTIPS          = WM_USER + 36;
  TB_SETPARENT            = WM_USER + 37;
  TB_SETROWS              = WM_USER + 39;
  TB_GETROWS              = WM_USER + 40;
  TB_SETCMDID             = WM_USER + 42;
  TB_CHANGEBITMAP         = WM_USER + 43;
  TB_GETBITMAP            = WM_USER + 44;
  TB_REPLACEBITMAP        = WM_USER + 46;
  TB_SETINDENT            = WM_USER + 47;
  TB_SETIMAGELIST         = WM_USER + 48;
  TB_GETIMAGELIST         = WM_USER + 49;
  TB_LOADIMAGES           = WM_USER + 50;
  TB_GETRECT              = WM_USER + 51; { wParam is the Cmd instead of index }
  TB_SETHOTIMAGELIST      = WM_USER + 52;
  TB_GETHOTIMAGELIST      = WM_USER + 53;
  TB_SETDISABLEDIMAGELIST = WM_USER + 54;
  TB_GETDISABLEDIMAGELIST = WM_USER + 55;
  TB_SETSTYLE             = WM_USER + 56;
  TB_GETSTYLE             = WM_USER + 57;
  TB_GETBUTTONSIZE        = WM_USER + 58;
  TB_SETBUTTONWIDTH       = WM_USER + 59;
  TB_SETMAXTEXTROWS       = WM_USER + 60;
  TB_GETTEXTROWS          = WM_USER + 61;

  TB_GETOBJECT            = WM_USER + 62;  // wParam == IID, lParam void **ppv
  TB_GETHOTITEM           = WM_USER + 71;
  TB_SETHOTITEM           = WM_USER + 72;  // wParam == iHotItem
  TB_SETANCHORHIGHLIGHT   = WM_USER + 73;  // wParam == TRUE/FALSE
  TB_GETANCHORHIGHLIGHT   = WM_USER + 74;
  TB_MAPACCELERATORA      = WM_USER + 78;  // wParam == ch, lParam int * pidBtn

type
  TBINSERTMARK = packed record
    iButton: Integer;
    dwFlags: DWORD;
  end;
  PTBInsertMark = ^TTBInsertMark;
  TTBInsertMark = TBINSERTMARK;

const
  TBIMHT_AFTER      = $00000001; // TRUE = insert After iButton, otherwise before
  TBIMHT_BACKGROUND = $00000002; // TRUE iff missed buttons completely

  TB_GETINSERTMARK        = WM_USER + 79;  // lParam == LPTBINSERTMARK
  TB_SETINSERTMARK        = WM_USER + 80;  // lParam == LPTBINSERTMARK
  TB_INSERTMARKHITTEST    = WM_USER + 81;  // wParam == LPPOINT lParam == LPTBINSERTMARK
  TB_MOVEBUTTON           = WM_USER + 82;
  TB_GETMAXSIZE           = WM_USER + 83;  // lParam == LPSIZE
  TB_SETEXTENDEDSTYLE     = WM_USER + 84;  // For TBSTYLE_EX_*
  TB_GETEXTENDEDSTYLE     = WM_USER + 85;  // For TBSTYLE_EX_*
  TB_GETPADDING           = WM_USER + 86;
  TB_SETPADDING           = WM_USER + 87;
  TB_SETINSERTMARKCOLOR   = WM_USER + 88;
  TB_GETINSERTMARKCOLOR   = WM_USER + 89;



type
  TBREPLACEBITMAP = packed record
    hInstOld: THandle;
    nIDOld: Cardinal;
    hInstNew: THandle;
    nIDNew: Cardinal;
    nButtons: Integer;
  end;
  PTBReplaceBitmap = ^TTBReplaceBitmap;
  TTBReplaceBitmap = TBREPLACEBITMAP;

const
  TBBF_LARGE              = $0001;

  TB_GETBITMAPFLAGS       = WM_USER + 41;

  TBIF_IMAGE              = $00000001;
  TBIF_TEXT               = $00000002;
  TBIF_STATE              = $00000004;
  TBIF_STYLE              = $00000008;
  TBIF_LPARAM             = $00000010;
  TBIF_COMMAND            = $00000020;
  TBIF_SIZE               = $00000040;

type
  TBBUTTONINFOA = packed record
    cbSize: UINT;
    dwMask: DWORD;
    idCommand: Integer;
    iImage: Integer;
    fsState: Byte;
    fsStyle: Byte;
    cx: Word;
    lParam: DWORD;
    pszText: PAnsiChar;
    cchText: Integer;
  end;
  TBBUTTONINFOW = packed record
    cbSize: UINT;
    dwMask: DWORD;
    idCommand: Integer;
    iImage: Integer;
    fsState: Byte;
    fsStyle: Byte;
    cx: Word;
    lParam: DWORD;
    pszText: PWideChar;
    cchText: Integer;
  end;
  TBBUTTONINFO = TBBUTTONINFOA;
  PTBButtonInfoA = ^TTBButtonInfoA;
  PTBButtonInfoW = ^TTBButtonInfoW;
  PTBButtonInfo = PTBButtonInfoA;
  TTBButtonInfoA = TBBUTTONINFOA;
  TTBButtonInfoW = TBBUTTONINFOW;
  TTBButtonInfo = TTBButtonInfoA;

const
  // BUTTONINFO APIs do NOT support the string pool.
  TB_GETBUTTONINFOW        = WM_USER + 63;
  TB_SETBUTTONINFOW        = WM_USER + 64;
  TB_GETBUTTONINFOA        = WM_USER + 65;
  TB_SETBUTTONINFOA        = WM_USER + 66;
  TB_GETBUTTONINFO         = TB_GETBUTTONINFOA;
  TB_SETBUTTONINFO         = TB_SETBUTTONINFOA;

  TB_INSERTBUTTONW        = WM_USER + 67;
  TB_ADDBUTTONSW          = WM_USER + 68;

  TB_HITTEST              = WM_USER + 69;

  // New post Win95/NT4 for InsertButton and AddButton.  if iString member
  // is a pointer to a string, it will be handled as a string like listview
  // = although LPSTR_TEXTCALLBACK is not supported;.
  TB_INSERTBUTTON         = TB_INSERTBUTTONA;
  TB_ADDBUTTONS           = TB_ADDBUTTONSA;

  TB_SETDRAWTEXTFLAGS     = WM_USER + 70;  // wParam == mask lParam == bit values

  TBN_BEGINDRAG           = TBN_FIRST-1;
  TBN_ENDDRAG             = TBN_FIRST-2;
  TBN_BEGINADJUST         = TBN_FIRST-3;
  TBN_ENDADJUST           = TBN_FIRST-4;
  TBN_RESET               = TBN_FIRST-5;
  TBN_QUERYINSERT         = TBN_FIRST-6;
  TBN_QUERYDELETE         = TBN_FIRST-7;
  TBN_TOOLBARCHANGE       = TBN_FIRST-8;
  TBN_CUSTHELP            = TBN_FIRST-9;
  TBN_DROPDOWN            = TBN_FIRST-10;
  TBN_CLOSEUP             = TBN_FIRST-11;
  TBN_GETOBJECT           = TBN_FIRST-12;





function CreateStatusWindow(Style: Longint; lpszText: PAnsiChar;
  hwndParent: HWND; wID: UINT): HWND;stdcall;
function CreateUpDownControl(dwStyle: Longint; X, Y, CX, CY: Integer;
  hParent: HWND;  nID: Integer; hInst: THandle; hBuddy: HWND;
  nUpper, nLower, nPos: Integer): HWND; stdcall;
function CreateToolBarEx(Wnd: HWnd; ws: Longint; ID: UINT;
  Bitmaps: Integer; BMInst: THandle; BMID: Cardinal; Buttons: PTBButton;
  NumButtons: Integer; dxButton, dyButton: Integer;
  dxBitmap, dyBitmap: Integer; StructSize: UINT): HWnd; stdcall;

procedure DrawStatusText(hDC: HDC; lprc: PRect; pzsText: PChar;
  uFlags: UINT); stdcall;


{ ====== IMAGE LIST =========================================== }


const
  CLR_NONE                = $FFFFFFFF;
  CLR_DEFAULT             = $FF000000;

type
  HImageList = THandle;

const
  ILC_MASK                = $0001;
  ILC_COLOR               = $00FE;
  ILC_COLORDDB            = $00FE;
  ILC_COLOR4              = $0004;
  ILC_COLOR8              = $0008;
  ILC_COLOR16             = $0010;
  ILC_COLOR24             = $0018;
  ILC_COLOR32             = $0020;
  ILC_PALETTE             = $0800;

function ImageList_Create(CX, CY: Integer; Flags: UINT;
  Initial, Grow: Integer): HImageList; stdcall;
function ImageList_Destroy(ImageList: HImageList): Bool; stdcall;
function ImageList_GetImageCount(ImageList: HImageList): Integer; stdcall;
function ImageList_Add(ImageList: HImageList; Image, Mask: HBitmap): Integer; stdcall;
function ImageList_ReplaceIcon(ImageList: HImageList; Index: Integer;
  Icon: HIcon): Integer; stdcall;
function ImageList_SetBkColor(ImageList: HImageList; ClrBk: TColorRef): TColorRef; stdcall;
function ImageList_GetBkColor(ImageList: HImageList): TColorRef; stdcall;
function ImageList_SetOverlayImage(ImageList: HImageList; Image: Integer;
  Overlay: Integer): Bool; stdcall;

function ImageList_AddIcon(ImageList: HImageList; Icon: HIcon): Integer;

const
  ILD_NORMAL              = $0000;
  ILD_TRANSPARENT         = $0001;
  ILD_MASK                = $0010;
  ILD_IMAGE               = $0020;
  ILD_BLEND25             = $0002;
  ILD_BLEND50             = $0004;
  ILD_OVERLAYMASK         = $0F00;

function IndexToOverlayMask(Index: Integer): Integer;

const
  ILD_SELECTED            = ILD_BLEND50;
  ILD_FOCUS               = ILD_BLEND25;
  ILD_BLEND               = ILD_BLEND50;
  CLR_HILIGHT             = CLR_DEFAULT;

function ImageList_Draw(ImageList: HImageList; Index: Integer;
  Dest: HDC; X, Y: Integer; Style: UINT): Bool; stdcall;

function ImageList_Replace(ImageList: HImageList; Index: Integer;
  Image, Mask: HBitmap): Bool; stdcall;
function ImageList_AddMasked(ImageList: HImageList; Image: HBitmap;
  Mask: TColorRef): Integer; stdcall;
function ImageList_DrawEx(ImageList: HImageList; Index: Integer;
  Dest: HDC; X, Y, DX, DY: Integer; Bk, Fg: TColorRef; Style: Cardinal): Bool; stdcall;
function ImageList_Remove(ImageList: HImageList; Index: Integer): Bool; stdcall;
function ImageList_GetIcon(ImageList: HImageList; Index: Integer;
  Flags: Cardinal): HIcon; stdcall;
function ImageList_LoadImageA(Instance: THandle; Bmp: PAnsiChar; CX, Grow: Integer;
  Mask: TColorRef; pType, Flags: Cardinal): HImageList; stdcall;
function ImageList_LoadImageW(Instance: THandle; Bmp: PWideChar; CX, Grow: Integer;
  Mask: TColorRef; pType, Flags: Cardinal): HImageList; stdcall;
function ImageList_LoadImage(Instance: THandle; Bmp: PChar; CX, Grow: Integer;
  Mask: TColorRef; pType, Flags: Cardinal): HImageList; stdcall;
function ImageList_BeginDrag(ImageList: HImageList; Track: Integer;
  XHotSpot, YHotSpot: Integer): Bool; stdcall;
function ImageList_EndDrag: Bool; stdcall;
function ImageList_DragEnter(LockWnd: HWnd; X, Y: Integer): Bool; stdcall;
function ImageList_DragLeave(LockWnd: HWnd): Bool; stdcall;
function ImageList_DragMove(X, Y: Integer): Bool; stdcall;
function ImageList_SetDragCursorImage(ImageList: HImageList; Drag: Integer;
  XHotSpot, YHotSpot: Integer): Bool; stdcall;
function ImageList_DragShowNolock(Show: Bool): Bool; stdcall;
function ImageList_GetDragImage(Point, HotSpot: PPoint): HImageList; stdcall;

{ macros }
procedure ImageList_RemoveAll(ImageList: HImageList);
function ImageList_ExtractIcon(Instance: THandle; ImageList: HImageList;
  Image: Integer): HIcon;
function ImageList_LoadBitmap(Instance: THandle; Bmp: PChar;
  CX, Grow: Integer; MasK: TColorRef): HImageList;

//function ImageList_Read(Stream: IStream): HImageList; stdcall;
//function ImageList_Write(ImageList: HImageList; Stream: IStream): BOOL; stdcall;

type
  PImageInfo = ^TImageInfo;
  TImageInfo = packed record
    hbmImage: HBitmap;
    hbmMask: HBitmap;
    Unused1: Integer;
    Unused2: Integer;
    rcImage: TRect;
  end;

function ImageList_GetIconSize(ImageList: HImageList; var CX, CY: Integer): Bool; stdcall;
function ImageList_SetIconSize(ImageList: HImageList; CX, CY: Integer): Bool; stdcall;
function ImageList_GetImageInfo(ImageList: HImageList; Index: Integer;
  var ImageInfo: TImageInfo): Bool; stdcall;
function ImageList_Merge(ImageList1: HImageList; Index1: Integer;
  ImageList2: HImageList; Index2: Integer; DX, DY: Integer): Bool; stdcall;


{ From prsht.h -- Interface for the Windows Property Sheet Pages }

const
  {$EXTERNALSYM MAXPROPPAGES}
  MAXPROPPAGES = 100;

  {$EXTERNALSYM PSP_DEFAULT}
  PSP_DEFAULT             = $00000000;
  {$EXTERNALSYM PSP_DLGINDIRECT}
  PSP_DLGINDIRECT         = $00000001;
  {$EXTERNALSYM PSP_USEHICON}
  PSP_USEHICON            = $00000002;
  {$EXTERNALSYM PSP_USEICONID}
  PSP_USEICONID           = $00000004;
  {$EXTERNALSYM PSP_USETITLE}
  PSP_USETITLE            = $00000008;
  {$EXTERNALSYM PSP_RTLREADING}
  PSP_RTLREADING          = $00000010;
  {$EXTERNALSYM PSP_HASHELP}
  PSP_HASHELP             = $00000020;
  {$EXTERNALSYM PSP_USEREFPARENT}
  PSP_USEREFPARENT        = $00000040;
  {$EXTERNALSYM PSP_USECALLBACK}
  PSP_USECALLBACK         = $00000080;
  {$EXTERNALSYM PSP_PREMATURE}
  PSP_PREMATURE           = $00000400;
  {$EXTERNALSYM PSP_HIDEHEADER}
  PSP_HIDEHEADER          = $00000800;
  {$EXTERNALSYM PSP_USEHEADERTITLE}
  PSP_USEHEADERTITLE      = $00001000;
  {$EXTERNALSYM PSP_USEHEADERSUBTITLE}
  PSP_USEHEADERSUBTITLE   = $00002000;

  {$EXTERNALSYM PSPCB_RELEASE}
  PSPCB_RELEASE           = 1;
  {$EXTERNALSYM PSPCB_CREATE}
  PSPCB_CREATE            = 2;

  {$EXTERNALSYM PSH_DEFAULT}
  PSH_DEFAULT             = $00000000;
  {$EXTERNALSYM PSH_PROPTITLE}
  PSH_PROPTITLE           = $00000001;
  {$EXTERNALSYM PSH_USEHICON}
  PSH_USEHICON            = $00000002;
  {$EXTERNALSYM PSH_USEICONID}
  PSH_USEICONID           = $00000004;
  {$EXTERNALSYM PSH_PROPSHEETPAGE}
  PSH_PROPSHEETPAGE       = $00000008;
  {$EXTERNALSYM PSH_WIZARDHASFINISH}
  PSH_WIZARDHASFINISH     = $00000010;
  PSH_MULTILINETABS       = $00000010;
  {$EXTERNALSYM PSH_WIZARD}
  PSH_WIZARD              = $00000020;
  {$EXTERNALSYM PSH_USEPSTARTPAGE}
  PSH_USEPSTARTPAGE       = $00000040;
  {$EXTERNALSYM PSH_NOAPPLYNOW}
  PSH_NOAPPLYNOW          = $00000080;
  {$EXTERNALSYM PSH_USECALLBACK}
  PSH_USECALLBACK         = $00000100;
  {$EXTERNALSYM PSH_HASHELP}
  PSH_HASHELP             = $00000200;
  {$EXTERNALSYM PSH_MODELESS}
  PSH_MODELESS            = $00000400;
  {$EXTERNALSYM PSH_RTLREADING}
  PSH_RTLREADING          = $00000800;
  {$EXTERNALSYM PSH_WIZARDCONTEXTHELP}
  PSH_WIZARDCONTEXTHELP   = $00001000;
  {$EXTERNALSYM PSH_WIZARD97}
  PSH_WIZARD97            = $00002000;
  {$EXTERNALSYM PSH_WATERMARK}
  PSH_WATERMARK           = $00008000;
  {$EXTERNALSYM PSH_USEHBMWATERMARK}
  PSH_USEHBMWATERMARK     = $00010000;  // user pass in a hbmWatermark instead of pszbmWatermark
  {$EXTERNALSYM PSH_USEHPLWATERMARK}
  PSH_USEHPLWATERMARK     = $00020000;  //
  {$EXTERNALSYM PSH_STRETCHWATERMARK}
  PSH_STRETCHWATERMARK    = $00040000;  // stretchwatermark also applies for the header
  {$EXTERNALSYM PSH_HEADER}
  PSH_HEADER              = $00080000;
  {$EXTERNALSYM PSH_USEHBMHEADER}
  PSH_USEHBMHEADER        = $00100000;
  {$EXTERNALSYM PSH_USEPAGELANG}
  PSH_USEPAGELANG         = $00200000;  // use frame dialog template matched to page

  {$EXTERNALSYM PSCB_INITIALIZED}
  PSCB_INITIALIZED  = 1;
  {$EXTERNALSYM PSCB_PRECREATE}
  PSCB_PRECREATE    = 2;

  {$EXTERNALSYM PSN_FIRST}
  PSN_FIRST               = -200;
  {$EXTERNALSYM PSN_LAST}
  PSN_LAST                = -299;

  {$EXTERNALSYM PSN_SETACTIVE}
  PSN_SETACTIVE           = PSN_FIRST - 0;
  {$EXTERNALSYM PSN_KILLACTIVE}
  PSN_KILLACTIVE          = PSN_FIRST - 1;
  {$EXTERNALSYM PSN_APPLY}
  PSN_APPLY               = PSN_FIRST - 2;
  {$EXTERNALSYM PSN_RESET}
  PSN_RESET               = PSN_FIRST - 3;
  {$EXTERNALSYM PSN_HELP}
  PSN_HELP                = PSN_FIRST - 5;
  {$EXTERNALSYM PSN_WIZBACK}
  PSN_WIZBACK             = PSN_FIRST - 6;
  {$EXTERNALSYM PSN_WIZNEXT}
  PSN_WIZNEXT             = PSN_FIRST - 7;
  {$EXTERNALSYM PSN_WIZFINISH}
  PSN_WIZFINISH           = PSN_FIRST - 8;
  {$EXTERNALSYM PSN_QUERYCANCEL}
  PSN_QUERYCANCEL         = PSN_FIRST - 9;
  {$EXTERNALSYM PSN_GETOBJECT}
  PSN_GETOBJECT           = PSN_FIRST - 10;

  {$EXTERNALSYM PSNRET_NOERROR}
  PSNRET_NOERROR              = 0;
  {$EXTERNALSYM PSNRET_INVALID}
  PSNRET_INVALID              = 1;
  {$EXTERNALSYM PSNRET_INVALID_NOCHANGEPAGE}
  PSNRET_INVALID_NOCHANGEPAGE = 2;

  {$EXTERNALSYM PSM_SETCURSEL}
  PSM_SETCURSEL           = WM_USER + 101;
  {$EXTERNALSYM PSM_REMOVEPAGE}
  PSM_REMOVEPAGE          = WM_USER + 102;
  {$EXTERNALSYM PSM_ADDPAGE}
  PSM_ADDPAGE             = WM_USER + 103;
  {$EXTERNALSYM PSM_CHANGED}
  PSM_CHANGED             = WM_USER + 104;
  {$EXTERNALSYM PSM_RESTARTWINDOWS}
  PSM_RESTARTWINDOWS      = WM_USER + 105;
  {$EXTERNALSYM PSM_REBOOTSYSTEM}
  PSM_REBOOTSYSTEM        = WM_USER + 106;
  {$EXTERNALSYM PSM_CANCELTOCLOSE}
  PSM_CANCELTOCLOSE       = WM_USER + 107;
  {$EXTERNALSYM PSM_QUERYSIBLINGS}
  PSM_QUERYSIBLINGS       = WM_USER + 108;
  {$EXTERNALSYM PSM_UNCHANGED}
  PSM_UNCHANGED           = WM_USER + 109;
  {$EXTERNALSYM PSM_APPLY}
  PSM_APPLY               = WM_USER + 110;
  {$EXTERNALSYM PSM_SETTITLE}
  PSM_SETTITLE            = WM_USER + 111;
  {$EXTERNALSYM PSM_SETTITLEW}
  PSM_SETTITLEW           = WM_USER + 120;
  {$EXTERNALSYM PSM_SETWIZBUTTONS}
  PSM_SETWIZBUTTONS       = WM_USER + 112;
  {$EXTERNALSYM PSM_PRESSBUTTON}
  PSM_PRESSBUTTON         = WM_USER + 113;
  {$EXTERNALSYM PSM_SETCURSELID}
  PSM_SETCURSELID         = WM_USER + 114;
  {$EXTERNALSYM PSM_SETFINISHTEXT}
  PSM_SETFINISHTEXT       = WM_USER + 115;
  {$EXTERNALSYM PSM_SETFINISHTEXTW}
  PSM_SETFINISHTEXTW      = WM_USER + 121;
  {$EXTERNALSYM PSM_GETTABCONTROL}
  PSM_GETTABCONTROL       = WM_USER + 116;
  {$EXTERNALSYM PSM_ISDIALOGMESSAGE}
  PSM_ISDIALOGMESSAGE     = WM_USER + 117;

  {$EXTERNALSYM PSWIZB_BACK}
  PSWIZB_BACK             = $00000001;
  {$EXTERNALSYM PSWIZB_NEXT}
  PSWIZB_NEXT             = $00000002;
  {$EXTERNALSYM PSWIZB_FINISH}
  PSWIZB_FINISH           = $00000004;
  {$EXTERNALSYM PSWIZB_DISABLEDFINISH}
  PSWIZB_DISABLEDFINISH   = $00000008;

  {$EXTERNALSYM PSBTN_BACK}
  PSBTN_BACK              = 0;
  {$EXTERNALSYM PSBTN_NEXT}
  PSBTN_NEXT              = 1;
  {$EXTERNALSYM PSBTN_FINISH}
  PSBTN_FINISH            = 2;
  {$EXTERNALSYM PSBTN_OK}
  PSBTN_OK                = 3;
  {$EXTERNALSYM PSBTN_APPLYNOW}
  PSBTN_APPLYNOW          = 4;
  {$EXTERNALSYM PSBTN_CANCEL}
  PSBTN_CANCEL            = 5;
  {$EXTERNALSYM PSBTN_HELP}
  PSBTN_HELP              = 6;
  {$EXTERNALSYM PSBTN_MAX}
  PSBTN_MAX               = 6;

  {$EXTERNALSYM ID_PSRESTARTWINDOWS}
  ID_PSRESTARTWINDOWS     = 2;
  {$EXTERNALSYM ID_PSREBOOTSYSTEM}
  ID_PSREBOOTSYSTEM       = ID_PSRESTARTWINDOWS or 1;

  {$EXTERNALSYM WIZ_CXDLG}
  WIZ_CXDLG               = 276;
  {$EXTERNALSYM WIZ_CYDLG}
  WIZ_CYDLG               = 140;

  {$EXTERNALSYM WIZ_CXBMP}
  WIZ_CXBMP               = 80;

  {$EXTERNALSYM WIZ_BODYX}
  WIZ_BODYX               = 92;
  {$EXTERNALSYM WIZ_BODYCX}
  WIZ_BODYCX              = 184;

  {$EXTERNALSYM PROP_SM_CXDLG}
  PROP_SM_CXDLG           = 212;
  {$EXTERNALSYM PROP_SM_CYDLG}
  PROP_SM_CYDLG           = 188;

  {$EXTERNALSYM PROP_MED_CXDLG}
  PROP_MED_CXDLG          = 227;
  {$EXTERNALSYM PROP_MED_CYDLG}
  PROP_MED_CYDLG          = 215;

  {$EXTERNALSYM PROP_LG_CXDLG}
  PROP_LG_CXDLG           = 252;
  {$EXTERNALSYM PROP_LG_CYDLG}
  PROP_LG_CYDLG           = 218;

type
  HPropSheetPage = Pointer;

  PPropSheetPageA = ^TPropSheetPageA;
  PPropSheetPageW = ^TPropSheetPageW;
  PPropSheetPage = PPropSheetPageA;

  {$EXTERNALSYM LPFNPSPCALLBACKA}
  LPFNPSPCALLBACKA = function(Wnd: HWnd; Msg: Integer;
    PPSP: PPropSheetPageA): Integer stdcall;
  {$EXTERNALSYM LPFNPSPCALLBACKW}
  LPFNPSPCALLBACKW = function(Wnd: HWnd; Msg: Integer;
    PPSP: PPropSheetPageW): Integer stdcall;
  {$EXTERNALSYM LPFNPSPCALLBACK}
  LPFNPSPCALLBACK = LPFNPSPCALLBACKA;
  TFNPSPCallbackA = LPFNPSPCALLBACKA;
  TFNPSPCallbackW = LPFNPSPCALLBACKW;
  TFNPSPCallback = TFNPSPCallbackA;

  {$EXTERNALSYM _PROPSHEETPAGEA}
  _PROPSHEETPAGEA = record
    dwSize: Longint;
    dwFlags: Longint;
    hInstance: THandle;
    case Integer of
      0: (
        pszTemplate: PAnsiChar);
      1: (
        pResource: Pointer;
        case Integer of
          0: (
            hIcon: THandle);
          1: (
            pszIcon: PAnsiChar;
            pszTitle: PAnsiChar;
            pfnDlgProc: Pointer;
            lParam: Longint;
            pfnCallback: TFNPSPCallbackA;
            pcRefParent: PInteger;
//            pszHeaderTitle: PAnsiChar;      // this is displayed in the header
//            pszHeaderSubTitle: PAnsiChar
             )
             ); //
  end;
  {$EXTERNALSYM _PROPSHEETPAGEW}
  _PROPSHEETPAGEW = record
    dwSize: Longint;
    dwFlags: Longint;
    hInstance: THandle;
    case Integer of
      0: (
        pszTemplate: PWideChar);
      1: (
        pResource: Pointer;
        case Integer of
          0: (
            hIcon: THandle);
          1: (
            pszIcon: PWideChar;
            pszTitle: PWideChar;
            pfnDlgProc: Pointer;
            lParam: Longint;
            pfnCallback: TFNPSPCallbackW;
            pcRefParent: PInteger;
            pszHeaderTitle: PWideChar;      // this is displayed in the header
            pszHeaderSubTitle: PWideChar)); //
  end;
  {$EXTERNALSYM _PROPSHEETPAGE}
  _PROPSHEETPAGE = _PROPSHEETPAGEA;
  TPropSheetPageA = _PROPSHEETPAGEA;
  TPropSheetPageW = _PROPSHEETPAGEW;
  TPropSheetPage = TPropSheetPageA;
  {$EXTERNALSYM PROPSHEETPAGEA}
  PROPSHEETPAGEA = _PROPSHEETPAGEA;
  {$EXTERNALSYM PROPSHEETPAGEW}
  PROPSHEETPAGEW = _PROPSHEETPAGEW;
  {$EXTERNALSYM PROPSHEETPAGE}
  PROPSHEETPAGE = PROPSHEETPAGEA;


  {$EXTERNALSYM PFNPROPSHEETCALLBACK}
  PFNPROPSHEETCALLBACK = function(Wnd: HWnd; Msg: Integer;
    LParam: Integer): Integer stdcall;
  TFNPropSheetCallback = PFNPROPSHEETCALLBACK;

  PPropSheetHeaderA = ^TPropSheetHeaderA;
  PPropSheetHeaderW = ^TPropSheetHeaderW;
  PPropSheetHeader = PPropSheetHeaderA;
  {$EXTERNALSYM _PROPSHEETHEADERA}
  _PROPSHEETHEADERA = record
    dwSize: Longint;
    dwFlags: Longint;
    hwndParent: HWnd;
    hInstance: THandle;
    case Integer of
      0: (
	hIcon: THandle);
      1: (
	pszIcon: PAnsiChar;
	pszCaption: PAnsiChar;
	nPages: Integer;
	case Integer of
	  0: (
	    nStartPage: Integer);
	  1: (
	    pStartPage: PAnsiChar;
	    case Integer of
	      0: (
		ppsp: PPropSheetPageA);
	      1: (
		phpage: Pointer;
		pfnCallback: TFNPropSheetCallback;
{                case Integer of//BIG BUG
                  0: (
                    hbmWatermark: HBITMAP);
                  1: (
                    pszbmWatermark: PAnsiChar;
                    hplWatermark: HPALETTE;
                    // Header bitmap shares the palette with watermark
                    case Integer of
                      0: (
                        hbmHeader: HBITMAP);
                      1: (
                        pszbmHeader: PAnsiChar))})));
  end;
  {$EXTERNALSYM _PROPSHEETHEADERW}
  _PROPSHEETHEADERW = record
    dwSize: Longint;
    dwFlags: Longint;
    hwndParent: HWnd;
    hInstance: THandle;
    case Integer of
      0: (
	hIcon: THandle);
      1: (
	pszIcon: PWideChar;
	pszCaption: PWideChar;
	nPages: Integer;
	case Integer of
	  0: (
	    nStartPage: Integer);
	  1: (
	    pStartPage: PWideChar;
	    case Integer of
	      0: (
		ppsp: PPropSheetPageW);
	      1: (
		phpage: Pointer;
		pfnCallback: TFNPropSheetCallback;
                case Integer of
                  0: (
                    hbmWatermark: HBITMAP);
                  1: (
                    pszbmWatermark: PWideChar;
                    hplWatermark: HPALETTE;
                    // Header bitmap shares the palette with watermark
                    case Integer of
                      0: (
                        hbmHeader: HBITMAP);
                      1: (
                        pszbmHeader: PWideChar)))));
  end;
  {$EXTERNALSYM _PROPSHEETHEADER}
  _PROPSHEETHEADER = _PROPSHEETHEADERA;
  TPropSheetHeaderA = _PROPSHEETHEADERA;
  TPropSheetHeaderW = _PROPSHEETHEADERW;
  TPropSheetHeader = TPropSheetHeaderA;

  {$EXTERNALSYM LPFNADDPROPSHEETPAGE}
  LPFNADDPROPSHEETPAGE = function(hPSP: HPropSheetPage;
    lParam: Longint): BOOL stdcall;
  TFNAddPropSheetPage = LPFNADDPROPSHEETPAGE;

  {$EXTERNALSYM LPFNADDPROPSHEETPAGES}
  LPFNADDPROPSHEETPAGES = function(lpvoid: Pointer; pfn: TFNAddPropSheetPage;
    lParam: Longint): BOOL stdcall;
  TFNAddPropSheetPages = LPFNADDPROPSHEETPAGES;

{$EXTERNALSYM CreatePropertySheetPageA}
function CreatePropertySheetPageA(var PSP: TPropSheetPageA): HPropSheetPage; stdcall;
{$EXTERNALSYM CreatePropertySheetPageW}
function CreatePropertySheetPageW(var PSP: TPropSheetPageW): HPropSheetPage; stdcall;
{$EXTERNALSYM CreatePropertySheetPage}
function CreatePropertySheetPage(var PSP: TPropSheetPage): HPropSheetPage; stdcall;
{$EXTERNALSYM DestroyPropertySheetPage}
function DestroyPropertySheetPage(hPSP: HPropSheetPage): BOOL; stdcall;
{$EXTERNALSYM PropertySheetA}
function PropertySheetA(var PSH: TPropSheetHeaderA): Integer; stdcall;
{$EXTERNALSYM PropertySheetW}
function PropertySheetW(var PSH: TPropSheetHeaderW): Integer; stdcall;
{$EXTERNALSYM PropertySheet}
function PropertySheet(var PSH: TPropSheetHeader): Integer; stdcall;



implementation

procedure InitCommonControls; external comctl name 'InitCommonControls';
//function InitCommonControlsEx(var ICC: TInitCommonControlsEx): Bool; stdcall; external comctl name 'InitCommonControlsEx';

function CreateStatusWindow(Style: Longint; lpszText: PAnsiChar;
  hwndParent: HWND; wID: UINT): HWND;stdcall; external comctl name 'CreateStatusWindowA';
function CreateUpDownControl(dwStyle: Longint; X, Y, CX, CY: Integer;
  hParent: HWND;  nID: Integer; hInst: THandle; hBuddy: HWND;
  nUpper, nLower, nPos: Integer): HWND; stdcall;external comctl name 'CreateUpDownControl';
function CreateToolBarEx(Wnd: HWnd; ws: Longint; ID: UINT;
  Bitmaps: Integer; BMInst: THandle; BMID: Cardinal; Buttons: PTBButton;
  NumButtons: Integer; dxButton, dyButton: Integer;
  dxBitmap, dyBitmap: Integer; StructSize: UINT): HWnd; stdcall;external comctl name 'CreateToolbarEx';

procedure DrawStatusText; external comctl name 'DrawStatusTextA';

{ Image List }
function ImageList_Create; external comctl name 'ImageList_Create';
function ImageList_Destroy; external comctl name 'ImageList_Destroy';
function ImageList_GetImageCount; external comctl name 'ImageList_GetImageCount';
function ImageList_Add; external comctl name 'ImageList_Add';
function ImageList_ReplaceIcon; external comctl name 'ImageList_ReplaceIcon';
function ImageList_SetBkColor; external comctl name 'ImageList_SetBkColor';
function ImageList_GetBkColor; external comctl name 'ImageList_GetBkColor';
function ImageList_SetOverlayImage; external comctl name 'ImageList_SetOverlayImage';

function ImageList_AddIcon(ImageList: HImageList; Icon: HIcon): Integer;
begin
  Result := ImageList_ReplaceIcon(ImageList, -1, Icon);
end;

function IndexToOverlayMask(Index: Integer): Integer;
begin
  Result := Index shl 8;
end;

function ImageList_Draw; external comctl name 'ImageList_Draw';

function ImageList_Replace; external comctl name 'ImageList_Replace';
function ImageList_AddMasked; external comctl name 'ImageList_AddMasked';
function ImageList_DrawEx; external comctl name 'ImageList_DrawEx';
function ImageList_Remove; external comctl name 'ImageList_Remove';
function ImageList_GetIcon; external comctl name 'ImageList_GetIcon';
function ImageList_LoadImageA; external comctl name 'ImageList_LoadImageA';
function ImageList_LoadImageW; external comctl name 'ImageList_LoadImageW';
function ImageList_LoadImage; external comctl name 'ImageList_LoadImageA';
function ImageList_BeginDrag; external comctl name 'ImageList_BeginDrag';
function ImageList_EndDrag; external comctl name 'ImageList_EndDrag';
function ImageList_DragEnter; external comctl name 'ImageList_DragEnter';
function ImageList_DragLeave; external comctl name 'ImageList_DragLeave';
function ImageList_DragMove; external comctl name 'ImageList_DragMove';
function ImageList_SetDragCursorImage; external comctl name 'ImageList_SetDragCursorImage';
function ImageList_DragShowNolock; external comctl name 'ImageList_DragShowNolock';
function ImageList_GetDragImage; external comctl name 'ImageList_GetDragImage';

{ macros }
procedure ImageList_RemoveAll(ImageList: HImageList);
begin
  ImageList_Remove(ImageList, -1);
end;

function ImageList_ExtractIcon(Instance: THandle; ImageList: HImageList;
  Image: Integer): HIcon;
begin
  Result := ImageList_GetIcon(ImageList, Image, 0);
end;

function ImageList_LoadBitmap(Instance: THandle; Bmp: PChar;
  CX, Grow: Integer; Mask: TColorRef): HImageList;
begin
  Result := ImageList_LoadImage(Instance, Bmp, CX, Grow, Mask,
    IMAGE_BITMAP, 0);
end;

//function ImageList_Read; external comctl name 'ImageList_Read';
//function ImageList_Write; external comctl name 'ImageList_Write';

function ImageList_GetIconSize; external comctl name 'ImageList_GetIconSize';
function ImageList_SetIconSize; external comctl name 'ImageList_SetIconSize';
function ImageList_GetImageInfo; external comctl name 'ImageList_GetImageInfo';
function ImageList_Merge; external comctl name 'ImageList_Merge';


{ Property Sheets }
{$EXTERNALSYM CreatePropertySheetPageA}
function CreatePropertySheetPageA; external comctl name 'CreatePropertySheetPageA';
{$EXTERNALSYM CreatePropertySheetPageW}
function CreatePropertySheetPageW; external comctl name 'CreatePropertySheetPageW';
{$EXTERNALSYM CreatePropertySheetPage}
function CreatePropertySheetPage; external comctl name 'CreatePropertySheetPageA';
{$EXTERNALSYM DestroyPropertySheetPage}
function DestroyPropertySheetPage; external comctl name 'DestroyPropertySheetPage';
{$EXTERNALSYM PropertySheetA}
function PropertySheetA; external comctl name 'PropertySheetA';
{$EXTERNALSYM PropertySheetW}
function PropertySheetW; external comctl name 'PropertySheetW';
{$EXTERNALSYM PropertySheet}
function PropertySheet; external comctl name 'PropertySheetA';
//-------------------------------------------------------

end.
