unit MyObj;

interface

(*
Aston 1.9.2 SDK
(c) Gladiatros Software, 1999-2006

Fixed several bugs in "ShlObj.pas" from Delphi.
*)

uses
  Windows,
  Messages,
  ShellAPI;

type
  IMalloc = interface(IUnknown)
    ['{00000002-0000-0000-C000-000000000046}']
    function Alloc(cb: Longint): Pointer; stdcall;
    function Realloc(pv: Pointer; cb: Longint): Pointer; stdcall;
    procedure Free(pv: Pointer); stdcall;
    function GetSize(pv: Pointer): Longint; stdcall;
    function DidAlloc(pv: Pointer): Integer; stdcall;
    procedure HeapMinimize; stdcall;
  end;

  PHResult = ^HResult;
  HResult = Integer;

(*  IShellIcon = interface(IUnknown)
    ['{000214E5-0000-0000-C000-000000000046}']
    function GetIconOf(pidl: PItemIDList; flags: UINT;
      out IconIndex: Integer): HResult; stdcall;
  end;
*)

function SHGetMalloc(var ppMalloc: Pointer): HResult; stdcall;
  external shell32 name 'SHGetMalloc';
procedure SHAddToRecentDocs(uFlags: UINT; pv: Pointer); stdcall;
  external shell32 name 'SHAddToRecentDocs';

{ SHGetPathFromIDList }

{ This function assumes the size of the buffer (MAX_PATH). The pidl
  should point to a file system object. }
function SHGetPathFromIDList(pidl: PItemIDList; pszPath: PChar): BOOL; stdcall;
  external shell32 name 'SHGetPathFromIDListA';
{ SHGetSpecialFolderLocation }

{ Caller should call SHFree to free the returned pidl. }

const
{ registry entries for special paths are kept in : }

//  REGSTR_PATH_SPECIAL_FOLDERS   = REGSTR_PATH_EXPLORER + '\Shell Folders';
  CSIDL_DESKTOP                       = $0000;
  CSIDL_INTERNET                      = $0001; 
  CSIDL_PROGRAMS                      = $0002; 
  CSIDL_CONTROLS                      = $0003; 
  CSIDL_PRINTERS                      = $0004; 
  CSIDL_PERSONAL                      = $0005; 
  CSIDL_FAVORITES                     = $0006;
  CSIDL_STARTUP                       = $0007; 
  CSIDL_RECENT                        = $0008; 
  CSIDL_SENDTO                        = $0009;
  CSIDL_BITBUCKET                     = $000a;
  CSIDL_STARTMENU                     = $000b; 
  CSIDL_DESKTOPDIRECTORY              = $0010;
  CSIDL_DRIVES                        = $0011; 
  CSIDL_NETWORK                       = $0012; 
  CSIDL_NETHOOD                       = $0013;
  CSIDL_FONTS                         = $0014; 
  CSIDL_TEMPLATES                     = $0015;
  CSIDL_COMMON_STARTMENU              = $0016;
  CSIDL_COMMON_PROGRAMS               = $0017;
  CSIDL_COMMON_STARTUP                = $0018;
  CSIDL_COMMON_DESKTOPDIRECTORY       = $0019;
  CSIDL_APPDATA                       = $001a;
  CSIDL_PRINTHOOD                     = $001b;

  CSIDL_ALTSTARTUP                = $001d;         // DBCS
  CSIDL_COMMON_ALTSTARTUP         = $001e;         // DBCS
  CSIDL_COMMON_FAVORITES          = $001f;
  CSIDL_INTERNET_CACHE            = $0020;
  CSIDL_COOKIES                   = $0021;
  CSIDL_HISTORY                   = $0022;

function SHGetSpecialFolderLocation(hwndOwner: HWND; nFolder: Integer;
    var ppidl: PItemIDList): HResult; stdcall;
  external shell32 name 'SHGetSpecialFolderLocation';

const
  STRRET_WSTR         = $0000;          { Use STRRET.pOleStr }
  STRRET_OFFSET       = $0001;          { Use STRRET.uOffset to Ansi }
  STRRET_CSTR         = $0002;          { Use STRRET.cStr }
  
type
  PIID = PGUID;
  TIID = TGUID;
  PCLSID = PGUID;
  TCLSID = TGUID;
  PSTRRet = ^TStrRet;
  TSTRRET = record
     uType: UINT;              { One of the STRRET_* values }
     case Integer of
       0: (pOleStr: LPWSTR);                    { must be freed by caller of GetDisplayNameOf }
       1: (pStr: LPSTR);                        { NOT USED }
       2: (uOffset: UINT);                      { Offset into SHITEMID (ANSI) }
       3: (cStr: array[0..MAX_PATH-1] of Char); { Buffer to fill in }
    end;

  IEnumIDList = interface(IUnknown)
    ['{000214F2-0000-0000-C000-000000000046}']
    function Next(celt: ULONG; out rgelt: PItemIDList;
      pceltFetched: PULONG): HResult; stdcall;
    function Skip(celt: ULONG): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Clone(out ppenum: IEnumIDList): HResult; stdcall;
  end;

  IShellFolder = interface(IUnknown)
    ['{000214E6-0000-0000-C000-000000000046}']
    function ParseDisplayName(hwndOwner: HWND;
      pbcReserved: Pointer; lpszDisplayName: PWideChar; out pchEaten: ULONG;
      out ppidl: PItemIDList; var dwAttributes: ULONG): HResult; stdcall;
    function EnumObjects(hwndOwner: HWND; grfFlags: DWORD;
      out EnumIDList: pointer): HResult; stdcall;
    function BindToObject(pidl: PItemIDList; pbcReserved: Pointer;
      const riid: TIID; out ppvOut: Pointer): HResult; stdcall;
    function BindToStorage(pidl: PItemIDList; pbcReserved: Pointer;
      const riid: TIID; out ppvObj: Pointer): HResult; stdcall;
    function CompareIDs(lParam: LPARAM;
      pidl1, pidl2: PItemIDList): HResult; stdcall;
    function CreateViewObject(hwndOwner: HWND; const riid: TIID;
      out ppvOut: Pointer): HResult; stdcall;
    function GetAttributesOf(cidl: UINT; var apidl: PItemIDList; 
      var rgfInOut: UINT): HResult; stdcall;
    function GetUIObjectOf(hwndOwner: HWND; cidl: UINT; var apidl: PItemIDList;
      const riid: TIID; prgfInOut: Pointer; out ppvOut: Pointer): HResult; stdcall;
    function GetDisplayNameOf(pidl: PItemIDList; uFlags: DWORD;
      var lpName: TStrRet): HResult; stdcall;
    function SetNameOf(hwndOwner: HWND; pidl: PItemIDList; lpszName: PWideChar;
      uFlags: DWORD; var ppidlOut: PItemIDList): HResult; stdcall;
  end;

{ Helper function which returns a IShellFolder interface to the desktop
  folder. This is equivalent to call CoCreateInstance with CLSID_ShellDesktop. }

function SHGetDesktopFolder(var ppshf: pointer): HResult; stdcall;
  external shell32 name 'SHGetDesktopFolder';

type

  IShellLinkA = interface(IUnknown) { sl }
    ['{000214EE-0000-0000-C000-000000000046}']
    function GetPath(pszFile: PAnsiChar; cchMaxPath: Integer;
      var pfd: TWin32FindData; fFlags: DWORD): HResult; stdcall;
    function GetIDList(var ppidl: PItemIDList): HResult; stdcall;
    function SetIDList(pidl: PItemIDList): HResult; stdcall;
    function GetDescription(pszName: PAnsiChar; cchMaxName: Integer): HResult; stdcall;
    function SetDescription(pszName: PAnsiChar): HResult; stdcall;
    function GetWorkingDirectory(pszDir: PAnsiChar; cchMaxPath: Integer): HResult; stdcall;
    function SetWorkingDirectory(pszDir: PAnsiChar): HResult; stdcall;
    function GetArguments(pszArgs: PAnsiChar; cchMaxPath: Integer): HResult; stdcall;
    function SetArguments(pszArgs: PAnsiChar): HResult; stdcall;
    function GetHotkey(var pwHotkey: Word): HResult; stdcall;
    function SetHotkey(wHotkey: Word): HResult; stdcall;
    function GetShowCmd(out piShowCmd: Integer): HResult; stdcall;
    function SetShowCmd(iShowCmd: Integer): HResult; stdcall;
    function GetIconLocation(pszIconPath: PAnsiChar; cchIconPath: Integer;
      out piIcon: Integer): HResult; stdcall;
    function SetIconLocation(pszIconPath: PAnsiChar; iIcon: Integer): HResult; stdcall;
    function SetRelativePath(pszPathRel: PAnsiChar; dwReserved: DWORD): HResult; stdcall;
    function Resolve(Wnd: HWND; fFlags: DWORD): HResult; stdcall;
    function SetPath(pszFile: PAnsiChar): HResult; stdcall;
  end;

  IPersist = interface(IUnknown)
    ['{0000010C-0000-0000-C000-000000000046}']
    function GetClassID(out classID: TCLSID): HResult; stdcall;
  end;

  IPersistFile = interface(IPersist)
    ['{0000010B-0000-0000-C000-000000000046}']
    function IsDirty: HResult; stdcall;
    function Load(pszFileName: PWideChar; dwMode: Longint): HResult;
      stdcall;
    function Save(pszFileName: PWideChar; fRemember: BOOL): HResult;
      stdcall;
    function SaveCompleted(pszFileName: PWideChar): HResult;
      stdcall;
    function GetCurFile(out pszFileName: PWideChar): HResult;
      stdcall;
  end;


  IExtractIconA = interface(IUnknown)
    ['{000214EB-0000-0000-C000-000000000046}']
    function GetIconLocation(uFlags: UINT; szIconFile: PAnsiChar; cchMax: UINT;
      out piIndex: Integer; out pwFlags: UINT): HResult; stdcall;
    function Extract(pszFile: PAnsiChar; nIconIndex: UINT;
      out phiconLarge, phiconSmall: HICON; nIconSize: UINT): HResult; stdcall;
  end;
  IExtractIconW = interface(IUnknown)
    ['{000214FA-0000-0000-C000-000000000046}']
    function GetIconLocation(uFlags: UINT; szIconFile: PWideChar; cchMax: UINT;
      out piIndex: Integer; out pwFlags: UINT): HResult; stdcall;
    function Extract(pszFile: PWideChar; nIconIndex: UINT;
      out phiconLarge, phiconSmall: HICON; nIconSize: UINT): HResult; stdcall;
  end;




const GIL_OPENICON     = $0001;      // allows containers to specify an "open" look
      GIL_FORSHELL     = $0002;      // icon is to be displayed in a ShellFolder
      GIL_ASYNC        = $0020;      // this is an async extract, return E_ASYNC

// GetIconLocation() return flags
const GIL_SIMULATEDOC  = $0001;      // simulate this document icon for this
      GIL_PERINSTANCE  = $0002;      // icons from this class are per instance (each file has its own)
      GIL_PERCLASS     = $0004;      // icons from this class per class (shared for all files of this type)
      GIL_NOTFILENAME  = $0008;      // location is not a filename, must call ::Extract
      GIL_DONTCACHE    = $0010;      // this icon should not be cached


  IID_IUnknown: TGUID = (
    D1:$00000000;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));

  IID_IExtractIconA: TGUID = (
    D1:$000214EB; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IShellLinkA: TGUID = (
    D1:$000214EE; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IPersistFile: TGUID = (
    D1:$0000010B;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  CLSID_ShellLink: TGUID = (
    D1:$00021401; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IShellIcon: TGUID = (
    D1:$000214E5; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));

  IID_IShellFolder: TGUID = (
    D1:$000214E6; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));


//-----------------------------------------------------------

const
  ole32    = 'ole32.dll';

  CLSCTX_INPROC_SERVER	 = 1;
  CLSCTX_INPROC_HANDLER	 = 2;
  CLSCTX_LOCAL_SERVER	 = 4;

//function CoInitialize(pvReserved: Pointer): HResult; stdcall;
//procedure CoUninitialize; stdcall;
//function CoCreateInstance(const clsid: TCLSID; unkOuter: IUnknown;
//  dwClsContext: Longint; const iid: TIID; var pv): HResult; stdcall;
//procedure CoTaskMemFree(pv: Pointer); stdcall;

//-------------------------------------------------------------

const SHCNE_RENAMEITEM          = $00000001;
      SHCNE_CREATE              = $00000002;
      SHCNE_DELETE              = $00000004;
      SHCNE_MKDIR               = $00000008;
      SHCNE_RMDIR               = $00000010;
      SHCNE_MEDIAINSERTED       = $00000020;
      SHCNE_MEDIAREMOVED        = $00000040;
      SHCNE_DRIVEREMOVED        = $00000080;
      SHCNE_DRIVEADD            = $00000100;
      SHCNE_NETSHARE            = $00000200;
      SHCNE_NETUNSHARE          = $00000400;
      SHCNE_ATTRIBUTES          = $00000800;
      SHCNE_UPDATEDIR           = $00001000;
      SHCNE_UPDATEITEM          = $00002000;
      SHCNE_SERVERDISCONNECT    = $00004000;
      SHCNE_UPDATEIMAGE         = $00008000;
      SHCNE_DRIVEADDGUI         = $00010000;
      SHCNE_RENAMEFOLDER        = $00020000;
      SHCNE_FREESPACE           = $00040000;
      SHCNE_EXTENDED_EVENT      = $00080000; // Extended Event.

      SHCNE_ASSOCCHANGED        = $08000000;

      SHCNE_DISKEVENTS          = $0002381F;
      SHCNE_GLOBALEVENTS        = $0C0581E0; // Events that dont match pidls first
      SHCNE_ALLEVENTS           = $7FFFFFFF;
      SHCNE_INTERRUPT           = $80000000; // The presence of this flag indicates
                                             // that the event was generated by an
                                             // interrupt.  It is stripped out before
                                             // the clients of SHCNNotify_ see it.

      SHCNEE_THEMECHANGED       = $00000001; // The theme changed

// Flags
// uFlags & SHCNF_TYPE is an ID which indicates what dwItem1 and dwItem2 mean
const SHCNF_IDLIST      = $0000; // LPITEMIDLIST
      SHCNF_PATH        = $0001; // path name
      SHCNF_PRINTER     = $0002; // printer friendly name
      SHCNF_DWORD       = $0003; // DWORD
      SHCNF_PATHW       = $0005; // path name
      SHCNF_PRINTERW    = $0006; // printer friendly name
      SHCNF_TYPE        = $00FF;
      SHCNF_FLUSH       = $1000;
      SHCNF_FLUSHNOWAIT = $2000;

function  SHChangeNotify( wEventId: Longint;  uFlags: UINT;  dwItem1, dwItem2: Pointer ): HResult; stdcall;
  external shell32 name 'SHChangeNotify';
const
  SHCONTF_FOLDERS         = 32;       { for shell browser }
  SHCONTF_NONFOLDERS      = 64;       { for default view }
  SHCONTF_INCLUDEHIDDEN   = 128;      { for hidden/system objects }

  SHGDN_NORMAL           = 0;         { default (display purpose) }
  SHGDN_INFOLDER         = 1;         { displayed under a folder (relative) }
  SHGDN_INCLUDE_NONFILESYS = $2000;   { if not set, display names for shell
                                        name space items that are not in the}
  SHGDN_FORADDRESSBAR      = $4000;     { for displaying in the address (drives dropdown) bar }
  SHGDN_FORPARSING         = $8000;     { for ParseDisplayName or path }

type
  BFFCALLBACK = function(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): Integer stdcall;
  TFNBFFCallBack = type BFFCALLBACK;

  PBrowseInfoA = ^TBrowseInfoA;
  PBrowseInfoW = ^TBrowseInfoW;
  PBrowseInfo = PBrowseInfoA;
  _browseinfoA = record
    hwndOwner: HWND;
    pidlRoot: PItemIDList;
    pszDisplayName: PAnsiChar;  { Return display name of item selected. }
    lpszTitle: PAnsiChar;      { text to go in the banner over the tree. }
    ulFlags: UINT;           { Flags that control the return stuff }
    lpfn: TFNBFFCallBack;
    lParam: LPARAM;          { extra info that's passed back in callbacks }
    iImage: Integer;         { output var: where to return the Image index. }
  end;
  _browseinfoW = record
    hwndOwner: HWND;
    pidlRoot: PItemIDList;
    pszDisplayName: PWideChar;  { Return display name of item selected. }
    lpszTitle: PWideChar;      { text to go in the banner over the tree. }
    ulFlags: UINT;           { Flags that control the return stuff }
    lpfn: TFNBFFCallBack;
    lParam: LPARAM;          { extra info that's passed back in callbacks }
    iImage: Integer;         { output var: where to return the Image index. }
  end;
  _browseinfo = _browseinfoA;
  TBrowseInfoA = _browseinfoA;
  TBrowseInfoW = _browseinfoW;
  TBrowseInfo = TBrowseInfoA;
  BROWSEINFOA = _browseinfoA;
  BROWSEINFOW = _browseinfoW;
  BROWSEINFO = BROWSEINFOA;

const
  BIF_RETURNONLYFSDIRS   = $0001;  { For finding a folder to start document searching }
  BIF_DONTGOBELOWDOMAIN  = $0002;  { For starting the Find Computer }
  BIF_STATUSTEXT         = $0004;
  BIF_RETURNFSANCESTORS  = $0008;
  BIF_EDITBOX            = $0010;
  BIF_VALIDATE           = $0020;  { insist on valid result (or CANCEL) }

  BIF_BROWSEFORCOMPUTER  = $1000;  { Browsing for Computers. }
  BIF_BROWSEFORPRINTER   = $2000;  { Browsing for Printers }
  BIF_BROWSEINCLUDEFILES = $4000;  { Browsing for Everything }

{ message from browser }

   BFFM_INITIALIZED       = 1;
  BFFM_SELCHANGED        = 2;
  BFFM_VALIDATEFAILEDA   = 3;   { lParam:szPath ret:1(cont),0(EndDialog) }
  BFFM_VALIDATEFAILEDW   = 4;   { lParam:wzPath ret:1(cont),0(EndDialog) }

{ messages to browser }

  BFFM_SETSTATUSTEXTA         = WM_USER + 100;
  BFFM_ENABLEOK               = WM_USER + 101;
  BFFM_SETSELECTIONA          = WM_USER + 102;
  BFFM_SETSELECTIONW          = WM_USER + 103;
  BFFM_SETSTATUSTEXTW         = WM_USER + 104;

  BFFM_VALIDATEFAILED     = BFFM_VALIDATEFAILEDA;
  BFFM_SETSTATUSTEXT      = BFFM_SETSTATUSTEXTA;
  BFFM_SETSELECTION       = BFFM_SETSELECTIONA;

function SHBrowseForFolder(var lpbi: TBrowseInfo): PItemIDList; stdcall;
  external shell32 name 'SHBrowseForFolderA';
function SHLoadInProc(rclsid: PCLSID): HRESULT; stdcall;
  external shell32 name 'SHLoadInProc';
function SHGetInstanceExplorer(var ppUnk: pointer): HResult; stdcall;
  external shell32 name 'SHGetInstanceExplorer';

type
  POleCmd = ^TOleCmd; //???
  _tagOLECMD = record
    cmdID: Cardinal;
    cmdf: Longint;
  end;
  OLECMD = _tagOLECMD;
  TOleCmd = _tagOLECMD;

  POleCmdText = ^TOleCmdText; //???
  _tagOLECMDTEXT = record
    cmdtextf: Longint;
    cwActual: Cardinal;
    cwBuf: Cardinal;         // size in wide chars of the buffer for text
    rgwz: array [0..0] of WideChar; // Array into which callee writes the text
  end;
  OLECMDTEXT = _tagOLECMDTEXT;
  TOleCmdText = _tagOLECMDTEXT;

  IOleCommandTarget = interface(IUnknown)
    ['{b722bccb-4e68-101b-a2bc-00aa00404770}']
    function QueryStatus(CmdGroup: PGUID; cCmds: Cardinal;
      prgCmds: POleCmd; CmdText: POleCmdText): HResult; stdcall;
    function Exec(CmdGroup: PGUID; nCmdID, nCmdexecopt: DWORD;
      vaIn: pointer; vaOut: pointer): HResult; stdcall;
  end;

const
  IID_IContextMenu: TGUID = (
    D1:$000214E4; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IContextMenu2: TGUID = (
    D1:$000214F4; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  SID_IContextMenu       = '{000214E4-0000-0000-C000-000000000046}';
  SID_IContextMenu2      = '{000214F4-0000-0000-C000-000000000046}';

  CMF_NORMAL             = $00000000;
  CMF_DEFAULTONLY        = $00000001;
  CMF_VERBSONLY          = $00000002;
  CMF_EXPLORE            = $00000004;
  CMF_NOVERBS            = $00000008;
  CMF_CANRENAME          = $00000010;
  CMF_NODEFAULT          = $00000020;
  CMF_INCLUDESTATIC      = $00000040;
  CMF_RESERVED           = $FFFF0000;      { View specific }

  GCS_VERBA            = $00000000;     { canonical verb }
  GCS_HELPTEXTA        = $00000001;     { help text (for status bar) }
  GCS_VALIDATEA        = $00000002;     { validate command exists }
  GCS_VERBW            = $00000004;     { canonical verb (unicode) }
  GCS_HELPTEXTW        = $00000005;     { help text (unicode version) }
  GCS_VALIDATEW        = $00000006;     { validate command exists (unicode) }
  GCS_UNICODE          = $00000004;     { for bit testing - Unicode string }

  GCS_VERB            = GCS_VERBA;
  {$EXTERNALSYM GCS_HELPTEXT}
  GCS_HELPTEXT        = GCS_HELPTEXTA;
  {$EXTERNALSYM GCS_VALIDATE}
  GCS_VALIDATE        = GCS_VALIDATEA;


  CMDSTR_NEWFOLDER       = 'NewFolder';
  CMDSTR_VIEWLIST        = 'ViewList';
  CMDSTR_VIEWDETAILS     = 'ViewDetails';

  CMIC_MASK_HOTKEY            = SEE_MASK_HOTKEY;
  CMIC_MASK_ICON              = SEE_MASK_ICON;
  CMIC_MASK_FLAG_NO_UI        = SEE_MASK_FLAG_NO_UI;
  CMIC_MASK_UNICODE           = SEE_MASK_UNICODE;
  CMIC_MASK_NO_CONSOLE        = SEE_MASK_NO_CONSOLE;
  CMIC_MASK_ASYNCOK           = SEE_MASK_ASYNCOK;

  CMIC_MASK_PTINVOKE          = $20000000;

type  
  PCMInvokeCommandInfo = ^TCMInvokeCommandInfo;
  _CMINVOKECOMMANDINFO = record
    cbSize: DWORD;        { must be sizeof(CMINVOKECOMMANDINFO) }
    fMask: DWORD;         { any combination of CMIC_MASK_* }
    hwnd: HWND;           { might be NULL (indicating no owner window) }
    lpVerb: LPCSTR;       { either a string of MAKEINTRESOURCE(idOffset) }
    lpParameters: LPCSTR; { might be NULL (indicating no parameter) }
    lpDirectory: LPCSTR;  { might be NULL (indicating no specific directory) }
    nShow: Integer;       { one of SW_ values for ShowWindow() API }
    dwHotKey: DWORD;
    hIcon: THandle;
  end;
  TCMInvokeCommandInfo = _CMINVOKECOMMANDINFO;
  CMINVOKECOMMANDINFO = _CMINVOKECOMMANDINFO;

  IContextMenu = interface(IUnknown)
    [SID_IContextMenu]
    function QueryContextMenu(Menu: HMENU;
      indexMenu, idCmdFirst, idCmdLast, uFlags: UINT): HResult; stdcall;
    function InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult; stdcall;
    function GetCommandString(idCmd, uType: UINT; pwReserved: PUINT;
      pszName: LPSTR; cchMax: UINT): HResult; stdcall;
  end;

  IContextMenu2 = interface(IContextMenu)
    [SID_IContextMenu2]
    function HandleMenuMsg(uMsg: UINT; WParam, LParam: Integer): HResult; stdcall;
  end;

const
  SHCNF_ACCEPT_INTERRUPTS     = $0001;
  SHCNF_ACCEPT_NON_INTERRUPTS = $0002;
  SHCNF_NO_PROXY              = $8000;

type
  TNotifyRegister = packed record
    pidlPath:      PItemIDList;
    bWatchSubtree: BOOL;
  end;
  PNotifyRegister = ^TNotifyRegister;

  TTwoPIDLArray = packed record
    PIDL1: PItemIDList;
    PIDL2: PItemIDList;
  end;
  PTwoPIDLArray = ^TTwoPIDLArray;

  TDWORDItemID = packed record
    cb:      Word;
    dwItem1: DWORD;
    dwItem2: DWORD;
  end;
  PDWORDItemID = ^TDWORDItemID;

function SHChangeNotifyRegister(Window: HWND; Flags: DWORD; EventMask: ULONG; MessageID: UINT;
                                ItemCount: DWORD; var Items: TNotifyRegister): THandle; stdcall;
  external shell32 index $2;
function SHChangeNotifyDeregister(Notification: THandle): BOOL; stdcall;
  external shell32 index $4;
//function SHChangeNotification_Lock(MemoryMap: THandle; ProcessID: DWORD; var PIDLs: PTwoPIDLArray; var EventID: ULONG): THandle; stdcall;
//function SHChangeNotification_Unlock(Lock: THandle): BOOL; stdcall;



implementation
end.
