unit st_api;


(*
Aston 1.9.2 SDK
(c) Gladiatros Software, 1999-2006
starter.dll interface
*)

interface

uses
  Windows,
  ShellAPI,
  AstonSDK;

//INTERNAL
procedure ReadRC(RCFileName: PChar; Core: PRing1);
  external apidll name 'ReadRC';
procedure ReadTip(RCFileName, szBarTip: PChar);
  external apidll name 'ReadTip';
procedure ResetPictureCache(CacheOptions:UINT);
  external apidll name 'ResetPictureCache';
procedure InitAstonAPI;
  external apidll name 'InitAstonAPI';
procedure DoneAstonAPI;
  external apidll name 'DoneAstonAPI';

function Amalloc(size: Integer): Pointer;stdcall;
  external apidll name 'Amalloc';
procedure Afree(p: Pointer);stdcall;
  external apidll name 'Afree';
function Arealloc(p: Pointer; size: Integer): Pointer;stdcall;
  external apidll name 'Arealloc';

function strcopy(Dest, Source: PChar): PChar;
  external apidll name 'strcopy';
function strecopy(Dest, Source: PChar): PChar;
  external apidll name 'strecopy';
{function strlen(Str: PChar): DWORD;
  external apidll name 'strlen';}
function strmoven(Dest, Source: PChar; Count: integer):PChar;
  external apidll name 'strmoven';
function IsPSTREmpty(p:PChar):bool;
  external apidll name 'IsPSTREmpty';
procedure ResetFontCache(CacheOptions:UINT);
  external apidll name 'ResetFontCache';

{$IFDEF Debug}
procedure WriteDebugStr(P:PChar; ln:boolean);
  external apidll name 'WriteDebugStr';
procedure WriteDebugInt(i: integer; ln:boolean);
  external apidll name 'WriteDebugInt';
procedure Prn(i:integer);
  external apidll name 'Prn';
{$ENDIF}
//EOF INTERNAL

{---------------------------------------------------------------------}
procedure LoadImageEx(Picture:PPicture);stdcall;
  external apidll name 'LoadImageEx';
procedure MakeMask(Picture:PPicture);stdcall;
  external apidll name 'MakeMask';

procedure GetShellIconSize(var Large, Small:integer);stdcall;
  external apidll name 'GetShellIconSize';{obsolete}
procedure GetShellIconBPP(var Large, Small, BPP:integer);stdcall
  external apidll name 'GetShellIconBPP';

function GetRegInt(Key:HKEY; szValue:PChar; iDefault: integer):integer;stdcall;
  external apidll name 'GetRegInt';

{---------------------------------------------------------------------}
procedure DrawPicture(DC, memDC:hDC; X,Y: integer; Picture:PPicture);stdcall;
  external apidll name 'DrawPicture';
procedure DrawSkinTrans(DC, memDC: HDC; index, id: integer; Core: PRing1);stdcall;
  external apidll name 'DrawSkinTrans';
procedure DrawSkin(DC, memDC: hDC; var DstRect, SrcRect, WinRect: TRect;
 Picture:PPicture; Brush: hBrush; uFlags:UINT);stdcall;
  external apidll name 'DrawSkin';
procedure StretchSkin(memDC: hDC; var NewSkin: TPicture; Skin: PPicture; cx, cy: integer);stdcall;
  external apidll name 'StretchSkin';
function BitmapToRegion(hBMP:hBitmap; cBGRTransparentColor:COLORREF;
                        xoffset, yoffset:integer):hrgn;stdcall;
  external apidll name 'BitmapToRegion';
{---------------------------------------------------------------------}
procedure FreeNode(Node: pNode);stdcall;
  external apidll name 'FreeNode';
procedure FreePicture(Picture: PPicture);stdcall;
  external apidll name 'FreePicture';
{---------------------------------------------------------------------}
procedure Run(Path, WorkDir, Param: PChar; nCmdShow: integer; dwHotKey: DWORD);stdcall;
  external apidll name 'Run';

procedure RunSHFolder(nFolder:integer; Verb:PChar; Mask:ULONG);stdcall;
  external apidll name 'RunSHFolder';
function RunSCF(p: PChar): bool;stdcall;
  external apidll name 'RunSCF';
{---------------------------------------------------------------------}
procedure StrCopyEx(Dest, Src: PChar);stdcall;
  external apidll name 'StrCopyEx';
procedure Quote(P:PChar);stdcall;
  external apidll name 'Quote';
procedure Unquote(P:PChar);stdcall;
  external apidll name 'Unquote';
function GetParamStr(P: PChar): PChar;stdcall;
  external apidll name 'GetParamStr';
procedure CheckInt(var c:integer;a, b, d:integer);stdcall;
  external apidll name 'CheckInt';
{---------------------------------------------------------------------}
procedure GetFontHandle(Font: PFont; deffont: hFont);stdcall;
  external apidll name 'GetFontHandle';
procedure FreeFont(Font: PFont);stdcall;
  external apidll name 'FreeFont';
{---------------------------------------------------------------------}
function OpenCFGw(RCFileName: PChar; CFG: PCFG):integer;stdcall;
  external apidll name 'OpenCFGw';
function CloseCFGw(RCFileName: PChar; Backup:BOOL; CFG: PCFG):integer;stdcall;
  external apidll name 'CloseCFGw';
{---------------------------------------------------------------------}
function OpenCFGr(RCFileName: PChar; CFG: PCFG):integer;stdcall;
  external apidll name 'OpenCFGr';
procedure CloseCFGr(CFG: PCFG);stdcall;
  external apidll name 'CloseCFGr';
function FindSection(szSection:PChar; Opt: UINT; CFG: PCFG):integer;stdcall;
  external apidll name 'FindSection';
function GetCFGString(szKey, szDefault, lpBuffer:PChar; BufferSize:integer; CFG: PCFG):integer;stdcall;
  external apidll name 'GetCFGString';
function GetCFGInt(szKey:PChar; nDefault: integer; CFG: PCFG):integer;stdcall;
  external apidll name 'GetCFGInt';
function GetCFGHex(szKey:PChar; nDefault: UINT; CFG: PCFG):UINT;stdcall;
  external apidll name 'GetCFGHex';
function GetCFGBool(szKey:PChar; bDefault: BOOL; CFG: PCFG):BOOL;stdcall;
  external apidll name 'GetCFGBool';
function GetCFGPic(szKey:PChar; Picture:PPicture; CFG: PCFG):integer;stdcall;
  external apidll name 'GetCFGPic';
procedure GetCFGFont(szKey:PChar; Font: PFont; CFG: PCFG);stdcall;
  external apidll name 'GetCFGFont';
{---------------------------------------------------------------------}
procedure CreateSection(szSection:PChar;  CFG: PCFG);stdcall;
  external apidll name 'CreateSection';
function Scan(szKey:PChar; CFG:PCFG):integer;stdcall;
  external apidll name 'Scan';
procedure CreateKey(szKey:PChar;  CFG: PCFG);stdcall;
  external apidll name 'CreateKey';
procedure InsertString(pBuffer:PChar; BufferLen: integer; CFG: PCFG);stdcall;
  external apidll name 'InsertString';
{---------------------------------------------------------------------}
procedure SetCFGString(szKey:PChar; pBuffer:PChar; CFG: PCFG);stdcall;
  external apidll name 'SetCFGString';
procedure SetCFGInt(szKey:PChar; iInt:integer; CFG: PCFG);stdcall;
  external apidll name 'SetCFGInt';
procedure SetCFGHex(szKey:PChar; uHex:UINT; CFG: PCFG);stdcall;
  external apidll name 'SetCFGHex';
procedure SetCFGPic(szKey:PChar; Picture:PPicture; CFG: PCFG);stdcall;
  external apidll name 'SetCFGPic';
procedure SetCFGFont(szKey:PChar; Font:PFont; CFG: PCFG);stdcall;
  external apidll name 'SetCFGFont';

procedure PackNodeList(var Data:PNodeList; count, max: integer);stdcall;
  external apidll name 'PackNodeList';
procedure GetNodeList(var Data:PNodeList; var count, max: integer);stdcall;
  external apidll name 'GetNodeList';
procedure FreeNodeList(var Data:PNodeList; var count, max: integer);stdcall;
  external apidll name 'FreeNodeList';
function FindFirstNode(CFG:PCFG):integer;stdcall;
  external apidll name 'FindFirstNode';
function FindNextNode(CFG:PCFG):integer;stdcall;
  external apidll name 'FindNextNode';
procedure NewNode(Level:integer; CFG:PCFG);stdcall;
  external apidll name 'NewNode';
procedure DeleteKey(szKey:PChar;  CFG: PCFG);stdcall;
  external apidll name 'DeleteKey';

procedure ErrorBox(Caption:PChar);stdcall;
  external apidll name 'ErrorBox';
procedure NotifyTip(hToolTip, Window: HWnd; Msg: UINT; wParam: WParam;
 lParam: LParam);stdcall;
  external apidll name 'NotifyTip';
{---------------------------------------------------------------------}
{--1.5----------------------------------------------------------------}
function InitExtractor(szFileName: Pchar; var Module: TModuleEx):bool;stdcall;
  external apidll name 'InitExtractor';
function ReadIconFromModule(const M: TModuleEx; IconIndex:integer): PMEMICON;stdcall;
  external apidll name 'ReadIconFromModule';
function AdjustIcon(const lpIR: PMEMICON): bool;stdcall;
  external apidll name 'AdjustIcon';
procedure FreeExIcon(p:PMEMICON);stdcall;
  external apidll name 'FreeExIcon';
procedure MakeHIcon(exIcon: PMEMICON; p: PPicture);stdcall;
  external apidll name 'MakeHIcon';
function IconMCount(var M: TModuleEx): integer;stdcall;
  external apidll name 'IconMCount';
procedure DoneExtractor(var Module: TModuleEx);stdcall;
  external apidll name 'DoneExtractor';
{---------------------------------------------------------------------}
function DefCharSet: BYTE; stdcall;
  external apidll name 'DefCharSet';
{---------------------------------------------------------------------}
function FileExists(szFileName: PChar): BOOL; stdcall;
  external apidll name 'FileExists';
function DirExists(Dir:PChar):bool; stdcall;
  external apidll name 'DirExists';
{---------------------------------------------------------------------}
function SHAlloc(cb: integer): pointer; stdcall;
  external apidll name 'SHAlloc';
procedure SHFree(p: pointer); stdcall;
  external apidll name 'SHFree';
{---------------------------------------------------------------------}
{-----1.6-------------------------------------------------------------}
function AllowForeWnd(Wnd: HWND): bool; stdcall;
  external apidll name 'AllowForeWnd';
function SetForeWndFix(Wnd: hWnd; os: POSVersionInfo): HWND; stdcall;
  external apidll name 'SetForeWndFix';
function SwitchFix(Wnd: hWnd; os: POSVERSIONINFO): HWND; stdcall;
  external apidll name 'SwitchFix';
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
function LayeredStyle(DC: HDC; bAlpha: BYTE): UINT; stdcall;
  external apidll name 'LayeredStyle';
function SetLayered(wnd:HWND; crKey:COLORREF; bAlpha: BYTE; dwFlags: DWORD): BOOL; stdcall;
  external apidll name 'SetLayered';
function CanAnimate(): BOOL; stdcall;
  external apidll name 'CanAnimate';
function AnimateWnd(wnd: HWND; dwTime: DWORD; dwFlags: DWORD): BOOL; stdcall;
  external apidll name 'AnimateWnd';
{-----1.7-------------------------------------------------------------}
procedure JPGtoBMP(JPEG: PChar; BMP:PChar);stdcall;
  external apidll name 'JPGtoBMP';
function BMPtoJPG(BMP:PChar;JPEG: PChar;FQuality:integer;
        FGrayscale,ProgressiveEncoding:boolean):DWORD;stdcall;
  external apidll name 'BMPtoJPG';
procedure LoadJPG(JPEG: PChar; p: PPicture);stdcall;
  external apidll name 'LoadJPG';
{-----1.9.2-----------------------------------------------------------}
procedure GetCFGRect(szKey:PChar; var r: TRect; CFG: PCFG)stdcall;
  external apidll name 'GetCFGRect';
procedure SetCFGRect(szKey:PChar; r: TRect; CFG: PCFG)stdcall;
  external apidll name 'SetCFGRect';
procedure GetCFGPoint(szKey:PChar; var p: TPoint; CFG: PCFG)stdcall;
  external apidll name 'GetCFGPoint';
procedure SetCFGPoint(szKey:PChar; p: TPoint; CFG: PCFG)stdcall;
  external apidll name 'SetCFGPoint';
procedure RunEx(Path, WorkDir, Param: PChar; nCmdShow: integer; dwHotKey: DWORD; monitor:THANDLE);stdcall;
  external apidll name 'RunEx';
procedure GetFontHandleEx(Font: PFontEx; deffont: hFont);stdcall;
  external apidll name 'GetFontHandleEx';
procedure GetCFGFontEx(szKey:PChar; Font: PFontEx; CFG: PCFG);stdcall;
  external apidll name 'GetCFGFontEx';
procedure SetCFGFontEx(szKey:PChar; Font:PFontEx; CFG: PCFG);stdcall;
  external apidll name 'SetCFGFontEx';
procedure FreeFontEx(Font: PFontEx);stdcall;
  external apidll name 'FreeFontEx';
procedure SetDrawDesktop(adr:pointer);stdcall;
    external apidll name 'SetDrawDesktop';
procedure DrawDesktop(Window:HWND; DC:HDC; rcPaint:PRect);stdcall;
    external apidll name 'DrawDesktop';
procedure ClearNewOptionInSection(Section:Pchar; CFG: PCFG);stdcall;
    external apidll name 'ClearNewOptionInSection';
procedure ClearNewOption(CFG: PCFG);stdcall;
    external apidll name 'ClearNewOption';
procedure LoadJPGZip(zh:HZIP; index:integer; ze:PZIPENTRY; pic:PPicture);stdcall;
    external apidll name 'LoadJPGZip';
procedure LoadBMPZip(zh:HZIP; index:integer; ze:PZIPENTRY; pic:PPicture);stdcall;
    external apidll name 'LoadBMPZip';
procedure LoadPngZip(zh:HZIP; index_:integer; ze:PZIPENTRY;  Picture:PPicture);stdcall;
    external apidll name 'LoadPngZip';


implementation
end.
