#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef ASTONEX_H
#define ASTONEX_H

#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(push, 3)
#endif
#include <windows.h>
#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(pop)
#endif

#define WM_REDRAW							  WM_USER + 0x500
#define WS_EX_LAYERED           0x00080000
#define HiTimerElapse           20
#define MAX_LAYERS              128
#define WndTimerID              597
#define AniTimerID              598
#define Timer3PicID             599
#define DragSens                6

#define AWS_LAYERED            1
#define AWS_DRAWWALLPAPER      2
#define AWS_NOAUTORESIZE       4
#define AWS_FADESTYLE          8
#define AWS_LOCKPOS            16
#define AWS_HIDEONMOUSEMOVE    32
#define AWS_GHOSTMODE          64

//--------------------------

#define LAYER_DEFAULT           0 
#define LAYER_NOANIMATION       1
#define LAYER_TRANSPARENT       2
#define LAYER_DRAG              4
#define LAYER_DRAGITEM          8
#define LAYER_NOBOUNDRECT       16
#define LAYER_DRAWWALLPAPER     32 
#define LAYER_LAYERED           64 
#define LAYER_3PIC_STRETCH      128
#define LAYER_HIDE              256


typedef struct tagTpaint
{
public:
	HDC DC;
	VOID* bits;
	SIZE size;
	int index;
    HGDIOBJ oldbmp;
}Tpaint, *Ppaint;


DECLARE_HANDLE(HZIP);

typedef struct
{ int index;                 
  TCHAR name[MAX_PATH];    
  DWORD attr;            
  FILETIME atime,ctime,mtime;
  long comp_size;          
  long unc_size;
} ZIPENTRY;


__interface AstonWND: IUnknown
{   
    HWND __stdcall hwnd();
    UINT  __stdcall GetVer();
    void __stdcall Show(int ShowFlag);
    void __stdcall ReDraw();
    void __stdcall SetFixedSize(int w, int h);
    void __stdcall MoveWindow(int x, int y);
    int __stdcall  SetBG(CHAR* path);
    void __stdcall SetANKState(int index, int newstate);
    int __stdcall  AddLayer(int index, int x, int y, CHAR* pic_path, int flag, int transparency);
    bool __stdcall RemoveLayer(int index);
    int __stdcall  CreateCustomLayer(int index, int x, int y, int w, int h, int flag, int transparency);
    bool __stdcall SetANKFrame(int index, int newframe);
    bool __stdcall SetLayerFlag(int index, int flag);
    int  __stdcall GetLayerFlag(int index);
    Ppaint __stdcall LayerPaint_Begin(int index);
    void __stdcall LayerPaint_End(Ppaint p);
    void __stdcall DrawText(HDC dc, CHAR* text, RECT* r, HFONT font, DWORD flag, COLORREF fontColor, BOOL shadow, COLORREF shadow_color);
    void __stdcall DrawTextOnLayer(int index, CHAR* text, RECT* r, HFONT font, DWORD flag, COLORREF fontColor, BOOL shadow, COLORREF shadow_color);
    HWND __stdcall CreateChildWnd(DWORD dwExStyle, LPCTSTR lpClassName, LPCTSTR lpWindowName, DWORD dwStyle, int x, int y, int nWidth, int nHeight, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam);
    bool __stdcall GetLayerRect(int index, RECT* rect);
    bool __stdcall SetLayerRect(int index, RECT* rect);
    void __stdcall Free();
    int __stdcall  AddLayerPic(int index, int x, int y, PPicture pic, int flag);
    int __stdcall  AddLayerPic3(int index, int x, int y, PPicture pic,PPicture pic2, PPicture pic3, int flag);
    void __stdcall MoveLayer(int index, int x, int y, bool SENDCHANGING);
    void __stdcall AddHintOnLayer(int index, CHAR* Hint);
    int __stdcall  AddLayer3Pic(int index, int x, int y, int w, int h, CHAR* path_3pic, int flag, int transparency);
    PPicture __stdcall GetLayerPic(int index);
    BOOL __stdcall LayerOnPoint(int index, POINT p);
    void __stdcall SetUserData(long dwNewLong);
    long __stdcall GetUserData();
    void __stdcall SetDebugMode(bool flag);
    bool __stdcall MakeScrollBar(int scrollbar, int slider, int min, int max, int pos, int flag);
    bool __stdcall GetScrollBar(int scrollbar, int& min, int& max, int& pos);
    bool __stdcall SetScrollBar(int scrollbar, int min, int max, int pos, int flag);
};

#ifdef __cplusplus
extern "C"  {
#endif
LRESULT __cdecl CreateAstonWND(int x, int y, HWND parent, int zorder, int flag, WNDPROC proc, HWND desktop, int transparency);
void __cdecl ADrawText(HDC dc, CHAR* text, RECT* r, HFONT font, DWORD flag, COLORREF fontColor, BOOL shadow, COLORREF shadow_color);
void __cdecl CalcTextRect(CHAR* text, RECT* r, HFONT font, DWORD flag, BOOL shadow);
POINTS __cdecl DrawWnd(HDC dc, HWND wnd, int size);
#ifdef __cplusplus
}
#endif 
#endif //ASTONEX_H