/*
Aston 1.9.2 SDK for VC6.0-7.1
(c) Gladiatros Software, 1999-2006
*/ 

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef _ASTONSDK_H_
#define _ASTONSDK_H_


#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(push, 3)
#endif
#include <windows.h>
#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(pop)
#endif
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 

#define PICTURE_ICO 1
#define PICTURE_BMP 2
#define PICTURE_SYSIMAGELIST 4
#define PICTURE_BMP_W_O_MASK 5
#define PICTURE_ANI_FIX 6
#define PICTURE_ANK 7
/*-----1.9-------------------------------------------------------------*/ 
#define PICTURE_BMP_ALPHA 8
/*-----1.9.2-------------------------------------------------------------*/ 
#define PICTURE_3PIC      9

#define PICTURE_CORRUPT -1
#define PICTURE_INTERNAL 0xff
/*---------------------------------------------------------------------*/ 

#define MAX_3PIC 4

typedef struct tagTwoBitmaps
{ 
  HBITMAP Handle;
  HBITMAP Mask;
} TwoBitmaps, *PBitmapArray;

typedef int * PFramesArray;

typedef struct tagTAnima
{ 
  PBitmapArray aBitmaps;
  int aBitmapCount;
  PFramesArray aFrames;
} TAnima, *PAnima;


typedef struct tagTAnima2
{ 
  PAnima pAnim;
  BOOL aShared;
  BOOL pAnimShared;
  
  int BMPframes;
  PFramesArray Frames;
  int FrameCount;
  int Interval;
  int Loop;
  char* Sound;
  char* FileName;
  BYTE* ALPHAbits;
  int ALPHAwidth;
  int ALPHAheight;
 
} TAnima2, *PAnima2;

#define MAX_ANK 4

typedef struct tagTAnk
{ 
  TAnima2 anks[MAX_ANK-1+1];
  DWORD dwRes;
} TAnk, *PAnk;



typedef struct tagTPicture
{ 
  int IconType;
  HGDIOBJ Handle;
  HGDIOBJ Mask;
  int Width;
  int Height;
  int CurrentFrame;
  int Frames;/*ani*/ 
  char* FileName;
  char* DefFileName;
  WORD IconIndex;
  UINT Options;
  BOOL Shared;
  DWORD dwReserved;
} TPicture, *PPicture;

/*---------------------------------------------------------------------*/ 

typedef struct tagT3Pic
{
  TPicture pic[MAX_3PIC];
} T3Pic, *P3Pic;



//#1 packed, use 
#pragma pack(push, 1)
typedef struct tagTFont
{ 
  char fFaceName[LF_FACESIZE-1+1];
  int Size;
  UINT Options;/*bold-italic-underline  111h*/ 
  int Charset;/*wvsprintf(p, ',%i,%03x,%i', @Font.Size)*/ 
  
  BOOL Shared;
  HFONT Handle;
  DWORD dwReserved;
} TFont, *PFont;

typedef struct tagTFontEx
{ 
  char fFaceName[LF_FACESIZE-1+1];
  int Size;
  UINT Options;/*bold-italic-underline  111h*/ 
  int Charset;/*wvsprintf(p, ',%i,%03x,%i', @Font.Size)*/ 
  
  BOOL Shared;
  HFONT Handle;
  COLORREF Color;
  BOOL Shadow;
  COLORREF ShadowColor;
  DWORD dwReserved1;
  DWORD dwReserved2;
  DWORD dwReserved3;
} TFontEx, *PFontEx;


#pragma pack(pop)


/*---------------------------------------------------------------------*/ 

typedef struct tagTNode
{ 
  UINT NodeType;
  TPicture Glyph;
  TPicture HilitedGlyph;
  TPicture ClickedGlyph;
  char* Path;
  char* WorkDir;
  char* Param;
  int nCmdShow;
  char* Hint;
  BYTE Modify;
  BYTE Key;/*hotkey*/ 
  int X;
  int Y;
  RECT textr;
  HMODULE Instance;
  HWND Wnd;
  DWORD dwReserved;
} TNode, *PNode;



//typedef TNode TNodeList[9999-1+1]
/*#3 bad array bound(s) !!!A*/
;
typedef TNode * PNodeList;
/*---------------------------------------------------------------------*/ 

typedef struct tagTCFG
{ 
  HANDLE FileHandle;
  HANDLE FileMapping;
  char* Text;/*not sz!!!!! do not use lstr*( functions*/ 
  int TextGrow;/*+*/ 
  DWORD FileSize;/*   sizeof(Text)*/ 
  
  char* Section;
  char* Pos1;
  char* Pos2;/*not szChar*/ 
  int Modified;/*0 - based*/ 
} TCFG, *PCFG;
/*config file*/ 

/*---------------------------------------------------------------------*/ 

#define ANK_NORMAL 0
#define ANK_OVER 1
#define ANK_LEAVE 2
#define ANK_CLICK 3
#define ANK_OVERLEAVE 4
#define ANK_LEAVEOVER 5
#define ANK_STOP 6

/*---------------------------------------------------------------------*/ 


typedef struct tagTDockInfo
{ 
  HWND Wnd;
  HWND Parent;
  RECT rc_Client;
  int Align;
  BOOL Vert;
  BOOL Flat;/*reserved*/ 
  int Priority;
} TDockInfo, *PDockInfo;

typedef struct tagTWallInfo
{
  CHAR* path;
  int Style;
} TWallInfo, *PTWallInfo;

//typedef TDockInfo TDock[999-1+1]
/*#4 bad array bound(s) !!!A*/

typedef TDockInfo * PDock;

typedef struct tagTRing1
{ 
  int cbsize;/*ver*/ 
/*-[aston]-----------------------------------------*/ 
  BOOL ToolSlideShow_;
  int ToolDelay;
  int PopupDelay;
  BOOL ShowToolHints;
  BOOL AutoRun;
  BOOL AudioRun;
  BOOL AlwaysOnTop_;
  BOOL ProcessStartUp;
  BOOL ProcessINI;
  BOOL RestoreWallpaper;
  int SlideSteps;
/*-[desktop]--------------------------------------*/ 
  BOOL ShowDragCursor;
  int DragSens;
  int IconColor;
  
  int HiliteColor;
  int FocusColor;
  BOOL TransparentIconText;
  
  BOOL DblClk;
  BOOL HTMLStyle;
  char Wallpaper[MAX_PATH+1];
  TFont DesktopFont;
/*---[taskbar]------------------------------------*/ 
  BOOL BarSlideShow;
  
  COLORREF BarTextColor;
  COLORREF BarColor;
  COLORREF ActiveTextColor;
  COLORREF InactiveTextColor;
  COLORREF MinTextColor;
  int BarSize;
  int TaskbarPos;/*0-left, 1-top, 2-right, 3-bottom*/ 
  BOOL BarAutoHide;
  TPicture BarSkin[3+1];
  BOOL SysIcon;
  int ButtonHeight;
  TFont ActiveFont;
  TFont InactiveFont;
  TFont MinFont;
  UINT TaskOptions;
  int TaskBarShowDelay;
  int TaskBarSlideSteps;
  
  char szBarTip[MAX_PATH+1];
  TPicture StartBmp;
/*---[systray]------------------------------------*/ 
  BOOL MinToTray;/*not used :-(*/ 
  COLORREF TrayBkColor;
  int TrayIconSize;
  int TrayPos;
/*---[hotkey]----------------------*/ 
  PNodeList HotKey;
  int HotCount;
  int HotMax;
/*-----[plugins]---------------------------*/ 
  PNodeList Modules;
  int ModCount;
  int ModMax;
/*--[icons]--------------------------------------------------*/ 
  PNodeList DesktopIcons;
  int IconMax;
  int IconCount;
/*--[toolbars]-------------------------------------------------*/ 
  int ToolSizeX[1+1];
  int ToolSizeY[1+1];
  int ToolCaption[1+1];/*0-no caption, 1-caption, 2-only caption*/ 
  TPicture AfterBmp[1+1];
  int ZYOffset[1+1];
  int ZXOffset[1+1];
  int YYOffset[1+1];
  int YXOffset[1+1];
  int XYOffset[1+1];
  int XXOffset[1+1];
  BOOL ToolAutoHide[1+1];
  int ToolYPos[1+1];
  BOOL ResizeDesktop[1+1];
  int PushOffset[1+1];
/*-----[really wharf]----------------------------------------------*/ 
  PNodeList Tools[1+1];
  int ToolCount[1+1];
  int ToolMax[1+1];
/*----------------------------------*/ 
  PNodeList MainMenu;
  int MenuCount;
  int MenuMax;
/*----[litestep emul]---------------------*/ 
  int lm78Unit;
  int lm78MaxCpu;
  int lm78MaxMb;
  int lm78Cpu;
  int vwmVelocity;
  int vwmDistance;
  int usClock;
  int vwmNoGathering;
  int vwmNoAuto;
  char pixmapDir[MAX_PATH+1];
  char defaultBmp[MAX_PATH+1];
  int vwmBackColor;
  int vwmSelBackColor;
  int vwmForeColor;
  int vwmBorderColor;
  char lsPath[MAX_PATH+1];
  BOOL lsapi;
/*----[???]-----------------------------*/ 
  BOOL TopDesktop;
  UINT ContextMenuOpt;
  
/*-----[Env]------------------------------*/ 
  PNodeList Environment;
  int EnvCount;
  int EnvMax;
/*-----------------------*/ 
  TPicture TraySkin;
  int TraySkinAlign;
/*----------------------------------------*/ 
/*ver 1.3*/ 
  int TaskbarSkinAlign;
  BOOL WarnOnStartup;
  BOOL IgnoreShape;
/*ver 1.4*/ 
  BOOL DisableToolbar[1+1];
/*ver 1.5*/ 
  TPicture StartBmpH;
  TPicture StartBmpP;
  BOOL LoadObj;
  BOOL HideTrayIcons;
  COLORREF ShadowColor;
  BOOL EnableShadows;
/*ver 1.6*/ 
  int ToolTrans[1+1];
  int TaskTrans;
  BOOL XPLngIcon;
/*ver 1.7*/ 
  PNodeList XPStyleTray;
  int XPSTCount;
  int XPSTMax;
  BOOL XPLButton;
/*ver 1.8*/ 
  TPicture TopSkinBmp[1+1];
  BOOL ToolSlideShow2[1+1];
  BOOL AlwaysOnTop2[1+1];
  BOOL bLockTaskbar;
  TFont TipFont;
/*1.8.2*/
  int SetShell;
  BOOL DontSeparateIE;
  BOOL DontSeparateE;
  BOOL DontProcessStartReg;
/*1.9.0*/
  BOOL bUseXPShadows;
  int nAlphaBlitNT;
  int nAlphaBlit9x;
  BOOL bUseMmKbdDll;
/*1.9.1*/
  TPicture TrayIcon;
  TPicture TrayIconHide;
/*1.9.2*/
  BOOL DisableTransparency;
  int TaskBarIconOffset;
  TWallInfo Wallpapers[MAX_MONITORS];
  BOOL AutoHideTrayIcons;
  int AutoHideDelay;
  BOOL AutoShowTrayIcons;
} TRing1, *PRing1;


/*---------------------------------------------------------------------*/ 

typedef struct tagTWallPaperInfo
{ 
  PPicture WallPaper;
  int WallpaperStyle;
  int TileWallpaper;
  HBRUSH DesktopBrush;
} TWallPaperInfo, *PWallPaperInfo;

/*---------------------------------------------------------------------*/ 

typedef struct tagTToolData
{ 
  int cbsize;
  PNode Node;
  PRing1 Ring1;
  LPOSVERSIONINFO osver;
  
  char* MainPath;
  char* AstonCFG;
  char* PluginsCFG;
  
  HWND MainWindow;
  
  HWND Desktop;
  HWND Taskbar;
  HWND ToolTip;
  HWND TrayWnd;
  HWND TasksWnd;
  HWND ToolBar[1+1];
  HWND ToolContainer[1+1];
  
  HDC MemoryDC;
  
  int iID;/*0 - left, 1 - right*/ 
  int Position;/*0 - based*/ 
  LPBOOL HideFlag;
  int* Focus;
  int* Pressed;
  int* AutoPressed;
  
  TWallPaperInfo WallPaperInfo;
  HANDLE AppInstance;
} TToolData, *PToolData;

/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 

typedef struct tagTAstonData
{ 
  int cbsize;
  PNode Node;
  PRing1 Ring1;
  LPOSVERSIONINFO osver;
  
  char* MainPath;
  char* AstonCFG;
  char* PluginsCFG;
  
  HWND MainWindow;
  
  HWND Desktop;
  HWND Taskbar;
  HWND ToolTip;
  HWND TrayWnd;
  HWND TasksWnd;
  HWND ToolBar[1+1];
  HWND ToolContainer[1+1];
  
  HDC MemoryDC;
  HBRUSH BarBrush;
  PBOOL TaskBarHideFlag;
  
  TWallPaperInfo WallPaperInfo;
  HANDLE AppInstance;
/*ver 1.5*/ 
  LONG (*AddTrayIcon)(void/*const LPVOID pnid*/);/*any of *NOTIFYICONDATA**/ 
  LONG (*ModifyTrayIcon)(void/*const LPVOID pnid*/);//fastcall :(
  LONG (*RemoveTrayIcon)(void/*const LPVOID pnid*/);
} TAstonData, *PAstonData;


/*typedef void (WINAPI *InitToolModule) (PToolData ad);
typedef void (WINAPI *InitAstonModule) (PAstonData ad);
typedef void (WINAPI *DoneModule) (void);/* :-/ */ 


#define szInitToolModule "InitToolbarModule"
#define szInitAstonModule "InitGlobalModule"
#define szDoneModule "DoneModule"

#define szMainClass "Aston"
#define szAston  szMainClass
#define szDeskClass "Progman"
#define szDeskClass2 "Desktop"
#define szFakeDeskClass "Fix FullScreen"
#define szBarClass "Shell_TrayWnd"
#define szTrayClass "TrayNotifyWnd"
#define szTasksClass "MSTaskSwWClass"


#define szToolBarClass  "YWindowCaption"
#define szToolContainerClass  "YWindow"
#define szPopupClass  "XWindow"
#define szZClass  "ZWindow"


#define szDeskName  "Program Manager"

#define DefAstonRC  "aston.rc"
#define DefTipFileName  "tips.rc"
#define DefPluginsFileName  "plugins.rc"
#define szUsers  "Users\\"

#define DefLSRC  "step.rc"

#define APIdll "starter.dll"
#define szPrintMon  "printmon.exe Millenium"

#define szAstonExe "aston.exe"
#define szShellSwpExe  "shellswp.exe"
#define szMaster  "a-master.exe"
#define szWizard  "thwizard.exe"
#define szRundll32  "rundll32.exe"
#define szExploreWClass  "ExploreWClass"
#define szCabinetWClass  "CabinetWClass"
#define szExplorer  "explorer.exe"
#define szproperties  "properties"
#define szexplore  "explore"
#define szWallpaper  "Wallpaper"
#define szConnectionsTray  "Connections Tray"
#define szTaskManager  "TaskMgr.exe"
#define szTrayIcons  "TrayIcons"
/*---------------------------------------------------------------------*/ 
#define szPrintMonClass "AstonPrintMon"
/*---------------------------------------------------------------------*/ 
#define NODE_TYPE (0xFF)/*mask*/ 
/* program or document*/ 
#define NODE_FILE 0x1
/* run dialog*/ 
#define NODE_RUN 0x2
/* shutdown dialog*/ 
#define NODE_SHUTDOWN 0x3
/* Recycle (reload config)*/ 
#define NODE_RECYCLE 0x4
/* Toolbar plugin*/ 
#define NODE_ASTONTOOLPLUGIN 0x5
/* run ScreenSaver*/ 
#define NODE_SAVER 0x6
/* show / hide Desktop*/ 
#define NODE_DESKTOP_ON_TOP 0x7
/* minimize active window*/ 
#define NODE_MINIMIZE 0x8
/* remove from start menu dialog*/ 
#define NODE_REMOVE_FROM_MENU 0x9
/* add to start menu dialog*/ 
#define NODE_ADD_TO_MENU 0xA
/* call "start menu"*/ 
#define NODE_MAINMENU 0xB
/* Clear Recent*/ 
#define NODE_CLEARRECENT 0xC
/* desk.cpl dialog*/ 
#define NODE_SCREENPROPERTIES 0xD
/* empty*/ 
#define NODE_FAKE 0xE
/* files find*/ 
#define NODE_FINDFILES 0xF
/* comp fild*/ 
#define NODE_FINDCOMP 0x10
/* logoff dialog (win 98) or logoff*/ 
#define NODE_LOGOFF 0x11
/* a-master*/ 
#define NODE_MASTER 0x12
/* About*/ 
#define NODE_ABOUT 0x14
/* Ls Emul*/ 
#define NODE_LSTOOLPLUGIN 0x15
/* Suspends Mode*/ 
#define NODE_SUSPENDS 0x16

/*--Menu only---*/ 
/* PopupFolder (r=Folder)*/ 
#define NODE_MENU_FOLDER 0x17
/* PopupFolder w/o sub-folders*/ 
#define NODE_MENU_FOLDER_NO_SUB 0x18
/* !programs*/ 
#define NODE_MENU_PROGRAMS 0x19
/* !programs (common)*/ 
#define NODE_MENU_COMMON_PROGRAMS 0x1A
/* !recent*/ 
#define NODE_MENU_RECENT 0x1B
/* new menu in menuex*/ 
#define NODE_MENU_MENU 0x1C
/* common only*/ 
#define NODE_MENU_COMMON_MENU 0x1D
/* cascade control panel*/ 
#define NODE_MENU_CPL 0x1E

/*---------------------------------------------------------------------*/ 
#define NODE_FAKE_THEME 0x1F
/*---------------------------------------------------------------------*/ 

/*menu again*/ 
#define NODE_PIDL 0x20
/*cascade desktop*/ 
#define NODE_MENU_DESKTOP 0x21

/* NODE_MENU_FAVORITES                0x22; not implemented yet*/ 

/*---explore folder------------------*/ 
/*CSIDL_PROGRAMS*/ 
#define NODE_CSIDL_PROGRAMS 0x30
/*CSIDL_COMMON_PROGRAMS*/ 
#define NODE_CSIDL_COMMON_PROGRAMS 0x31
/*CSIDL_STARTMENU*/ 
#define NODE_CSIDL_STARTMENU 0x32
/*CSIDL_COMMON_STARTMENU*/ 
#define NODE_CSIDL_COMMON_STARTMENU 0x33
/*CSIDL_SENDTO*/ 
#define NODE_CSIDL_SENDTO 0x34
/*CSIDL_RECENT*/ 
#define NODE_CSIDL_RECENT 0x35
/*CSIDL_DESKTOPDIRECTORY*/ 
#define NODE_CSIDL_DESKTOPDIRECTORY 0x36
/*CSIDL_COMMON_DESKTOPDIRECTORY*/ 
#define NODE_CSIDL_COMMON_DESKTOPDIRECTORY 0x37
/*CSIDL_FAVORITES*/ 
#define NODE_CSIDL_FAVORITES 0x38
/*CSIDL_COMMON_FAVORITES*/ 
#define NODE_CSIDL_COMMON_FAVORITES 0x39
/*CSIDL_PERSONAL*/ 
#define NODE_CSIDL_PERSONAL 0x3A
/*--open in explorer---------------*/ 
/*CSIDL_CONTROLS*/ 
#define NODE_CSIDL_CONTROLS 0x3B
/*CSIDL_PRINTERS*/ 
#define NODE_CSIDL_PRINTERS 0x3C
/*CSIDL_BITBUCKET*/ 
#define NODE_CSIDL_BITBUCKET 0x3D
/*CSIDL_DRIVES*/ 
#define NODE_CSIDL_DRIVES 0x3E/*my comp!!!*/ 
/*CSIDL_NETWORK*/ 
#define NODE_CSIDL_NETWORK 0x3F
/*CSIDL_FONTS*/ 
#define NODE_CSIDL_FONTS 0x40
/*CSIDL_INTERNET_CACHE*/ 
#define NODE_CSIDL_INTERNET_CACHE 0x41
/*CSIDL_HISTORY*/ 
#define NODE_CSIDL_HISTORY 0x42
/*CSIDL_INTERNET*/ 
#define NODE_CSIDL_INTERNET 0x43

/* lockstation (2k) / switch user (XP)*/ 
#define NODE_LOCKWS 0x70
/* show/hide tray*/ 
#define NODE_HIDETRAYICONS 0x71
#define NODE_SETUPTRAYICONS 0x72

/*quit aston*/ 
#define NODE_DEBUG_CLOSE 0xFF
/*---------------------------------------------------------------------*/ 
/*flags:*/ 
#define NODE_LOADMASK (0xfff)

#define NODE_ICONBOUNDRECT (0x100)
#define NODE_REAL_THEME (0x200)
#define NODE_LOCKED (0x400)
#define NODE_DISABLED (0x800)

/*internal*/ 
/*-plugins------------------------------------------------*/ 
#define NODE_LEVEL1 (0x1000)
#define NODE_LEVEL2 (0x2000)
#define NODE_LEVEL3 (0x4000)

/*--system events----------------------------!!-----------*/ 
#define NODE_WM_DISPLAYCHANGE_REGISTER (0x10000)
#define NODE_WM_SETTINGCHANGE_REGISTER (0x20000)
#define NODE_WM_TIMECHANGE_REGISTER (0x40000)
#define NODE_WM_DEVICECHANGE_REGISTER (0x80000)
#define NODE_WM_DEVMODECHANGE_REGISTER (0x100000)
#define NODE_WM_SYSCOLORCHANGE_REGISTER (0x200000)
/*------------------------*/ 

#define NODE_REGISTERMAINMENU (0x1000000)
#define NODE_FLAT (0x2000000)
#define NODE_TOOLPOPUP ((0x4000000) | NODE_FLAT)
#define NODE_USERCOMMONMENU (0x8000000)

/*--------------------------------------------------------*/ 
#define maxbarsize (int)(24)/*size of taskbar, in pixels*/ 
#define _FrameSize_ 2/*taskbar's border*/ 


/*timers (track mouse event)*/ 
#define dElapse (70)
#define dElapseNT (140)
#define Elapse (160)

#define RecycleTimerID (0xb5)
#define TrayTimerID (0xb4)
#define TaskTimerID (0xb3)
#define BarTimerID (0xb2)
#define DesktopTimerID (0xb1)
#define ToolTimerID (0xb0)


/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*-----messages------------------------------------------*/ 
#define WM_USERM (0x7FFF)
#define CM_GETPLUGINMEMSIZE WM_USERM-3/*_Send_ This Message!!! Do not Post!!!*/ 
#define CM_RESTOREPLUGINMEM WM_USERM-1/*Do not Post!!!*/ 
#define CM_SAVEPLUGINMEM WM_USERM-2/*Do not Post - Memory leak !!!*/ 


#define CM_PLUGINMOUSELEAVE WM_USERM-5

#define CM_RECYCLE WM_USERM-0xC
#define CM_SCREENSETUP WM_USERM-0xD
#define CM_PRINTERS WM_USERM-0x11

#define CM_EXECUTENODE WM_USERM-0xE/*lParam - PNode;*/ 

#define CM_POPUPMAINMENU WM_USERM-0x12
#define CM_TIMEDATESETUP WM_USERM-0x13


/*--INTERNAL!!!!----------------------*/ 
#define CM_SHELLHOOK WM_USERM-0xF

#define CM_ASTONICON WM_USERM-0x21

/*----plugins-------------------*/ 
#define CM_TOOLPLUGINPOPUP WM_USERM-0x16
#define CM_TOOLPLUGINMOUSEMOVE WM_USERM-0x17

#define CM_DOCK WM_USERM-0x18
#define CM_UNDOCK WM_USERM-0x19
#define CM_TASKBARSIZECHANGE WM_USERM-0x1A
#define CM_DOCKSIZECHANGE WM_USERM-0x1B

#define CM_ENTERMODAL WM_USERM-0x1D
#define CM_LEAVEMODAL WM_USERM-0x1E


#define CM_TOOLPLUGINHOTKEY WM_USERM-0x22

#define CM_FORCETOOLPLUGINPOPUP WM_USERM-0x23/*wParam - Position, lParam - Node.Wnd, result - succ/fail (1/0)*/ 
#define CM_FORCETOOLPLUGINHIDE WM_USERM-0x26/*wParam - Position, result - succ/fail (1/0)*/ 
#define CM_ISTOOLPLUGINACTIVE WM_USERM-0x24

#define CM_SWITCHTOTASKBAR WM_USERM-0x25

#define CM_SETUPASTON WM_USERM-0x26/*lParam - CmdParam*/ 

#define CM_WALLPAPER WM_USERM-0x27/*no parameters*/ 
#define CM_WALLPAPERSETUP WM_USERM-0x28/*no parameters*/ 
#define CM_SETPICTURE WM_USERM-0x29/*wParam - 0|PICTURE_ANI_FIX, lParam - 0 (Clear) | PPicture (PICTURE_ANI_FIX only)*/ 

#define CM_UPDATEICONS WM_USERM-0x30
#define CM_DELAYEDRECYCLE WM_USERM-0x33
#define CM_WALLPAPERSTYLE WM_USERM-0x35//'fixfullscreen' window
#define CM_SETUPTRAY WM_USERM-0x36
#define CM_HITIMER WM_USERM-0x37

#define CM_COINITIALIZE  WM_USERM-0x40
#define CM_GETFULLSCREEN WM_USERM-0x41
/*---------------------------------------------------------------------*/ 
/*---LoadImageEx options-----------------------------------------------*/ 
#define PIC_AUTODETECT (0)

#define BMP_NOMASK (1)
#define PIC_NOCACHE (2)
#define BMP_USE_W_H (4 | BMP_NOMASK)
#define PIC_SHELLICON (8 | PIC_NOCACHE)
#define ICO_USE_W_H (0x10)
#define BMP_PALETTE (0x20)
#define BMP_STRETCH_HALFTONE (0x40)
#define ANK_PREVIEW (0x80)
/*-----1.9-------------------------------------------------------------*/ 
#define PIC_NOPREALPHA (0x100)
/*---------------------------------------------------------------------*/ 

/*plugin setup*/ 
typedef struct tagTKey
{ 
  char* szKey;
  int   nType;
  char* szHint;
  DWORD vDefault;
  int   res1;
  int   res2;
} TKey, *PKey;



typedef TKey * PKeyTable;



typedef struct tagTPluginInfo
{ 
  int cbSize;
  char* szName;
  char* szDescription;
  char* szSection;
  UINT nKeyCount;
  PKeyTable Keys;
} TPluginInfo, *PPluginInfo;



#define KEY_BOOL 1
#define KEY_INT 2
#define KEY_INT_RANGE 3
#define KEY_HEX 4
#define KEY_HEX_RANGE 5
#define KEY_COLOR 6
#define KEY_STRING 7
#define KEY_PATH 8
#define KEY_FOLDER 9
#define KEY_BOOLEAN 10
#define KEY_SCROLLBAR 11
#define KEY_FONT 12
#define KEY_BITMAP 14
#define KEY_UPDOWNCONTROL 15
#define KEY_LIST 16
/*---------------------------------------------------------------------*/ 
/*-1.8.x---------------------------------------------------------------*/
#define KEY_TREE          17
//res1 - max level
#define KEY_SEPARATOR     18
#define KEY_CAPTION       19
/*---------------------------------------------------------------------*/ 
#define KEY_STATIC_ICON   20
#define KEY_PICTURE       21  
/*-----1.9-------------------------------------------------------------*/ 
#define KEY_RECT 22
#define KEY_PRINT_FONT    23
/*-----1.9.1-----------------------------------------------------------*/ 
#define KEY_PIC_LIST      24
/*-----1.9.2-----------------------------------------------------------*/ 
#define KEY_TRANSPARENCY  25
#define KEY_TAB           26
#define KEY_PICTURE_EX    27
#define KEY_FONT_EX       28
#define KEY_POINT         29

/*---------------------------------------------------------------------*/ 
#define KEY_MASK 0xFF
#define KEY_NOTHEME 0x100
/*---------------------------------------------------------------------*/ 
/*-menu IDs------------------------------------------------------------*/ 
/*-from explorer.exe-----------------------------------------*/ 
#define menuid_Cascade (403)
#define menuid_TileHorizontal (404)
#define menuid_TileVertical (405)

#define menuid_MinimizeAll (415)
#define menuid_Undo (416)
#define menuid_TaskMgr 420
/*---------------------------------------------------------------------*/ 
/*--ContextMenuOpt-----------------------------------------------*/ 
#define CONTEXTMENU_NOSETUP (0x1)
#define CONTEXTMENU_NORECYCLE (0x10)
#define CONTEXTMENU_NOSCREENSETUP (0x100)
#define CONTEXTMENU_NOWINARRANGE (0x1000)
#define CONTEXTMENU_NOWINMINALL (0x10000)
#define CONTEXTMENU_NODESKTOP (0x100000)
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
#define SECTION_CREATE_ALWAYS (1)
/*---------------------------------------------------------------------*/ 
#define FONT_BOLD (0x100)
#define FONT_ITALIC (0x010)
#define FONT_UNDERLINE (0x001)
#define FONT_NOCLEARTYPE (0x1000)
/*--taskbar options-------------------------*/ 
#define TASK_MINACTIVEONCLICK (0x1)
#define TASK_HIDEBUTTONS (0x10)
#define TASK_EXPLORERLIKEHINTS (0x100)
#define TASK_MENUNEARSTART (0x1000)
#define TASK_NOWINKEY (0x10000)
#define TASK_NOBEVEL (0x100000)
#define TASK_NOTOPMOST (0x1000000)
/*---------------------------------------------------------------------*/ 
#define double_buffer_size 256
/*---------------------------------------------------------------------*/ 
/*DrawSkin flags*/ 
/*---------------------------------------------------------------------*/ 
#define DPEx_TILED (1)
#define DPEx_CENTERED (2)
#define DPEx_CORRECTBRUSH (4)
#define DPEx_STRETCHED (8)
#define DPEx_STRETCHED_RATIO (16)
#define DPEx_STRETCHED_RATIO_OIB (32)
/*---------------------------------------------------------------------*/ 
#define MaxRCFileSize 0x2ffff
#define MaxGrow 0x1fff
/*---------------------------------------------------------------------*/ 
/*--ls emu----------------------------------------*/ 
#define magicDWord  0x49474541
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 

#pragma pack(push, 1)
typedef struct tagICONIMAGE
{ 
  UINT Width;
  UINT Height;
  UINT Colors;/* Width, Height and bpp*/ 
  LPBYTE lpBits;/* ptr to DIB bits*/ 
  DWORD dwNumBytes;/* how many bytes?*/ 
} ICONIMAGE, *PICONIMAGE;
#pragma pack(pop)



typedef struct tagMEMICON
{ 
  UINT nNumImages;
  ICONIMAGE IconImages[1];
} MEMICON, *PMEMICON;



typedef struct tagTModuleEx
{ 
  HANDLE hLibrary;
  LPBYTE pData;/*win 3.11 - 16 bit only*/ 
  int size;
} TModuleEx, *PModuleEx;


#pragma pack(push, 1)
typedef struct tagICODIRENTRY
{ 
  BYTE bWidth;/* Width of the image*/ 
  BYTE bHeight;/* Height of the image (times 2)*/ 
  BYTE bColorCount;/* Number of colors in image (0 if >=8bpp)*/ 
  BYTE bReserved;
  WORD wPlanes;/* Color Planes*/ 
  WORD wBitCount;/* Bits per pixel*/ 
  DWORD dwBytesInRes;/* how many bytes in this resource?*/ 
  DWORD dwImageOffset;/* where in the file is this image*/ 
} ICODIRENTRY, *PICODIRENTRY;
#pragma pack(pop)

/*in *.ICO file*/ 

//typedef ICODIRENTRY ICODIRENTRIES[999+1];
//typedef ICODIRENTRIES* PICODIRENTRIES;

#ifndef abs
#define abs(a)          (((a) < 0) ? -(a) : (a))
#endif

#ifndef GET_X_LPARAM
#define GET_X_LPARAM(lp)   ((int)(short)LOWORD(lp))
#endif

#ifndef GET_Y_LPARAM
#define GET_Y_LPARAM(lp)   ((int)(short)HIWORD(lp))
#endif

#if defined(_MSC_VER) 

#if (_MSC_VER < 1300)

//VC 6 
#ifdef NODEFAULTLIB
//Reduce size of dll:
#pragma comment(linker,"/nodefaultlib")
//Force 512 byte section alignment in the PE file:
#pragma comment(linker, "/OPT:NOWIN98")
#ifdef _DEBUG
_declspec(naked) void _chkesp(void)
{
  __asm
  {
    je __1
    int 3//stack corrupted!!?
__1:
    ret
  }
}
#endif
#endif

#else
//VC 7
#ifdef NODEFAULTLIB
#pragma message( "you can try 'Ignore all defaul libraries: yes'" )
#pragma message( "and 'Optimize for Win98: no' options for Release" )
#endif

#endif

//supress nasty warnings...

#pragma warning( disable : 4100 )
//unused params ^^^

#pragma warning( disable : 4201 )
//nameless structs ^^^

#ifdef _DEBUG
#pragma warning(disable : 4101)
//unreferenced vars ^^^
#endif

#endif

#endif
