/*
Aston 1.9.2 SDK for VC6.0-7.1
(c) Gladiatros Software, 1999-2006
starter.dll interface
*/ 

#if defined(_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef _ST_API_H_
#define _ST_API_H_

//Interface

#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(push, 3)
#endif
#include <windows.h>
#include <shlobj.h>
#if defined(_MSC_VER) && (_MSC_VER >= 1300)
#pragma warning(pop)
#endif

/*---------------------------------------------------------------------*/ 
#ifdef __cplusplus
extern "C"  {
#endif

LPVOID WINAPI Amalloc(int size); 
void WINAPI Afree(LPVOID p);
LPVOID WINAPI Arealloc(LPVOID p, int size);

void WINAPI LoadImageEx(PPicture Picture);

void WINAPI MakeMask(PPicture Picture);


void WINAPI GetShellIconSize(int* Large, int* Small);/*obsolete*/ 

void WINAPI GetShellIconBPP(int* Large, int* Small, int* BPP);


int WINAPI GetRegInt(HKEY Key, char* szValue, int iDefault);


/*---------------------------------------------------------------------*/ 
void WINAPI DrawPicture(HDC DC, HDC memDC, int X, int Y, PPicture Picture);

void WINAPI DrawSkinTrans(HDC DC, HDC memDC, int index, int id, PRing1 Core);

void WINAPI DrawSkin(HDC DC, HDC memDC, RECT* DstRect, RECT* SrcRect, RECT* WinRect, PPicture Picture, HBRUSH Brush, UINT uFlags);


void WINAPI StretchSkin(HDC memDC, TPicture* NewSkin, PPicture Skin, int cx, int cy);

HRGN WINAPI BitmapToRegion(HBITMAP hBMP, COLORREF cBGRTransparentColor, int xoffset, int yoffset);


/*---------------------------------------------------------------------*/ 
void WINAPI FreeNode(PNode Node);

void WINAPI FreePicture(PPicture Picture);

/*---------------------------------------------------------------------*/ 
void WINAPI Run(char* Path, char* WorkDir, char* Param, int nCmdShow, DWORD dwHotKey);

void WINAPI RunSHFolder(int nFolder, char* Verb, ULONG Mask);

BOOL WINAPI RunSCF(char* p);

/*---------------------------------------------------------------------*/ 
void WINAPI StrCopyEx(char* Dest, char* Src);

void WINAPI Quote(char* P);

void WINAPI Unquote(char* P);

char* WINAPI GetParamStr(char* P);

void WINAPI CheckInt(int* c, int a, int b, int d);

/*---------------------------------------------------------------------*/ 
void WINAPI GetFontHandle(PFont Font, HFONT deffont);

void WINAPI FreeFont(PFont Font);

/*---------------------------------------------------------------------*/ 

int WINAPI OpenCFGw(char* RCFileName, PCFG CFG);

int WINAPI CloseCFGw(char* RCFileName, BOOL Backup, PCFG CFG);

/*---------------------------------------------------------------------*/ 
int WINAPI OpenCFGr(char* RCFileName, PCFG CFG);

void WINAPI CloseCFGr(PCFG CFG);

int WINAPI FindSection(char* szSection, UINT Opt, PCFG CFG);

int WINAPI GetCFGString(char* szKey, char* szDefault, char* lpBuffer, int BufferSize, PCFG CFG);

int WINAPI GetCFGInt(char* szKey, int nDefault, PCFG CFG);

UINT WINAPI GetCFGHex(char* szKey, UINT nDefault, PCFG CFG);

BOOL WINAPI GetCFGBool(char* szKey, BOOL bDefault, PCFG CFG);

//delphi "bug" - true = -1
#define _GetCFGBool(k, d, c) (GetCFGBool((k), (d), (c)) ? 1 : 0)

int WINAPI GetCFGPic(char* szKey, PPicture Picture, PCFG CFG);

void WINAPI GetCFGFont(char* szKey, PFont Font, PCFG CFG);

/*---------------------------------------------------------------------*/ 
void WINAPI CreateSection(char* szSection, PCFG CFG);

int WINAPI Scan(char* szKey, PCFG CFG);

void WINAPI CreateKey(char* szKey, PCFG CFG);

void WINAPI InsertString(char* pBuffer, int BufferLen, PCFG CFG);

/*---------------------------------------------------------------------*/ 
void WINAPI SetCFGString(char* szKey, char* pBuffer, PCFG CFG);

void WINAPI SetCFGInt(char* szKey, int iInt, PCFG CFG);

void WINAPI SetCFGHex(char* szKey, UINT uHex, PCFG CFG);

void WINAPI SetCFGPic(char* szKey, PPicture Picture, PCFG CFG);

void WINAPI SetCFGFont(char* szKey, PFont Font, PCFG CFG);


void WINAPI PackNodeList(PNodeList* Data, int count, int max);

void WINAPI GetNodeList(PNodeList* Data, int* count, int* max);

void WINAPI FreeNodeList(PNodeList* Data, int* count, int* max);

int WINAPI FindFirstNode(PCFG CFG);

int WINAPI FindNextNode(PCFG CFG);

void WINAPI NewNode(int Level, PCFG CFG);

void WINAPI DeleteKey(char* szKey, PCFG CFG);


void WINAPI ErrorBox(char* Caption);

void WINAPI NotifyTip(HWND hToolTip, HWND Window, UINT Msg, WPARAM wParam, LPARAM lParam);


/*---------------------------------------------------------------------*/ 
/*--1.5----------------------------------------------------------------*/ 
BOOL WINAPI InitExtractor(char* szFileName, TModuleEx* Module);

PMEMICON WINAPI ReadIconFromModule(const TModuleEx* M, int IconIndex);

BOOL WINAPI AdjustIcon(const PMEMICON lpIR);

void WINAPI FreeExIcon(PMEMICON p);

void WINAPI MakeHIcon(PMEMICON exIcon, PPicture p);

int WINAPI IconMCount(TModuleEx* M);

void WINAPI DoneExtractor(TModuleEx* Module);

/*---------------------------------------------------------------------*/ 
BYTE WINAPI DefCharSet(void);

/*---------------------------------------------------------------------*/ 
BOOL WINAPI FileExists(char* szFileName);

BOOL WINAPI DirExists(char* Dir);

/*-----1.6-------------------------------------------------------------*/ 
void WINAPI AllowForeWnd(HWND Wnd);

HWND WINAPI SetForeWndFix(HWND Wnd, LPOSVERSIONINFO os);

void WINAPI SwitchFix(HWND Wnd, LPOSVERSIONINFO os);

/*---------------------------------------------------------------------*/ 
LPITEMIDLIST WINAPI NextPIDL(LPITEMIDLIST IDList);

int WINAPI GetPIDLSize(LPITEMIDLIST IDList);

LPITEMIDLIST WINAPI CreatePIDL(int Size);

LPITEMIDLIST WINAPI CopyPIDL(LPITEMIDLIST IDList);

LPITEMIDLIST WINAPI ConcatPIDLs(LPITEMIDLIST IDList1, LPITEMIDLIST IDList2);

/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
UINT WINAPI LayeredStyle(HDC DC, BYTE bAlpha);

BOOL WINAPI SetLayered(HWND wnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags);

BOOL WINAPI CanAnimate(void);

BOOL WINAPI AnimateWnd(HWND wnd, DWORD dwTime, DWORD dwFlags);

/*-----1.7-------------------------------------------------------------*/ 
void WINAPI JPGtoBMP(char* JPEG, char* BMP);

DWORD WINAPI BMPtoJPG(char* BMP, char* JPEG, int FQuality, BOOL FGrayscale, BOOL ProgressiveEncoding);

void WINAPI LoadJPG(char* JPEG, PPicture p);

/*-----1.9-------------------------------------------------------------*/ 
LPITEMIDLIST WINAPI PidlFromPathA(char* Path, LPOSVERSIONINFO os);
/*-----1.9.2-----------------------------------------------------------*/ 
void WINAPI GetCFGRect(char* szKey, RECT* r,  PCFG CFG);

void WINAPI RunEx(char* Path, char* WorkDir, char* Param, int nCmdShow, DWORD dwHotKey, HANDLE monitor);

void WINAPI GetFontHandleEx(PFontEx Font, HFONT deffont);

void WINAPI GetCFGFontEx(char* szKey, PFontEx Font, PCFG CFG);

void WINAPI SetCFGFontEx(char* szKey, PFontEx Font, PCFG CFG);

void WINAPI FreeFontEx(PFontEx Font);

void WINAPI SetDrawDesktop(long adr);

void WINAPI DrawDesktop(HWND Window, HDC DC, RECT* rcPaint);

/*-----1.9.3-----------------------------------------------------------*/ 
//void WINAPI GetCFGPoint(char* szKey, POINT* p,  PCFG CFG);
//void WINAPI SetCFGRect(char* szKey, RECT r,  PCFG CFG);
//void WINAPI SetCFGPoint(char* szKey, POINT p,  PCFG CFG);

#ifdef __cplusplus
}
#endif


//pas2c32 warnings: 0
#endif

