#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:ClipView.def")
#pragma comment(linker,"/entry:DllMain")

#include <windows.h>
#include "../SDK/rtlmem.h"

#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}

//---------------

//Library ClipView; 


/* Gladiators Software, 1999-2003*/ 


HWND FWndNext;
HWND hSDKWnd = 0;
TToolData AData;
UINT uFormat = ((UINT)(-1));
int SizeX;
int SizeY;
RECT ClientRect;
TOOLINFO ti;
COLORREF ForeCl;
HBRUSH BkBrush;
BOOL ShowCRLF;
int tipwidth;

static UINT auPriorityList[] = 
{
  CF_OWNERDISPLAY,
  CF_TEXT, 
  CF_BITMAP,
  CF_HDROP
};

static char* szClipView = "Clipboard Viewer";
static char* szAbout = "Clipboard Viewer 1.8c\x0D\x0A"\
"Can display CF_TEXT, CF_BITMAP,\x0D\x0A"\
"CF_OWNERDISPLAY, CF_HDROP formats.\x0D\x0A"\
" 1999-2003 Gladiators Software";


static char* Empty = "The clipboard is empty.";
static char* Error = "Unable to display format.";


TPluginInfo PluginInfo;
TFont Font;

#define def_tipwidth 480

#define szBackCl "BackColor"
#define szForeCl "ForeColor"
#define szFont "Font"
#define szShowCRLF "ShowCRLF"
#define szTipWidth "TipWidth"

static TKey ClipViewKeys[]
/*#4 bad array bound(s) !!!A*/
 = 
{
  {
    szFont, 
    KEY_FONT, szFont, 0, 
    0, 0
  }, 
  {
    szForeCl, 
    KEY_COLOR, szForeCl, 0xffffff, 
    0, 0
  }, 
  {
    szBackCl, 
    KEY_COLOR, szBackCl, 0x000000, 
    0, 0
  },
  {
    szTipWidth, 
    KEY_INT | KEY_NOTHEME, "Width Of Hint", def_tipwidth, 
    0, 0
  },
  {
    szShowCRLF, 
    KEY_BOOL | KEY_NOTHEME, "Show Line Breaks", 0, 
    0, 0
  }
};


/*----------------------------------------------------------------*/ 
#define max_text 512
char * text = NULL;
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

void SetAutoView(void)
{
  uFormat = GetPriorityClipboardFormat(auPriorityList, sizeof(auPriorityList)/sizeof(UINT));
  InvalidateRect(hSDKWnd, NULL, TRUE);
  UpdateWindow(hSDKWnd);
};
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

int shortintstrlen(char* p)
{
/*#5 BASM !!!E*/
  __asm
  {
            MOV     EDX,EDI
            MOV     EDI,p
            MOV     ECX,0FFH
            XOR     AL,AL
            REPNE   SCASB
            MOV     EAX,0FEH
            SUB     EAX,ECX
            MOV     EDI,EDX
  }
};
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

LONG WINAPI WndProcSDK(HWND Window, UINT Message, WPARAM wParam, LPARAM lParam)
{
  
  PAINTSTRUCT ps;
  HDC dc;
  HBITMAP Old;
  HBITMAP hbm;
  HFONT OldFont;
  HANDLE hglb;
  char* lpstr;
  RECT r;
  int l;
  int OldMode;
  int OldColor;
  //1.8c
  HWND hwndOwner;
  LPVOID lpps, hdrop;
  {
    LONG result;
    
    if (!(*(AData.HideFlag)))
    NotifyTip(AData.ToolTip, Window, Message, wParam, lParam);
    
    result = 0;
    switch (Message)
    {
      case WM_MBUTTONUP:
      {
        PostMessage(AData.MainWindow, CM_POPUPMAINMENU, 0, 0);
        return result;
      };
      break;
      case WM_PAINT:
      {
        dc = BeginPaint(Window, &ps);
        CopyRect(&r, &ClientRect);
        InflateRect(&r, -1, -1);

        lstrcpy(text, szClipView);
        
        switch (uFormat)
        {
        case CF_OWNERDISPLAY: 
          hwndOwner = GetClipboardOwner(); 
          hglb = GlobalAlloc(GMEM_MOVEABLE, sizeof(PAINTSTRUCT)); 
          lpps = GlobalLock(hglb); 
          RtlMoveMemory(lpps, &ps, sizeof(PAINTSTRUCT)); 
          GlobalUnlock(hglb); 
          SendMessage(hwndOwner, WM_PAINTCLIPBOARD, (WPARAM) Window, (LPARAM) hglb); 
          GlobalFree(hglb); 
          break; 
        case CF_BITMAP:
          if (OpenClipboard(Window))
          {
            hbm = ((HBITMAP)(GetClipboardData(uFormat)));
            Old = SelectObject(AData.MemoryDC, hbm);
            BitBlt(dc, 1, 1, r.right, r.bottom, AData.MemoryDC, 
            0, 0, SRCCOPY);
            SelectObject(AData.MemoryDC, Old);
            CloseClipboard();
          };
          break;
        case CF_TEXT:
          if (OpenClipboard(Window))
          {
            OldFont = SelectObject(dc, Font.Handle);
            OldMode = SetBkMode(dc, TRANSPARENT);
            OldColor = SetTextColor(dc, ForeCl);
            
            hglb = GetClipboardData(uFormat);
            lpstr = GlobalLock(hglb);
            l = shortintstrlen(lpstr);

            RtlMoveMemory(text, lpstr, l);
            text[l] = 0;

            DrawText(dc, lpstr, l, &r, DT_LEFT | 
              (ShowCRLF ? DT_SINGLELINE : DT_WORDBREAK) | 
              DT_NOPREFIX);
            
            GlobalUnlock(hglb);
            CloseClipboard();
            SetTextColor(dc, OldColor);
            SetBkMode(dc, OldMode);
            SelectObject(dc, OldFont);
          };
          break;

        case CF_HDROP:
          if (OpenClipboard(Window))
          {

            OldFont = SelectObject(dc, Font.Handle);
            OldMode = SetBkMode(dc, TRANSPARENT);
            OldColor = SetTextColor(dc, ForeCl);

            hglb = GetClipboardData(uFormat);
            hdrop = GlobalLock(hglb);
            if (NULL != hdrop)
            {
              RECT tmpr;
              int height, L;
              char szFileName[MAX_PATH + 1];
              UINT nNames;
              UINT nFiles = DragQueryFile(hdrop, (UINT)-1, NULL, 0);
              
              SetRectEmpty(&tmpr);
              tmpr.right = 1;
              DrawText(dc, szClipView, 1, &tmpr, DT_CALCRECT | DT_SINGLELINE);

              height = r.bottom;
              r.bottom = tmpr.bottom + 1;
    
              lstrcpy(text, "[File");
              if (nFiles > 1 )
                lstrcat(text, "s]\x0D\x0A");
              else
                lstrcat(text, "]\x0D\x0A");
              L = lstrlen(text);

              for(nNames = 0; nNames < nFiles; nNames++)
              {
                RtlZeroMemory(szFileName, MAX_PATH + 1);
                DragQueryFile(hdrop, nNames, (LPTSTR)szFileName, MAX_PATH + 1);
                
                if (max_text - L > 4)
                {
                  lstrcpyn(&text[L], szFileName, max_text - L);
                  L = lstrlen(text);
                  if (nNames != nFiles - 1)
                  {
                    lstrcpy(&text[L], "\x0D\x0A");
                    L += 2;
                  }
                }

                DrawText(dc, szFileName, -1, &r, DT_LEFT | 
                  DT_PATH_ELLIPSIS |
                  DT_NOPREFIX);
                OffsetRect(&r, 0, tmpr.bottom);
                if (r.top >= height)
                  break;
              }
              GlobalUnlock(hglb);
            }
            else
            DrawText(dc, Error, -1, &r, DT_CENTER | DT_WORDBREAK);

            SetTextColor(dc, OldColor);
            SetBkMode(dc, OldMode);
            SelectObject(dc, OldFont);

            CloseClipboard();
          };
          break;

        case 0:
          {
            OldFont = SelectObject(dc, Font.Handle);
            OldMode = SetBkMode(dc, TRANSPARENT);
            OldColor = SetTextColor(dc, ForeCl);
            DrawText(dc, Empty, -1, &r, DT_CENTER | DT_WORDBREAK);
            lstrcpy(text, Empty);
            SetTextColor(dc, OldColor);
            SetBkMode(dc, OldMode);
            SelectObject(dc, OldFont);
          };
          break;
        default:
          {
            OldFont = SelectObject(dc, Font.Handle);
            OldMode = SetBkMode(dc, TRANSPARENT);
            OldColor = SetTextColor(dc, ForeCl);
            DrawText(dc, Error, -1, &r, DT_CENTER | DT_WORDBREAK);
            lstrcpy(text, Error);
            SetTextColor(dc, OldColor);
            SetBkMode(dc, OldMode);
            SelectObject(dc, OldFont);
          };
          
          
        };
        
        EndPaint(Window, &ps);
        return result;
      };
      break;
      case WM_CHANGECBCHAIN:
      {
        if (((HWND)(wParam)) == FWndNext)
        FWndNext = ((HWND)(lParam));
        else
        if (FWndNext != 0)
        SendMessage(FWndNext, Message, wParam, lParam);
      };
      break;
      case WM_DRAWCLIPBOARD:
      {
        SetAutoView();
        if (FWndNext != 0)
        SendMessage(FWndNext, Message, wParam, lParam);
      };
      break;
      case WM_MOUSEMOVE:
      if (*(AData.HideFlag))
      {
        SendMessage(AData.ToolContainer[AData.iID], CM_TOOLPLUGINMOUSEMOVE, 0, 0);
        return result;
      };
      break;
      case WM_ERASEBKGND:
      {
        FillRect(((HDC)(wParam)), &ClientRect, BkBrush);
        DrawEdge(((HDC)(wParam)), &ClientRect, BDR_SUNKENOUTER, BF_RECT);
        result = 1;
        return result;
      };
      break;
      case WM_NOTIFY:
      {
        switch (((LPNMHDR)(lParam))->code)
        {
        case TTN_NEEDTEXT:
          {
            SendMessage(((LPNMHDR)(lParam))->hwndFrom, TTM_SETMAXTIPWIDTH, 0, tipwidth);
            (*((LPTOOLTIPTEXT)(lParam))).lpszText = &text[0];
          }
          break;
        
        case TTN_SHOW:
          {
            result = ((LONG)(SetWindowPos(((LPNMHDR)(lParam))->hwndFrom, HWND_TOPMOST, 0, 0, 0, 0, 
              SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE)));
            
          };
        };
        return result;
      };
      
    };
    result = DefWindowProc(Window, Message, wParam, lParam);
    return result;
  };
};
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
void ReadConfig(void)
{
  
  TCFG CFG;
  {
/*with (AData)*/
    {
      OpenCFGr(AData.PluginsCFG, &CFG);
      FindSection(szClipView, 0, &CFG);
      ForeCl = GetCFGHex(szForeCl, 0xffffff, &CFG);
      BkBrush = CreateSolidBrush(GetCFGHex(szBackCl, 0, &CFG));
      GetCFGFont(szFont, &Font, &CFG);
      ShowCRLF = GetCFGBool(szShowCRLF, 0, &CFG);
      tipwidth = GetCFGInt(szTipWidth, def_tipwidth, &CFG);
      CloseCFGr(&CFG);
    };
  };
};

/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
void InitClipView(void)
{
  ReadConfig();
  GetFontHandle(&Font, GetStockObject(ANSI_VAR_FONT));
  FWndNext = SetClipboardViewer(hSDKWnd);
  
  text = HeapAlloc(GetProcessHeap(), 0, max_text + 4);
  lstrcpy(text, szClipView);

  ti.cbSize = sizeof(TOOLINFO);
  ti.uFlags = TTF_CENTERTIP;
  ti.hwnd = hSDKWnd;
  ti.uId = 1;
  GetClientRect(hSDKWnd, &ClientRect);
  CopyRect(&ti.rect, &ClientRect);
  InflateRect(&ti.rect, -1, -1);
  ti.hinst = hInstance;
  ti.lpszText = LPSTR_TEXTCALLBACK;
  SendMessage(AData.ToolTip, TTM_ADDTOOL, 0, ((LPARAM)(&ti)));
};

/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
void WINAPI InitToolbarModule(PToolData ad)
{
  
  WNDCLASS WindowClass;
  {
    RtlMoveMemory(&AData, ad, sizeof(TToolData));
    if (ad->cbsize < sizeof(TToolData))
    return;
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WndProcSDK;
    WindowClass.hCursor = LoadCursor(0, IDC_ARROW);
    WindowClass.lpszClassName = szClipView;
    if (RegisterClass(&WindowClass) == 0)
    return;
    
    SizeX = AData.Ring1->ToolSizeX[AData.iID];
    SizeY = AData.Ring1->ToolSizeY[AData.iID];
    
    
/*with (AData)*/
    {
      hSDKWnd = CreateWindowEx(0, 
      szClipView, 
      NULL, 
      WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
      
      0, 
      AData.Position*SizeY, SizeX, 
      SizeY, AData.ToolContainer[AData.iID], 
      0, 
      hInstance, 
      NULL);
      
      if (hSDKWnd == 0)
      return;
      
      
      AData.Node->Wnd = hSDKWnd;
    };
    
    InitClipView();
  };
};
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
void WINAPI DoneModule(void)
{
  if (hSDKWnd != 0)
  {
    SendMessage(AData.ToolTip, TTM_DELTOOL, 0, ((LPARAM)(&ti)));
    
    ChangeClipboardChain(hSDKWnd, FWndNext);
    DestroyWindow(hSDKWnd);
    hSDKWnd = 0;
    FreeFont(&Font);
    RtlZeroMemory(&Font, sizeof(Font));
    if (BkBrush != 0)
    DeleteObject(BkBrush);
    BkBrush = 0;
  };
  if (text)
    HeapFree(GetProcessHeap(), 0, text);
  text = NULL;
  UnregisterClass(szClipView, hInstance);
};
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

PPluginInfo WINAPI GetPluginInfo(void)
{
  PPluginInfo result;
  
  PluginInfo.cbSize = sizeof(TPluginInfo);
  PluginInfo.szName = szClipView;
  PluginInfo.szDescription = szAbout;
  PluginInfo.szSection = szClipView;
  PluginInfo.nKeyCount = sizeof(ClipViewKeys)/sizeof(TKey);
  PluginInfo.Keys = (PKey)&ClipViewKeys;
  result = &PluginInfo;
  return result;
};

/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

