/* Gladiators Software, 1999-2006*/ 



#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:CpuMon.def")
#pragma comment(linker,"/entry:DllMain")

#include <windows.h>
#include "../SDK/rtlmem.h"
#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"
#include "getcpuu.h"
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}


//----------------------------------------------------------------
//----------------------------------------------------------------
extern BYTE (*RealGetCPUusage)(void);
extern BOOL bInitialized;

HWND hCPUWnd;//CPU Monitor
BOOL bTimer = FALSE;
TToolData AData;
RECT ClientRect;
HPEN BlackPen = 0;
HPEN GreenPen = 0;
HPEN RedPen = 0;
HBRUSH Brush = 0;
BOOL bVxdUse;

#define szFormat "CPU: %2u%%"
char szCpuHint[32];
TOOLINFO ti;
BYTE biOld = 255;
BOOL IsShowTip;
UINT _Width;
UINT _Height;


#define szBackCl "BackColor"
#define szCpuCl "CPUColor"
#define szLineCl "LineColor"
#define szElapse "Elapse"
#define szUseVXD "UseVXD"

//---------------------------------
static char szCPU[] = "CPU Monitor\x00";
#define TimerID 1

//#define NtdwSize 0x138
#define USA

#ifdef RUS
#define szAbout "CPU Monitor - ,   \x0D\x0A"\
"    ()."
#endif
#ifdef USA
#define szAbout "CPU(s) usage monitor 1.8c\x0D\x0A"\
" 1999-2003 Gladiators Software"
#endif

typedef struct 
{ 
  char ID[sizeof(szCPU) + 1];
  UINT pos;
  BYTE bytes[];
} TCpuRec, *PCpuRec;

PCpuRec history;

TPluginInfo PluginInfo;

static TKey CPUKeys[]
 = 
{
  {
    szElapse, 
    KEY_INT_RANGE | KEY_NOTHEME, szElapse, 950, 
    200, 10000
  }, 
  {
    szCpuCl, 
    KEY_COLOR, szCpuCl, 0xffff00, 
    0, 0
  }, 
  {
    szLineCl, 
    KEY_COLOR, szLineCl, 0x0000ff, 
    0, 0
  }, 
  {
    szBackCl, 
    KEY_COLOR, szBackCl, 0x000000, 
    0, 0
  }, 
  {
    szUseVXD, 
    KEY_BOOL | KEY_NOTHEME, "Use VXD driver", 1, 
    0, 0
  }
};

//---------------------------------
#define CM_APPBAR WM_USER+2
BOOL bFullScreen;
APPBARDATA bd;

// -------------------------------------------------------------------------------------------------------
void InitToolTips(void)
{
  IsShowTip = FALSE;
  ti.cbSize = sizeof(TOOLINFO);
  ti.uFlags = TTF_CENTERTIP;
  ti.hwnd = hCPUWnd;
  ti.uId = 1;
  CopyRect(&ti.rect, &ClientRect);
  InflateRect(&ti.rect, -1, -1);
  ti.hinst = hInstance;
  lstrcpy(szCpuHint, szCPU);
  ti.lpszText = &szCpuHint[0];
  SendMessage(AData.ToolTip, TTM_ADDTOOL, 0, ((LPARAM)(&ti)));
}
// -------------------------------------------------------------------------------------------------------
//==========================================================================
void UpdateTip(void)
{
  if (biOld != history->bytes[history->pos])
  {
    UINT i;
    i = biOld = history->bytes[history->pos];
    wvsprintf(szCpuHint, szFormat, (CHAR *)&i);
    SendMessage(AData.ToolTip, TTM_UPDATETIPTEXT, 0, ((LONG)(&ti)));
  };
};
//-----------------------------------------
LONG WINAPI WndProcCPU(HWND window, UINT message, WPARAM wParam, LPARAM lParam)
{
  PAINTSTRUCT ps;
  HDC dc;
  HGDIOBJ OldPen;
  UINT u;
  
  {
    LONG result;
    
    if (!(*(AData.HideFlag)))
    NotifyTip(AData.ToolTip, window, message, wParam, lParam);
    
    result = 0;
    switch (message)
    {
      case WM_TIMER:
      {
        if (!bInitialized)
        {
          InitCPUMon(bVxdUse, AData.osver->dwPlatformId == VER_PLATFORM_WIN32_NT);
          return result;
        };

        ++(history->pos);
        if (history->pos >= _Width)
          history->pos = 0;
          
        history->bytes[history->pos] = RealGetCPUusage();
          
        if (!(*(AData.HideFlag)) && !bFullScreen)
        {
          UINT h;

          if (IsShowTip)
            UpdateTip();
          dc = GetDC(window);
          u = history->pos;
          h = (history->bytes[u++] * _Height) / 100;
          if (0 == h)
          {
            OldPen = SelectObject(dc, BlackPen);
            MoveToEx(dc, u, _Height, NULL);
            LineTo(dc, u, 0);
          }
          else
          if (_Height == h)
          {
            OldPen = SelectObject(dc, GreenPen);
            MoveToEx(dc, u, _Height, NULL);
            LineTo(dc, u, 0);
          }
          else
          {
            OldPen = SelectObject(dc, GreenPen);
            MoveToEx(dc, u, _Height, NULL);
            LineTo(dc, u, _Height - h);
            SelectObject(dc, BlackPen);
            LineTo(dc, u, 0);
          }
            
          SelectObject(dc, RedPen);
          if (u == _Width)
            u = 0;
          MoveToEx(dc, ++u, _Height, NULL);
          LineTo(dc, u, 0);
          SelectObject(dc, OldPen);
          ReleaseDC(window, dc);
        };
        return result;
      };
      
      break;
      case WM_MBUTTONUP:
      {
        PostMessage(AData.MainWindow, CM_POPUPMAINMENU, 0, 0);
        return result;
      };
      break;
      case WM_ERASEBKGND:
      {
        FillRect(((HDC)(wParam)), &ClientRect, Brush);
        DrawEdge(((HDC)(wParam)), &ClientRect, BDR_SUNKENOUTER, BF_RECT);
        result++;
        return result;
      };
      break;
      case WM_PAINT:
      {
        UINT h;
        dc = BeginPaint(window, &ps);

        OldPen = SelectObject(dc, GreenPen);
        for (u = 1; u <= _Width; u++)
        {
          h = (history->bytes[u - 1] * _Height) / 100;
          if (0 != h)
          {
            MoveToEx(dc, u, _Height, NULL);
            LineTo(dc, u, _Height - h);
          }
        };
        
        SelectObject(dc, RedPen);
        u = history->pos;
        if (++u == _Width)
          u = 0;
        
        MoveToEx(dc, ++u, _Height, NULL);
        LineTo(dc, u, 0);
        SelectObject(dc, OldPen);
        
        EndPaint(window, &ps);
        return result;
      };
      
      break;
      case WM_MOUSEMOVE:
      {
        if (*(AData.HideFlag))
        {
          PostMessage(AData.ToolContainer[AData.iID], message, wParam, lParam);
        };
      };
      
      break;
      case WM_NOTIFY:
      {
        switch ((*(LPNMHDR)(lParam)).code)
        {
          case TTN_SHOW:
          {
            result = ((int)(SetWindowPos((*(LPNMHDR)(lParam)).hwndFrom, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE)));
            
            IsShowTip = TRUE;
          };
          break;
          case TTN_POP:
          {
            IsShowTip = FALSE;
          };
        };
        return result;
      };
      break;
      case CM_APPBAR:
      {
        if (wParam == ABN_FULLSCREENAPP)
          bFullScreen = lParam != 0;
        if (!bFullScreen) 
          InvalidateRect(window, NULL, TRUE);
        return result;
      };
    };
    result = DefWindowProc(window, message, wParam, lParam);
    return result;
  };
};
    
//----------------------------------------------------------------
void ReadConfig(void)
{
  
  TCFG CFG;
  int iElapse;
  UINT Cl;
  {
    OpenCFGr(AData.PluginsCFG, &CFG);
    FindSection(szCPU, 0, &CFG);
    Cl = GetCFGHex(szBackCl, 0, &CFG);
    BlackPen = CreatePen(PS_SOLID, 1, Cl);
    Brush = CreateSolidBrush(Cl);
    GreenPen = CreatePen(PS_SOLID, 1, GetCFGHex(szCpuCl, 0xffff00, &CFG));
    RedPen = CreatePen(PS_SOLID, 1, GetCFGHex(szLineCl, 0x0000ff, &CFG));
    iElapse = GetCFGInt(szElapse, 950, &CFG);
    bVxdUse = GetCFGInt(szUseVXD, 1, &CFG) != 0;
    CloseCFGr(&CFG);
    CheckInt(&iElapse, 250, 5000, 950);
    bTimer = SetTimer(hCPUWnd, TimerID, iElapse, NULL) != 0;
  };
};
    
//------------------------
void WINAPI InitToolbarModule(PToolData ad)
{
  
  WNDCLASS WindowClass;
  {
    RtlMoveMemory(&AData, ad, sizeof(TToolData));
    if (ad->cbsize < sizeof(TToolData))
      return;
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WndProcCPU;
    WindowClass.hCursor = LoadCursor(0, IDC_ARROW);
    WindowClass.lpszClassName = szCPU;
    if (RegisterClass(&WindowClass) == 0)
      return;//    :)
    
//CPU Mon
    hCPUWnd = CreateWindowEx(0, 
      szCPU, 
      NULL, 
      WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
      0, 
      AData.Position * AData.Ring1->ToolSizeY[AData.iID], 
      AData.Ring1->ToolSizeX[AData.iID], 
      AData.Ring1->ToolSizeY[AData.iID], 
      AData.ToolContainer[AData.iID], 
      0, 
      hInstance, 
      NULL);
      
    if (hCPUWnd == 0)
      return;
    AData.Node->Wnd = hCPUWnd;
      
    GetClientRect(hCPUWnd, &ClientRect);
      
    _Width = AData.Ring1->ToolSizeX[AData.iID]-2;
    _Height = AData.Ring1->ToolSizeY[AData.iID]-2;
      
    if ((UINT)SendMessage(AData.MainWindow, CM_GETPLUGINMEMSIZE, 0, ((LPARAM)(&szCPU[0]))) == (UINT)sizeof(TCpuRec)+_Width)
    {//try to restoremem
        history = (PCpuRec)SendMessage(AData.MainWindow, CM_RESTOREPLUGINMEM, 0, ((LPARAM)(&szCPU[0])));
        {
          if (history->pos >= _Width)
            history->pos = 0;
        };
    }
    else
    {//alloc mem
        history = (PCpuRec)SendMessage(AData.MainWindow, CM_SAVEPLUGINMEM, sizeof(TCpuRec)+_Width, ((LPARAM)(&szCPU[0])));
        RtlZeroMemory(&history->bytes[0], _Width);
        history->pos = 0;
    };
      
    bFullScreen = SendMessage(AData.MainWindow, CM_GETFULLSCREEN, 0, 0) != 0;
    bd.cbSize = sizeof(APPBARDATA);
    bd.uCallbackMessage = CM_APPBAR;
    bd.hWnd = hCPUWnd;
    SHAppBarMessage(ABM_NEW, &bd);
    
    ReadConfig();
    InitToolTips();
  };
};
//===================================================================
void WINAPI DoneModule(void)
{
  if (bTimer)
  {
    bTimer = FALSE;
    KillTimer(hCPUWnd, TimerID);
  };
  if (hCPUWnd != 0)
  {
    SendMessage(AData.ToolTip, TTM_DELTOOL, 0, ((LPARAM)(&ti)));

    SHAppBarMessage(ABM_REMOVE, &bd);
    
    DestroyWindow(hCPUWnd);
    hCPUWnd = 0;

    DoneCPUmon(AData.osver->dwPlatformId == VER_PLATFORM_WIN32_NT);

    if (BlackPen != 0)
      DeleteObject(BlackPen);
    BlackPen = 0;
    
    if (GreenPen != 0)
      DeleteObject(GreenPen);
    GreenPen = 0;

    if (RedPen != 0)
      DeleteObject(RedPen);
    RedPen = 0;

    if (Brush != 0)
      DeleteObject(Brush);
    Brush = 0;
  };
  UnregisterClass(szCPU, hInstance);
};

//--------------------------------------
PPluginInfo WINAPI GetPluginInfo(void)
{
  OSVERSIONINFO os;
  {
    PPluginInfo result;
    
    PluginInfo.cbSize = sizeof(TPluginInfo);
    PluginInfo.szName = szCPU;
    PluginInfo.szDescription = szAbout;
    PluginInfo.szSection = szCPU;
    PluginInfo.nKeyCount = sizeof(CPUKeys)/sizeof(TKey);
    os.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&os);
    if (os.dwPlatformId == VER_PLATFORM_WIN32_NT)
    --PluginInfo.nKeyCount;//disable vxd
    PluginInfo.Keys = (PKey)&CPUKeys;
    result = &PluginInfo;
    return result;
  };
};

//pas2c32 warnings: 6
