//getcpuu.c

#include <windows.h>

BYTE (*RealGetCPUusage)(void);
BOOL bInitialized = FALSE;
HKEY perfKey = 0;// Registry key to get cpu usage
HANDLE hNtDll = 0;
HANDLE HVxDHandle = 0;

extern HMODULE hInstance;

#define szUsage9x "KERNEL\\CPUUsage"
#define szVxDName "\\\\.\\CPUUSAGE.VXD"
#define szNtDll "ntdll.dll"

BYTE GetCPUusageUnknown(void)
{
  return 0;
};
//---------------------------------
BYTE GetCPUusage95(void)
{
  DWORD dwUsage = 0;
  DWORD dataLen = 4;
  RegQueryValueEx(perfKey, szUsage9x, NULL, NULL, (LPBYTE)&dwUsage, &dataLen);
  if (LOBYTE(dwUsage) > 100)
    return 100;
  else
    return LOBYTE(dwUsage);
};

BYTE GetCPUusage95VXD(void)
{
  DWORD d;
  DWORD dwUsage = 0;
  DeviceIoControl(HVxDHandle, 2, NULL, 0, &dwUsage, sizeof(dwUsage), &d, NULL);
  if (LOBYTE(dwUsage) > 100)
    return 100;
  else
    return LOBYTE(dwUsage);
};
//---------------------------------
//---------------------------------
#define	SystemBasicInformation			0 
#define	SystemPerformanceInformation	2 
#define	SystemTimeInformation			3 

#define	Li2Double(x) ((double)((x).HighPart) * 4.294967296E9 + (double)((x).LowPart)) 

typedef	struct 
{ 
	DWORD	dwUnknown1; 
	ULONG	uKeMaximumIncrement; 
	ULONG	uPageSize; 
	ULONG	uMmNumberOfPhysicalPages; 
	ULONG	uMmLowestPhysicalPage; 
	ULONG	uMmHighestPhysicalPage;	
	ULONG	uAllocationGranularity;	
	PVOID	pLowestUserAddress; 
	PVOID	pMmHighestUserAddress; 
	ULONG	uKeActiveProcessors; 
	BYTE	bKeNumberProcessors; 
	BYTE	bUnknown2; 
	WORD	wUnknown3; 
} SYSTEM_BASIC_INFORMATION; 

typedef	struct 
{ 
	LARGE_INTEGER	liIdleTime; 
	DWORD			dwSpare[76]; 
} SYSTEM_PERFORMANCE_INFORMATION; 

typedef	struct 
{ 
	LARGE_INTEGER	liKeBootTime; 
	LARGE_INTEGER	liKeSystemTime;	
	LARGE_INTEGER	liExpTimeZoneBias; 
	ULONG			uCurrentTimeZoneId; 
	DWORD			dwReserved; 
} SYSTEM_TIME_INFORMATION; 

// ntdll!NtQuerySystemInformation (NT specific!) 
// 
// The function	copies the system information of the 
// specified type into a buffer	
// 
// NTSYSAPI 
// NTSTATUS 
// NTAPI 
// NtQuerySystemInformation( IN		UINT	SystemInformationClass,	 // information	type 
//							 OUT	PVOID	SystemInformation,		 // pointer to buffer 
//							 IN		ULONG	SystemInformationLength, // buffer size	in bytes 
//							 OUT	PULONG	ReturnLength OPTIONAL ); // pointer to a 32-bit	
//																	 // variable that receives 
//																	 // the	number of bytes	
//																	 // written to the buffer 
//  

typedef	LONG (WINAPI *PROCNTQSI)(UINT,PVOID,ULONG,PULONG); 

PROCNTQSI NtQuerySystemInformation; 

SYSTEM_BASIC_INFORMATION m_SysBaseInfo; 
LARGE_INTEGER m_liOldIdleTime = {0, 0}; 
LARGE_INTEGER m_liOldSystemTime = {0, 0}; 
SYSTEM_TIME_INFORMATION SysTimeInfo; 
SYSTEM_PERFORMANCE_INFORMATION SysPerfInfo; 

//---------------------------------
BYTE GetCPUusageNT(void)
{
  LONG status;
  double dbIdleTime; 
  BYTE result;

  status = NtQuerySystemInformation(SystemTimeInformation, &SysTimeInfo, sizeof(SysTimeInfo), 0); 

  if (status != NO_ERROR) 
    return 0; 

	// get new CPU's idle time 
	status = NtQuerySystemInformation(SystemPerformanceInformation, &SysPerfInfo, sizeof(SysPerfInfo), NULL); 

	if (status != NO_ERROR) 
		return 0; 

	// if it's a first call - skip it 
	if (m_liOldIdleTime.QuadPart != 0) 
	{ 
		double dbSystemTime; 

		// CurrentValue = NewValue - OldValue 
		dbIdleTime = Li2Double(SysPerfInfo.liIdleTime) - Li2Double(m_liOldIdleTime); 
		dbSystemTime = Li2Double(SysTimeInfo.liKeSystemTime) - Li2Double(m_liOldSystemTime); 

    if (0.0 == dbSystemTime)
      dbIdleTime = 0.0;//???
    else
		// CurrentCpuIdle = IdleTime / SystemTime 
		  dbIdleTime = dbIdleTime / dbSystemTime; 

		// CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors 
		dbIdleTime = 100.0 - dbIdleTime * 100.0 / (double)m_SysBaseInfo.bKeNumberProcessors + 0.5; 
	} 
	else
		dbIdleTime = 0.0;

	// store new CPU's idle and system time 
	m_liOldIdleTime		= SysPerfInfo.liIdleTime; 
	m_liOldSystemTime	= SysTimeInfo.liKeSystemTime; 

	result = LOBYTE((UINT)dbIdleTime);
  if (result > 100)
    result = 100;
  return result;
};

//---------------------------------
//---------------------------------

void InitCPUMon(BOOL bTryLoadVXD, BOOL bNT)
{
  bInitialized = TRUE;
  RealGetCPUusage = GetCPUusageUnknown;
  
  if (!bNT)
  {
    HKEY startPerfKey;
    DWORD dwUsage, dataLen;
    if (bTryLoadVXD)
    {
      char curdir[MAX_PATH+1];
      char dir[MAX_PATH+1];
      int i;

      GetCurrentDirectory(MAX_PATH, dir);
      curdir[0] = '\x00';
      i = GetModuleFileName(hInstance, curdir, MAX_PATH);
      while ((i > 0) && (curdir[i] != '\\'))
      --i;
      if (curdir[i] == '\\')
      {
        curdir[i] = '\x00';
        SetCurrentDirectory(curdir);
      };
      HVxDHandle = CreateFile(szVxDName, 0, 0, NULL, 0, FILE_FLAG_DELETE_ON_CLOSE, 0);
      SetCurrentDirectory(dir);
      if (HVxDHandle != INVALID_HANDLE_VALUE)
      {
        RealGetCPUusage = GetCPUusage95VXD;
        return;
      };
      HVxDHandle = 0;
    };
    
    RegOpenKey(HKEY_DYN_DATA, "PerfStats\\StartStat", &startPerfKey);
    dataLen = sizeof(dwUsage);
    RegQueryValueEx(startPerfKey, szUsage9x, NULL, NULL, (LPBYTE)&dwUsage, &dataLen);
    //and kernel start cpu monitoring

    RegCloseKey(startPerfKey);
    
    RegOpenKey(HKEY_DYN_DATA, "PerfStats\\StatData", &perfKey);
    RealGetCPUusage = GetCPUusage95;
  }
  else
  {
    hNtDll = GetModuleHandle(szNtDll);
    if (NULL == hNtDll)
      return;
    
    NtQuerySystemInformation = (PROCNTQSI)GetProcAddress(hNtDll, "NtQuerySystemInformation");

    if (!NtQuerySystemInformation) 
      return;
    NtQuerySystemInformation(SystemBasicInformation, &m_SysBaseInfo, sizeof(m_SysBaseInfo), NULL);
    if (0 == m_SysBaseInfo.bKeNumberProcessors)
      m_SysBaseInfo.bKeNumberProcessors++;

    RealGetCPUusage = GetCPUusageNT;
  };
}
//----------------------------------------------------------
void DoneCPUmon(BOOL bNT)
{
  if (!bNT)
  {
    if (HVxDHandle != 0)
    {
      CloseHandle(HVxDHandle);
      HVxDHandle = 0;
    }
    else
    {
      HKEY stopPerfKey;
      DWORD dwUsage, dataLen;

      if (perfKey != 0)
      RegCloseKey(perfKey);
      perfKey = 0;
          
      RegOpenKey(HKEY_DYN_DATA, "PerfStats\\StopStat", &stopPerfKey);
      dataLen = sizeof(dwUsage);
      RegQueryValueEx(stopPerfKey, szUsage9x, NULL, NULL, (LPBYTE)&dwUsage, &dataLen);
      //and kernel stop cpu monitoring
      RegCloseKey(stopPerfKey);
    };
  };
};

//[EOF]