// deskwndc.cpp : Defines the entry point for the DLL application.
//

#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:DeskWndC.def")
#pragma comment(linker,"/entry:DllMain")


#include <windows.h>
#include "../SDK/rtlmem.h"

#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"

HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}

#define szClassName "Desktop Plugin Sample"
#define szXPos "XPos"
#define szYPos "YPos"


TAstonData AData;
HWND ChildWindow = 0;
RECT ClientRC;
int XPos;
int YPos;
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
void SavePos(void)
{
  
  TCFG CFG;
  RECT r;
  {
    OpenCFGw(AData.PluginsCFG, &CFG);
    FindSection(szClassName, SECTION_CREATE_ALWAYS, &CFG);
    GetWindowRect(ChildWindow, &r);
    XPos = r.left;
    YPos = r.top;
    SetCFGInt(szXPos, XPos, &CFG);
    SetCFGInt(szYPos, YPos, &CFG);
    CloseCFGw(AData.PluginsCFG, FALSE, &CFG);
  };
};
/*---------------------------------------------------------------------*/ 
LONG WINAPI WindowProc(HWND Window, UINT Message, WPARAM WParam, LPARAM LParam)
{
  
  HDC DC;
  PAINTSTRUCT ps;
  RECT r;
  RECT r2;
  UINT uFlags;
  {
    LONG result;
    
    result = 0;
    switch (Message)
    {
      case WM_PAINT:
      {
        DC = BeginPaint(Window, &ps);
        GetClientRect(Window, &ClientRC);
        GetWindowRect(Window, &r);
        SetRect(&r2, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
        uFlags = DPEx_CORRECTBRUSH;
/*with (AData.WallPaperInfo)*/
        {
          if (AData.WallPaperInfo.TileWallpaper != 0)
          uFlags = uFlags | DPEx_TILED;
          if (AData.WallPaperInfo.WallpaperStyle == 0)
          uFlags = uFlags | DPEx_CENTERED;
          DrawSkin(DC, DC, &ClientRC, &r, &r2, AData.WallPaperInfo.WallPaper, AData.WallPaperInfo.DesktopBrush, uFlags);
        };
        
        DrawEdge(DC, &ClientRC, BDR_SUNKENOUTER, BF_RECT);
        InflateRect(&ClientRC, -8, -8);
        DrawEdge(DC, &ClientRC, BDR_RAISEDINNER, BF_RECT);
        EndPaint(Window, &ps);
        return result;
      };
      break;
      case WM_ERASEBKGND:
      {
        result = 1;
        return result;
      };
      break;
      case WM_ENTERSIZEMOVE:
      {
        SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) & ~WS_EX_TRANSPARENT);
      };
      break;
      case WM_MOVING:
      {
        InvalidateRect(Window, NULL, FALSE);
      };
      break;
      case WM_EXITSIZEMOVE:
      {
        SavePos();
        SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) | WS_EX_TRANSPARENT);
        InvalidateRect(Window, NULL, FALSE);
      };
      break;
      case WM_NCHITTEST:
      {
        DefWindowProc(Window, Message, WParam, LParam);
        result = HTCAPTION;
        return result;
      };
    };
    result = DefWindowProc(Window, Message, WParam, LParam);
    return result;
  };
};

/*---------------------------------------------------------------------*/ 
void ReadConfig(void)
{
  
  TCFG CFG;
  {
    OpenCFGr(AData.PluginsCFG, &CFG);
    
    FindSection(szClassName, 0, &CFG);
    XPos = GetCFGInt(szXPos, 0, &CFG);
    CheckInt(&XPos, 0, GetSystemMetrics(SM_CXSCREEN)-8, 0);
    YPos = GetCFGInt(szYPos, 1, &CFG);
    CheckInt(&YPos, 0, GetSystemMetrics(SM_CYSCREEN)-8, 0);
    CloseCFGr(&CFG);
  };
};
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 

void WINAPI InitGlobalModule(const PAstonData AstonData)
{
  
  WNDCLASS WindowClass;
  {
    if (AstonData->cbsize < sizeof(TAstonData))
    return;
    RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    WindowClass.style = CS_HREDRAW | CS_VREDRAW;
    WindowClass.hCursor = LoadCursor(0, IDC_ARROW);
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WindowProc;
    WindowClass.lpszClassName = szClassName;
    if (RegisterClass(&WindowClass) == 0)
    return;
    
    
    ReadConfig();
    
    ChildWindow = CreateWindowEx(WS_EX_TRANSPARENT, szClassName, 
    NULL, 
    WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
    XPos, 
    YPos, 64, 
    48, AData.Desktop, 
    0, 
    WindowClass.hInstance, 
    NULL);
    
    
    AData.Node->Wnd = ChildWindow;
    GetClientRect(ChildWindow, &ClientRC);
  };
};

/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 

void WINAPI DoneModule(void)
{
  if (ChildWindow != 0)
  {
    DestroyWindow(ChildWindow);
    ChildWindow = 0;
  };
  UnregisterClass(szClassName, hInstance);
};

/*---------------------------------------------------------------------*/ 

