/* Gladiators Software, 1999-2006*/ 

/*---------------------------------------------------------------------*/ 
#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:InVis.def")
#pragma comment(linker,"/entry:DllMain")


#include <windows.h>
#include "../SDK/rtlmem.h"

#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"

HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}

static char* szName = "Aston Plugin Sample";
static char* szHello = "Hello!";
#define CM_ICONMESSAGE (WM_USER+1)

TAstonData AData;
HWND ChildWindow = 0;
HICON SmallIcon;
NOTIFYICONDATA ta;
BOOL Added = FALSE;
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
void ShowMenu(void)
{
  
  HMENU Menu;
  TPMPARAMS TP;
  POINT p;
  {
    Menu = CreatePopupMenu();
    AppendMenu(Menu, MF_STRING, 100, szHello);
    
    SetForeWndFix(AData.Taskbar, AData.osver);
    SetFocus(ChildWindow);
    
    TP.cbSize = sizeof(TPMPARAMS);
    GetWindowRect(AData.Taskbar, &TP.rcExclude);
    GetCursorPos(&p);
    SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);//avoid AV
    TrackPopupMenuEx(Menu, TPM_RIGHTBUTTON, p.x, p.y, ChildWindow, &TP);
    SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);
    DestroyMenu(Menu);
    PostMessage(ChildWindow, WM_NULL, 0, 0);
  };
};

/*---------------------------------------------------------------------*/ 
LONG WINAPI WindowProc(HWND window, UINT message, WPARAM wParam, LPARAM lParam)

{
  LONG result;
  
  result = 0;
  switch (message)
  {
    case CM_ICONMESSAGE:
    {
      if (lParam == WM_RBUTTONDOWN)
        ShowMenu();
      return result;
    };
    break;
    case WM_COMMAND:
    {
      switch (LOWORD(wParam))
      {
        case 100:
        {
          SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);//avoid AV
          MessageBox(0, szHello, szName, MB_OK | MB_TOPMOST | MB_ICONINFORMATION);
          SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);
        };
      };
      return result;
    };
  };
  result = DefWindowProc(window, message, wParam, lParam);
  return result;
};
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
void ReadConfig(void)
/*var
 CFG:TCFG;*/ 
{
/* OpenCFGr(AData.PluginsCFG, @CFG);
   CloseCFGr(@CFG);*/ 
};


/*---------------------------------------------------------------------*/ 
void WINAPI InitGlobalModule(const PAstonData AstonData)
{
  
  WNDCLASS WindowClass;
  {
    if (AstonData->cbsize < sizeof(TAstonData))
      return;
    RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WindowProc;
    WindowClass.lpszClassName = szName;
    if (RegisterClass(&WindowClass) == 0)
    return;
    
    
    //ReadConfig();
    
    ChildWindow = CreateWindowEx(0, szName, 
    NULL, 
    WS_CHILD, 
    0, 
    0, 0, 
    0, AData.Taskbar, 
    0, 
    hInstance, 
    NULL);
    
    
    AData.Node->Wnd = ChildWindow;
    
    SmallIcon = LoadImage(hInstance, ((char*)(1)), IMAGE_ICON, 16, 16, 0);
    
    ta.cbSize = sizeof(NOTIFYICONDATA);
    ta.hWnd = ChildWindow;
    ta.uID = 1;
    
    ta.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
    ta.uCallbackMessage = CM_ICONMESSAGE;
    ta.hIcon = SmallIcon;
    lstrcpy(ta.szTip, szHello);
    __asm
    {
      MOV EAX, offset ta
      CALL AData.AddTrayIcon
      MOV Added, EAX
    }
  };
};

/*---------------------------------------------------------------------*/ 
void WINAPI DoneModule(void)
{
  if (Added)
  __asm
  {
    MOV EAX, offset ta
    CALL AData.RemoveTrayIcon
  }
  Added = FALSE;
  if (ChildWindow != 0)
  {
    DestroyWindow(ChildWindow);
    ChildWindow = 0;
  };
  if (SmallIcon != 0)
    DestroyIcon(SmallIcon);
  SmallIcon = 0;
  UnregisterClass(szName, hInstance);
};

/*---------------------------------------------------------------------*/ 
