/* Gladiators Software, 1999-2006*/ 

/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:ShutDown.def")
#pragma comment(linker,"/entry:DllMain")


#include <windows.h>
#include "../SDK/rtlmem.h"

#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"

HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}
/*---------------------------------------------------------------------*/ 

static char* szName = "Aston Tray Shutdown";
static char* szHelp = "Aston Tray Shutdown 1.8c\x0D\x0A"\
" 1999-2006 Gladiators Software\x0D\x0A"\
"Press and hold down the \"Ctrl\" key to\x0D\x0A"\
"forces processes to terminate.\x0D\x0A"\
"Warning!\x0D\x0A"\
"This can cause the applications to lose data.\x0D\x0A"\
"You should only use this key in an emergency.";



#define CM_ICONMESSAGE (WM_USER+1)

static char* SeDown = "SeShutdownPrivilege";

#define szATX "ATX poweroff"
static TKey Keys[] = {
{
  szATX, 
  KEY_BOOL | KEY_NOTHEME, szATX, 1, 
  0, 0
}};


TAstonData AData;
HWND ChildWindow = 0;
HICON SmallIcon;
NOTIFYICONDATA ta;
BOOL Added = FALSE;
BOOL ATX;
/*---------------------------------------------------------------------*/ 
TPluginInfo PluginInfo;
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
void AdjustPrivileges(char* pp)
{
  
  HANDLE hToken;
  TOKEN_PRIVILEGES tkp;
  {
    if (AData.osver->dwPlatformId != VER_PLATFORM_WIN32_NT)
    return;
    if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
    return;
    LookupPrivilegeValue(NULL, pp, &tkp.Privileges[0].Luid);
    tkp.PrivilegeCount = 1;
    tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
    AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, NULL, NULL);
    CloseHandle(hToken);
  };
};

/*---------------------------------------------------------------------*/ 
void DoAction(LONG lParam)
{
  
  int Flags;
  {
    switch (lParam)
    {
      case WM_LBUTTONDOWN:
      {
        if (ATX)
        Flags = EWX_POWEROFF;
        else
        Flags = EWX_SHUTDOWN;
      };
      break;
      case WM_RBUTTONDOWN:
      {
        Flags = EWX_REBOOT;
      };
      break;
      default:
      return;
    };
    AdjustPrivileges(SeDown);
    if (GetAsyncKeyState(VK_CONTROL) < 0)
      Flags |= EWX_FORCE;
    ExitWindowsEx(Flags, 0);
  };
};

/*---------------------------------------------------------------------*/ 
LONG WINAPI WindowProc(HWND window, UINT message, WPARAM wParam, LPARAM lParam)

{
  LONG result;
  
  result = 0;
  switch (message)
  {
    case CM_ICONMESSAGE:
    {
      DoAction(lParam);
      return result;
    };
  };
  result = DefWindowProc(window, message, wParam, lParam);
  return result;
};
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
void ReadConfig(void)
{
  
  TCFG CFG;
  {
    OpenCFGr(AData.PluginsCFG, &CFG);
    FindSection(szName, 0, &CFG);
    ATX = GetCFGBool(szATX, TRUE, &CFG);
    CloseCFGr(&CFG);
  };
};
/*----------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
void WINAPI InitGlobalModule(const PAstonData AstonData)
{
  
  WNDCLASS WindowClass;
  {
    if (AstonData->cbsize < sizeof(TAstonData))
    return;
    RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WindowProc;
    WindowClass.lpszClassName = szName;
    if (RegisterClass(&WindowClass) == 0)
    return;
    
    ReadConfig();
    
    ChildWindow = CreateWindowEx(0, szName, 
    NULL, 
    WS_CHILD, 
    0, 
    0, 0, 
    0, AData.Taskbar, 
    0, 
    hInstance, 
    NULL);
    
    
    AData.Node->Wnd = ChildWindow;
    
    SmallIcon = LoadImage(hInstance, ((char*)(1)), IMAGE_ICON, 16, 16, LR_SHARED);
    
    ta.cbSize = sizeof(NOTIFYICONDATA);
    ta.hWnd = ChildWindow;
    ta.uID = 1;
    
    ta.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
    ta.uCallbackMessage = CM_ICONMESSAGE;
    ta.hIcon = SmallIcon;
    lstrcpy(ta.szTip, "Left-click - shutdown\x0D\x0A"\
    "Right-click - reboot");
    
    __asm
    {
      MOV EAX, offset ta
      CALL AData.AddTrayIcon
      MOV Added, EAX
    }
  };
};

/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
void WINAPI DoneModule(void)
{
  if (Added)
  __asm
  {
    MOV EAX, offset ta
    CALL AData.RemoveTrayIcon
  }
  Added = FALSE;
  if (ChildWindow != 0)
  {
    DestroyWindow(ChildWindow);
    ChildWindow = 0;
  };
  UnregisterClass(szName, hInstance);
};

/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
/*---------------------------------------------------------------------*/ 
PPluginInfo WINAPI GetPluginInfo(void)
{
  PPluginInfo result;
  
  PluginInfo.cbSize = sizeof(TPluginInfo);
  PluginInfo.szName = szName;
  PluginInfo.szDescription = szHelp;
  PluginInfo.szSection = szName;
  PluginInfo.nKeyCount = sizeof(Keys)/sizeof(TKey);
  PluginInfo.Keys = (void *)&Keys;
  result = &PluginInfo;
  return result;
};
/*---------------------------------------------------------------------*/ 
//--def---------

//pas2c32 warnings: 5
