/* Gladiators Software, 1999-2006*/ 
#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:TaskWndC.def")
#pragma comment(linker,"/entry:DllMain")

#include <windows.h>
#include "../SDK/rtlmem.h"

#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"


static char* szName = "Aston Plugin Sample";

TAstonData AData;
HWND ChildWindow = 0;
/*----------------------------------------------------------------*/ 

HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}
/*----------------------------------------------------------------*/ 
LONG WINAPI WindowProc(HWND window, UINT message, WPARAM wParam, LPARAM lParam)
{
  
  HDC dc;
  PAINTSTRUCT ps;
  RECT r;
  {
    LONG result;
    
    result = 0;
    switch (message)
    {
      case WM_PAINT:
      {
        dc = BeginPaint(window, &ps);
        GetClientRect(window, &r);
        DrawEdge(dc, &r, BDR_SUNKENOUTER, BF_RECT);
        TextOut(dc, 4, 4, ":-)", 3);
        EndPaint(window, &ps);
        return result;
      };
    };
    result = DefWindowProc(window, message, wParam, lParam);
    return result;
  };
};

/*----------------------------------------------------------------*/ 
void ReadConfig(void)
/*var
 CFG:TCFG;*/ 
{
/* OpenCFGr(AData.PluginsCFG, @CFG);
   CloseCFGr(@CFG);*/ 
};

/*----------------------------------------------------------------*/ 

void WINAPI InitGlobalModule(const PAstonData AstonData)
{
  
  WNDCLASS WindowClass;
  TDockInfo DockInfo;
  {
    if (AstonData->cbsize < sizeof(TAstonData))
    return;
    RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    WindowClass.style = CS_HREDRAW | CS_VREDRAW;
    WindowClass.hCursor = LoadCursor(0, IDC_ARROW);
    WindowClass.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WindowProc;
    WindowClass.lpszClassName = szName;
    if (RegisterClass(&WindowClass) == 0)
    return;
    
    
    ReadConfig();
    
    ChildWindow = CreateWindowEx(0, szName, 
    NULL, 
    WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
    0, 
    0, 0, 
    0, AData.Taskbar, 
    0, 
    hInstance, 
    NULL);
    
    
    AData.Node->Wnd = ChildWindow;
    
/*with (DockInfo)*/
    {
      DockInfo.Wnd = ChildWindow;
      DockInfo.Parent = AData.Taskbar;
      SetRect(&DockInfo.rc_Client, 0, 0, 32, AData.Ring1->ButtonHeight);
      DockInfo.Align = 1;
      DockInfo.Vert = FALSE;
      DockInfo.Flat = FALSE;
      DockInfo.Priority = 1;
    };
    SendMessage(AData.MainWindow, CM_DOCK, 0, ((LONG)(&DockInfo)));
  };
};

/*----------------------------------------------------------------*/ 

void WINAPI DoneModule(void)
{
  if (ChildWindow != 0)
  {
    DestroyWindow(ChildWindow);
    ChildWindow = 0;
  };
  UnregisterClass(szName, hInstance);
};

/*----------------------------------------------------------------*/ 


//pas2c32 warnings: 3
