/*   http://www.astonshell.com/     */

//---------------

//Unit Proces; 


//Interface

#include <windows.h>
#include "../SDK/rtlmem.h"

#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"
#include "proces.h"
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
DWORD osinfo;
DWORD curid;
int pcount = 0;
int pmax = 0;
PProc plist = NULL;
//----------------------------------------------------------------



//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
BOOL ToolHelp = TRUE;
BOOL TempInit = FALSE;
BOOL Initialized = FALSE;


#define TH32CS_SNAPPROCESS 0x00000002

#pragma pack(1)
typedef struct tagPROCESSENTRY32
{ 
  DWORD dwSize;
  DWORD cntUsage;
  DWORD th32ProcessID;
  DWORD th32DefaultHeapID;
  DWORD th32ModuleID;
  DWORD cntThreads;
  DWORD th32ParentProcessID;
  LONG pcPriClassBase;
  DWORD dwFlags;
  char szExeFile[MAX_PATH];
} PROCESSENTRY32;
typedef PROCESSENTRY32* PPROCESSENTRY32;
typedef PROCESSENTRY32 TProcessEntry32;


HANDLE hSnapshot;
HANDLE (WINAPI *CreateToolhelp32Snapshot)(DWORD dwFlags, DWORD th32ProcessID);
BOOL (WINAPI *Process32First)(HANDLE hSnapshot, TProcessEntry32* lppe);
BOOL (WINAPI *Process32Next)(HANDLE hSnapshot, TProcessEntry32* lppe);
//----------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
typedef struct TProcessInfo* PProcessInfo;

typedef struct TProcessInfo
{ 
  DWORD dwOffset;
  DWORD dwThreadCount;
  DWORD dwUnknown1[6];
  FILETIME ftCreationTime;
  DWORD dwUnknown2[5];
  WCHAR* pszProcessName;
  DWORD dwBasePriority;
  DWORD dwProcessID;
  DWORD dwParentProcessID; 
  //etc...
} TProcessInfo;

#pragma pack()

#define STATUS_SUCCESS 0x00000000
#define STATUS_UNSUCCESSFUL ((LONG)(0xC0000001))
#define STATUS_INFO_LENGTH_MISMATCH ((LONG)(0xC0000004))


LONG (WINAPI *NtQuerySystemInformation)(DWORD a, LPVOID p, DWORD b, LPDWORD c);
LPVOID buff = NULL;
DWORD MemProcess;
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
void InitProcessInfo(void)
{
  
  HANDLE KernelHandle;
  HANDLE hNTDll;
  {
    curid = GetCurrentProcessId();
    ToolHelp = osinfo == VER_PLATFORM_WIN32_WINDOWS;
    if (ToolHelp)
    {
      KernelHandle = GetModuleHandle("KERNEL32.DLL");
      if (NULL != KernelHandle)
      {
        CreateToolhelp32Snapshot = (void*)GetProcAddress(KernelHandle, "CreateToolhelp32Snapshot");
        Process32First = (void*)GetProcAddress(KernelHandle, "Process32First");
        Process32Next = (void*)GetProcAddress(KernelHandle, "Process32Next");
        Initialized = CreateToolhelp32Snapshot != NULL;
      };
    }
    else
    {
      hNTDll = GetModuleHandle("NTDLL.DLL");
      if (hNTDll != 0)
      {
        NtQuerySystemInformation = (void*)GetProcAddress(hNTDll, "NtQuerySystemInformation");
        if (NtQuerySystemInformation != NULL)
        {
          MemProcess = 0xFFF;
          buff = malloc(MemProcess);
          Initialized = (buff != NULL);
        };
      };
    };
  };
};
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
void GetProcessList(void)
{
/*Label 
  Ass*/
  {
    if (!Initialized)
    InitProcessInfo();
    
    TempInit = FALSE;
    if (!Initialized)
    return;
    
    if (ToolHelp)
    {
      hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
      TempInit = hSnapshot != INVALID_HANDLE_VALUE;
    }
    else
    {
Ass:
      RtlZeroMemory(buff, MemProcess);
      switch (NtQuerySystemInformation(5, buff, MemProcess, NULL))
      {
        case STATUS_SUCCESS:
        TempInit = TRUE;
        break;
        case STATUS_INFO_LENGTH_MISMATCH:
        {
          MemProcess += 0xFFF;
          buff = realloc(buff, MemProcess);
          if (NULL != buff)
            goto Ass;
        };
      };//case
    };
  };
};
//----------------------------------------------------------------
void TryFreeProcessList(void)
{
  if (!TempInit)
  return;
  TempInit = FALSE;
  if (ToolHelp)
  CloseHandle(hSnapshot);
};
//----------------------------------------------------------------
void DoneProcessInfo(void)
{
  MemProcess = 0;
  if (buff)
    free(buff);
  buff = NULL;
};
//----------------------------------------------------------------
int FindNameInPath(char* Path)
{
  int result;
  
  result = lstrlen(Path);
  while ((result > 0) && (Path[result-1] != '\\'))
  --result;
  return result;
};
//----------------------------------------------------------------
static char* black[] = 
{
  "smss.exe", 
  "csrss.exe", 
  "winlogon.exe", 
  "services.exe", 
  "svchost.exe", 
  "lsass.exe", 
  "WinMgmt.exe", 
  "MSTask.exe", 
  "regsvc.exe", 
  "spoolsv.exe", 
  "spoolss.exe", 
  "RpcSs.exe", 
  "MSGSRV32.EXE", 
  "MPREXE.EXE"
};


static char* sys[] = 
{
  "System", 
  "KERNEL32.DLL"
};


//----------------------------------------------------------------
void AddFileName(char* p, DWORD id)
{
  
  int i, j;
  char* pt;
  {
    if ((p == NULL) || (p[0] == '0x00'))
    return;
    pt = &p[FindNameInPath(p)];
    for (i = 0; i < sizeof(black)/sizeof(PCHAR); i++)
    if (lstrcmpi(pt, black[i]) == 0)
    return;
    
    j = pcount++;
    if (pcount > pmax)
    {
      pmax += 16;
      plist = realloc(plist, pmax*sizeof(TProc));
    };
    
    plist[j].pid = id;
    plist[j].szexe = malloc(lstrlen(p) + 1);
    lstrcpy(plist[j].szexe, p);
    
    plist[j].wnd = 0;
    plist[j].caption = NULL;
    plist[j].flag = 0;
    
    for (i = 0; i < sizeof(sys)/sizeof(PCHAR); i++)
    if (lstrcmpi(pt, sys[i]) == 0)
    {
      plist[j].flag |= FLAG_SYS;
      break;
    };
  };
};

//----------------------------------------------------------------
void FillProcessListNT(void)
{
  
  PProcessInfo pinfo;
  char ExeName[MAX_PATH+1];
  {
    pcount = 0;
    pmax = 0;
    plist = NULL;
    
    pinfo = (PProcessInfo)buff;
    while (TRUE)
    {
      if (pinfo->pszProcessName != NULL)
      {
        ExeName[0] = '\x00';
        WideCharToMultiByte(CP_ACP, 0, &pinfo->pszProcessName[0], -1, &ExeName[0], MAX_PATH, NULL, NULL);
        AddFileName(ExeName, pinfo->dwProcessID);
      };
      if (pinfo->dwOffset != 0)
      pinfo = (PProcessInfo)(((DWORD)(pinfo))+pinfo->dwOffset);
      else
      break;
    };
  };
};
//----------------------------------------------------------------
void FillProcessList9x(void)
{
  
  PROCESSENTRY32 pe32;
  {
    pcount = 0;
    pmax = 0;
    plist = NULL;
    
    
    pe32.dwSize = sizeof(PROCESSENTRY32);
    if (Process32First(hSnapshot, &pe32))
    {
      do
      {
        AddFileName(pe32.szExeFile, pe32.th32ProcessID);
      } while (Process32Next(hSnapshot, &pe32));
    };
  };
};
//----------------------------------------------------------------
//----------------------------------------------------------------
//----------------------------------------------------------------
