/************************************/
/*   Gladiators Software            */
/*   http://www.astonshell.com/     */
/************************************/


/* Gladiators Software, 1999-2006*/ 


#pragma comment(linker, "/OPT:NOWIN98")
#pragma comment(linker, "/DEF:Zoom.def")
#pragma comment(linker,"/entry:DllMain")

#include <windows.h>
#include "../SDK/rtlmem.h"

#define NODEFAULTLIB

#include "../SDK/astonsdk.h"
#include "../SDK/st_api.h"
#include "../SDK/w2k.h"
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------------------------------------------------------------------
HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = hModule);
    }
    return TRUE;
}

/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

HWND hSDKWnd = 0;
TToolData AData;
TOOLINFO ti;
char* szSDK = "Zoom";
char* Description = "Zoom 1.8c\x0D\x0A"\
" 1999-2003 Gladiators Software";

RECT ClientRect;
int IconSize;
int SizeX;
int SizeY;
int Factor;
HICON Ico = 0;
int zoomX, zoomY;
int iElapse;

#define TimerID 1
BOOL bTimer, bEnabled;

#define CM_APPBAR WM_USER+2
BOOL bFullScreen;
APPBARDATA bd;

TPluginInfo PluginInfo;
/*----------------------------------------------------------------*/ 

#define szFactor "Factor"
#define szEnabled "Enabled"
#define szElapse "Elapse"

static TKey ZoomKeys[] = 
{
  {
    szFactor, 
    KEY_INT_RANGE | KEY_NOTHEME, szFactor, 2, 
    1, 8
  },
  {
    szEnabled, 
    KEY_BOOL | KEY_NOTHEME, "Always Enabled", 0, 
    0, 0
  },
  {
    szElapse, 
    KEY_INT_RANGE | KEY_NOTHEME, "Timer Elapse", 200, 
    17, 30000
  }
};

/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

void TryStopTimer(void)
{
  if (bTimer)
  {
    bTimer = FALSE;
    KillTimer(hSDKWnd, TimerID);
  };
};
//************************************************
void TryStartTimer(void)
{
  if (!bTimer)
    bTimer = SetTimer(hSDKWnd, TimerID, iElapse, NULL) != 0;
};
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
void ReadConfig(void)
{
  
  TCFG CFG;
  {
    OpenCFGr(AData.PluginsCFG, &CFG);
    FindSection(szSDK, 0, &CFG);
    Factor = GetCFGInt(szFactor, 2, &CFG);
    bEnabled = GetCFGBool(szEnabled, 0, &CFG);
    iElapse = GetCFGInt(szElapse, 200, &CFG);
    CheckInt(&iElapse, 17, 30000, 200);
    CloseCFGr(&CFG);
    CheckInt(&Factor, 1, 8, 2);
  };
};
/*----------------------------------------------------------------*/ 
void DrawFlatButton(HDC dc)
{
  
  int cx;
  int cy;
  int j;
  {
    {
      cx = (SizeX-IconSize)/2;
      cy = (SizeY-IconSize)/2;
      cx += AData.Ring1->YXOffset[AData.iID];
      cy += AData.Ring1->YYOffset[AData.iID];
      if (*(AData.Pressed) == AData.Position)
      {
        cx += AData.Ring1->PushOffset[AData.iID];
        cy += AData.Ring1->PushOffset[AData.iID];
        j = 3;
      }
      else
      if (*(AData.Focus) == AData.Position)
      {
        cx -= AData.Ring1->PushOffset[AData.iID];
        cy -= AData.Ring1->PushOffset[AData.iID];
        j = 2;
      }
      else
      {
        j = 1;
      };
      DrawSkinTrans(dc, AData.MemoryDC, j, AData.iID, AData.Ring1);
      DrawIconEx(AData.MemoryDC, cx, cy, Ico, 0, 0, 0, 0, DI_NORMAL);
      BitBlt(dc, 0, 0, SizeX, SizeY, AData.MemoryDC, 0, 0, SRCCOPY);
    };
  };
};
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 
void DrawZoom(HDC dc)
{
  
  HDC ScreenDC;
  POINT p;
  if ( ! (*(AData.HideFlag)))
  {
    GetCursorPos(&p);
    ScreenDC = GetDC(0);
    {
      BitBlt(AData.MemoryDC, 0, 0, zoomX, zoomY,
             ScreenDC, p.x - zoomX/2, p.y - zoomY/2,
             SRCCOPY | ((AData.osver->dwMajorVersion > 4) ? 
             (//NOMIRRORBITMAP | 
             CAPTUREBLT) : 0));
      StretchBlt(dc, 0, 0, zoomX * Factor, zoomY * Factor, 
             AData.MemoryDC, 0, 0, zoomX, zoomY,
      SRCCOPY);
    };
    ReleaseDC(0, ScreenDC);
  };
};

/*----------------------------------------------------------------*/ 
/*----------------------------------------------------------------*/ 

LONG WINAPI WndProcSDK(HWND window, UINT message, WPARAM wParam, LPARAM lParam)
{
  
  PAINTSTRUCT ps;
  HDC dc;
  int i;
  {
    LONG result;
    
    if ( !(*(AData.HideFlag)))/*autohide toolbar*/ 
    NotifyTip(AData.ToolTip, window, message, wParam, lParam);
    
    result = 0;
    
    switch (message)
    {
    case WM_PAINT:
      {
        dc = BeginPaint(window, &ps);
        if (bEnabled)
          DrawZoom(dc);
        else
          DrawFlatButton(dc);
        EndPaint(window, &ps);
        return result;
      };
      break;
    case WM_MOUSEMOVE:
      if (*(AData.Focus) != AData.Position)
      {
        SendMessage(AData.ToolContainer[AData.iID], CM_TOOLPLUGINMOUSEMOVE, 0, 0);
        InvalidateRect(window, NULL, FALSE);
        UpdateWindow(window);
        return result;
      }
      else
      if (*(AData.Pressed) == AData.Position)
      {
        dc = GetDC(window);
        DrawZoom(dc);
        ReleaseDC(window, dc);
        return result;
      };
      break;
    case WM_TIMER:
      if (bEnabled)
      {
        if (!bFullScreen && !(*(AData.HideFlag)))
        {
          dc = GetDC(window);
          DrawZoom(dc);
          ReleaseDC(window, dc);
        }
      }
      else
        TryStopTimer();
      return result;
    case CM_PLUGINMOUSELEAVE:
      {
        InvalidateRect(window, NULL, FALSE);
        UpdateWindow(window);
        return result;
      };
      break;
    case WM_LBUTTONDOWN:
      {
        SetCapture(window);
        *(AData.Pressed) = AData.Position;
        InvalidateRect(window, NULL, FALSE);
        return result;
      };
      break;
    case WM_LBUTTONUP:
      {
        ReleaseCapture();
        return result;
      };
      break;
    case WM_CAPTURECHANGED:
      {
        i = *(AData.Pressed);
        if (i < 0)
          return result;
        *(AData.Pressed) = -1;
        InvalidateRect(window, NULL, FALSE);
        return result;
      };
      break;
    case WM_NOTIFY:
      {
        switch ((*(LPNMHDR)(lParam)).code)
        {
        case TTN_SHOW:
          {
            result = ((LONG)(SetWindowPos((*(LPNMHDR)(lParam)).hwndFrom, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE)));
          };
        };
        return result;
      };
      break;
    case CM_APPBAR:
      {
        if (wParam == ABN_FULLSCREENAPP)
          bFullScreen = lParam != 0;
        return result;
      };
    };
    return DefWindowProc(window, message, wParam, lParam);
  };
};

/*----------------------------------------------------------------*/ 
void WINAPI InitToolbarModule(PToolData ad)
{
  WNDCLASS WindowClass;
  {
    if (ad->cbsize < sizeof(TToolData))
    return;
    RtlMoveMemory(&AData, ad, sizeof(TToolData));
    
    RtlZeroMemory(&WindowClass, sizeof(WNDCLASS));
    WindowClass.hInstance = hInstance;
    WindowClass.lpfnWndProc = WndProcSDK;
    WindowClass.hCursor = LoadCursor(0, IDC_ARROW);
    WindowClass.lpszClassName = szSDK;
    if (RegisterClass(&WindowClass) == 0)
      return;
    
    SizeX = AData.Ring1->ToolSizeX[AData.iID];
    SizeY = AData.Ring1->ToolSizeY[AData.iID];
    
    ReadConfig();
    
    zoomX = SizeX/Factor + 1;
    zoomY = SizeY/Factor + 1;

    {
      hSDKWnd = CreateWindowEx(0, 
      szSDK, 
      NULL, 
      WS_VISIBLE | WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, 
      0, 
      AData.Position*SizeY, SizeX, 
      SizeY, AData.ToolContainer[AData.iID], 
      0, 
      hInstance, 
      NULL);
      
      AData.Node->Wnd = hSDKWnd;
      AData.Node->NodeType |= NODE_FLAT;
    };
    GetClientRect(hSDKWnd, &ClientRect);
    
    ti.cbSize = sizeof(TOOLINFO);
    ti.uFlags = TTF_CENTERTIP;
    ti.hwnd = hSDKWnd;
    ti.uId = 1;
    CopyRect(&ti.rect, &ClientRect);
    InflateRect(&ti.rect, -1, -1);
    ti.hinst = hInstance;
    ti.lpszText = szSDK;
    SendMessage(AData.ToolTip, TTM_ADDTOOL, 0, ((LPARAM)(&ti)));
    
    
    if ((SizeX <= 32) || (SizeY <= 32))
      IconSize = 16;
    else
      IconSize = 32;
    Ico = LoadImage(hInstance, ((char*)(1)), IMAGE_ICON, IconSize, IconSize, LR_SHARED);

    bFullScreen = SendMessage(AData.MainWindow, CM_GETFULLSCREEN, 0, 0) != 0;
    bd.cbSize = sizeof(APPBARDATA);
    bd.uCallbackMessage = CM_APPBAR;
    bd.hWnd = hSDKWnd;
    SHAppBarMessage(ABM_NEW, &bd);
    
    if (bEnabled)
      TryStartTimer();
  };
};
/*----------------------------------------------------------------*/ 

void WINAPI DoneModule(void)
{
  if (hSDKWnd != 0)
  {
    TryStopTimer();
    SendMessage(AData.ToolTip, TTM_DELTOOL, 0, ((LPARAM)(&ti)));
    SHAppBarMessage(ABM_REMOVE, &bd);
    DestroyWindow(hSDKWnd);
    hSDKWnd = 0;
  };

  UnregisterClass(szSDK, hInstance);
};
/*----------------------------------------------------------------*/ 

PPluginInfo WINAPI GetPluginInfo(void)
{
  PPluginInfo result;
  
  PluginInfo.cbSize = sizeof(TPluginInfo);
  PluginInfo.szName = szSDK;
  PluginInfo.szDescription = Description;
  PluginInfo.szSection = szSDK;
  PluginInfo.nKeyCount = sizeof(ZoomKeys)/sizeof(TKey);
  PluginInfo.Keys = (void *)&ZoomKeys;
  result = &PluginInfo;
  return result;
};
