/************************************/
/*   Gladiators Software 2006       */
/*   http://www.astonshell.com/     */
/************************************/


#include "stdafx.h"

#define IsEmpty(c) ((c)==NULL || (c)[0] == 0) 
#define szPicKey        "picture"
#define szPicKeyHint    "Picture"
           

AstonWND* ii;
TCFG CFG;
TPluginInfo PluginInfo;
TAstonData	AData;
char Pic_path[MAX_PATH+1];
static char* szName = "Test plug-in";
static char* szhelp = "Test plug-in";
static char* szSection = "Test_PLG";



static TKey Keys[] = 
{
	{
		 szPicKey,  KEY_BITMAP, szPicKeyHint, 0, 0, 0
	}
};



//-----------------------------------------------------------------------------
#pragma comment(linker,"/entry:DllMain")
//-----------------------------------------------------------------------------
HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = (HMODULE)hModule);
    }
    return TRUE;
};
//-----------------------------------------------------------------------------
void ShowError(char* text)
{
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);       // disable recycle
  MessageBox(0, text, "Error", MB_ICONWARNING | MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);       // enable recycle
};
//-----------------------------------------------------------------------------
void GetDefaultPicture(char* result, char* pic)
{
  int i;
  GetModuleFileName((HMODULE)AData.AppInstance, result, MAX_PATH);
  for (i = lstrlen(result)-1; i>=0; --i)
  {
    if (result[i] == '\\')
    {
      result[i+1] = 0;
      break;
    }
  }
  lstrcat(result, pic);
}
//-----------------------------------------------------------------------------
void LoadConfig(void)// read Config
{
  OpenCFGr(AData.PluginsCFG, &CFG);
  FindSection(szSection, 0, &CFG);
  GetCFGString(szPicKey, "", Pic_path, MAX_PATH, &CFG);
  if (IsEmpty(Pic_path))
  {
    GetDefaultPicture(Pic_path, "Pic\\frame.jpg");//  default picture, for test
  };
  CloseCFGr(&CFG);
};
//-----------------------------------------------------------------------------


void WINAPI InitGlobalModule(const PAstonData Info)
{
  RtlMoveMemory(&AData, Info, sizeof(TAstonData));
  LoadConfig();
  ii = (AstonWND *)CreateAstonWND(0, 0, 0, 2, AWS_LAYERED | AWS_FADESTYLE, NULL, 0, 0);
  if ((ii == NULL))
  {
    ShowError("Aston window wasn''t created");
    return;
  };

  if ((ii->GetVer() < 19200))// check version
  {
    ShowError("Old version AstonEx.dll! Please update Aston");
    return;
  };

  int i = ii->SetBG(Pic_path);// add  background (zero layer)
  if ((i < 0))
  ShowError(Pic_path/*"Picture frame.jpg not found!"*/);// i = layer index
  ii->Show(1);
 };
//-----------------------------------------------------------------
void WINAPI DoneModule(void)
{
  if (ii != NULL)
  {
	  DestroyWindow(ii->hwnd());
  }
};
//-----------------------------------------------------------------
PPluginInfo WINAPI GetPluginInfo(void)
{
    PPluginInfo result;
    PluginInfo.cbSize = sizeof(TPluginInfo);
    PluginInfo.szName = szName;
    PluginInfo.szDescription = szhelp;
    PluginInfo.szSection = szSection;
    PluginInfo.nKeyCount = sizeof(Keys)/sizeof(TKey);
    PluginInfo.Keys = (PKey)&Keys;
    result = &PluginInfo;
    return result;
};
