/************************************/
/*   Gladiators Software 2006       */
/*   http://www.astonshell.com/     */
/************************************/


#include "stdafx.h"

#define IsEmpty(c) ((c)==NULL || (c)[0] == 0) 
#define szPicKey        "picture"
#define szPicKeyHint    "Picture"
           

AstonWND* ii;
TPicture pic;
TPicture pic1;
TPicture pic2;
TPicture pic3;
TCFG CFG;
int c;
int index;
int j;
int k;
int s;
int b;
HWND w;
RECT r;

TPluginInfo PluginInfo;
TAstonData	AData;
static char* szName = "Test plug-in";
static char* szhelp = "Test plug-in";
static char* szSection = "Test_PLG";



static TKey Keys[] = 
{
	{
		 szPicKey,  KEY_BITMAP, szPicKeyHint, 0, 0, 0
	}
};



//-----------------------------------------------------------------------------
#pragma comment(linker,"/entry:DllMain")
//-----------------------------------------------------------------------------
HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = (HMODULE)hModule);
    }
    return TRUE;
};
//-----------------------------------------------------------------------------
void ShowError(char* text)
{
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);       // disable recycle
  MessageBox(0, text, "Error", MB_ICONWARNING | MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);       // enable recycle
};
//-----------------------------------------------------------------------------
void GetDefaultPicture(char* result, char* pic)
{
  int i;
  GetModuleFileName((HMODULE)AData.AppInstance, result, MAX_PATH);
  for (i = lstrlen(result)-1; i>=0; --i)
  {
    if (result[i] == '\\')
    {
      result[i+1] = 0;
      break;
    }
  }
  lstrcat(result, pic);
}

//-----------------------------------------------------------------------------


void WINAPI InitGlobalModule(const PAstonData Info)
{
  char path[MAX_PATH];
  RtlMoveMemory(&AData, Info, sizeof(TAstonData));
  ii = (AstonWND *)CreateAstonWND(0, 0, 0, 2, AWS_LAYERED | AWS_FADESTYLE, NULL, 0, 10);
  if ((ii == NULL))
  {
    ShowError("Aston window wasn''t created");
    return;
  };

  if ((ii->GetVer() < 19200))// check version
  {
    ShowError("Old version AstonEx.dll! Please update Aston");
    return;
  };

  GetDefaultPicture(path, "Pic\\frame.jpg");
  index = ii->SetBG(path);// add  background (zero layer)
  if ((index < 0))
  ShowError("Picture frame.jpg is not found! Please copy folder with pictures to %AstonPath%\\Pic\\");// index - layer index
//---------------------------------------------------------------
  ii->MoveWindow(100, 100);// set new position for window
//---------------------------------------------------------------
  SetRect(&r, 200, 50, 400, 70);
  ii->DrawTextOnLayer(index, "Hello Aston developers", &r, 
                      (HFONT)GetStockObject(SYSTEM_FONT), DT_LEFT, 0x0000FF, TRUE, 0);
  
//---------------------------------------------------------------
  GetDefaultPicture(path, "Pic\\cd.ankz");
  j = ii->AddLayer(0, 0, 0, path, LAYER_DRAG, 0);
  if ((j < 0))
  ShowError("Picture cd.ankz is not found!");
  
//---------------------------------------------------------------
  k = ii->CreateCustomLayer(0, 100, 100, 50, 70, LAYER_DRAWWALLPAPER | LAYER_LAYERED, 0);
  
//---------------------------------------------------------------
  w = ii->CreateChildWnd(WS_EX_TOOLWINDOW, "EDIT", "edit control",
                         WS_VISIBLE | WS_BORDER | ES_MULTILINE | ES_AUTOVSCROLL, 
                         250, 100, 150, 80, 
                         0, hInstance, NULL);
  
//---------------------------------------------------------------
  RtlZeroMemory(&pic, sizeof(TPicture));
  GetDefaultPicture(path, "Pic\\XPClock.png");
  pic.FileName = path;
  LoadImageEx(&pic);
  if (pic.IconType > 0)
  {
    c = ii->AddLayerPic(0, 0, 280, &pic, LAYER_DRAGITEM);
    ii->AddHintOnLayer(c, "Drag me!");// add hint on layer
  }
  else
  ShowError("Picture XPClock.png is not found!");
  pic.FileName = NULL;
  
//---------------------------------------------------------------
  RtlZeroMemory(&pic1, sizeof(TPicture));
  RtlZeroMemory(&pic2, sizeof(TPicture));
  RtlZeroMemory(&pic3, sizeof(TPicture));
  GetDefaultPicture(path, "Pic\\AA-play1.png");
  pic1.FileName = path;
  LoadImageEx(&pic1);
  GetDefaultPicture(path, "Pic\\AA-play2.png");
  pic2.FileName = path;
  LoadImageEx(&pic2);
  GetDefaultPicture(path, "Pic\\AA-play3.png");
  pic3.FileName = path;
  LoadImageEx(&pic3);
  
  ii->AddLayerPic3(0, 200, 200, &pic1, &pic2, &pic3, 0);
  
  pic1.FileName = NULL;
  pic2.FileName = NULL;
  pic3.FileName = NULL;
  
//---------------------------------------------------------------

  GetDefaultPicture(path, "Pic\\pos_bar.png");
  s = ii->AddLayer(0, 100, 40, path, 0, 0);
  GetDefaultPicture(path, "Pic\\VSliderDot.png");
  b = ii->AddLayer(0, 0, 0, path, 0, 0);
  
  ii->MakeScrollBar(s, b, 10, 120, 50, 0);
  
//---------------------------------------------------------------
  ii->Show(1);

 };
//-----------------------------------------------------------------
void WINAPI DoneModule(void)
{
  if (ii != NULL)
  {
	  DestroyWindow(ii->hwnd());
  }
  FreePicture(&pic1);
  FreePicture(&pic2);
  FreePicture(&pic3);
};
//-----------------------------------------------------------------
PPluginInfo WINAPI GetPluginInfo(void)
{
    PPluginInfo result;
    PluginInfo.cbSize = sizeof(TPluginInfo);
    PluginInfo.szName = szName;
    PluginInfo.szDescription = szhelp;
    PluginInfo.szSection = szSection;
    PluginInfo.nKeyCount = sizeof(Keys)/sizeof(TKey);
    PluginInfo.Keys = (PKey)&Keys;
    result = &PluginInfo;
    return result;
};
