/************************************/
/*   Gladiators Software 2006       */
/*   http://www.astonshell.com/     */
/************************************/


#include "stdafx.h"

#define IsEmpty(c) ((c)==NULL || (c)[0] == 0) 
#define szPicKey        "picture"
#define szPicKeyHint    "Picture"
           

static CHAR* szName = "Test plug-in";
static CHAR* szhelp = "Test plug-in";
static CHAR* szSection = "Test_PLG";
#define szXY                "XY"
#define szXYHint            "Coordinates"
#define szZOrderHint        "Z-Order"
#define szZOrder            "ZOrder"
#define szSetupPlugin       "Setup Plug-in"
#define szTransparency      "Transparency"
#define szTransparencyHint  "Transparency"



#define TPos 2 
static CHAR* TPosT[TPos+1] = 
{
  "Desktop", 
  "Normal", 
  "Always on top"
}; 

#define KeyCount 3
static TKey Keys[] = 
{
  {
    szXY, KEY_POINT, szXYHint, 0, 0, 0
  }, 
  {
    szZOrder, KEY_LIST, szZOrderHint, 1, TPos, (int)&TPosT
  },
  {
    szTransparency, KEY_TRANSPARENCY, szTransparencyHint, 0, 0, 0
  }
};

TPluginInfo PluginInfo;
TAstonData AData;
AstonWND* ii;
TPicture pic1;
TPicture pic2;
TPicture pic3;
int btn;
int index;
int j;
int k;
int s;
int b;
Ppaint pp;
TCFG CFG;
POINT xy;
int ZOrder; 
bool OpenMenu = false;
int Transparency;



//-----------------------------------------------------------------------------
#pragma comment(linker,"/entry:DllMain")
//-----------------------------------------------------------------------------
HMODULE hInstance;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = (HMODULE)hModule);
    }
    return TRUE;
};
//-----------------------------------------------------------------------------
void ShowError(char* text)
{
  SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);       // disable recycle
  MessageBox(0, text, "Error", MB_ICONWARNING | MB_TOPMOST);
  SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);       // enable recycle
};
//-----------------------------------------------------------------------------

void GetDefaultPicture(char* result, char* pic)
{
  int i;
  GetModuleFileName((HMODULE)AData.AppInstance, result, MAX_PATH);
  for (i = lstrlen(result)-1; i>=0; --i)
  {
    if (result[i] == '\\')
    {
      result[i+1] = 0;
      break;
    }
  }
  lstrcat(result, pic);
}
//-----------------------------------------------------------------------------
void LoadConfig()// read Config
{
  OpenCFGr(AData.PluginsCFG, &CFG);
  FindSection(szSection, 0, &CFG);
  xy.x = 50;// default coordinates
  xy.y = 50;
  GetCFGPoint(szXY, &xy, &CFG);
  ZOrder = GetCFGInt(szZOrder, 2, &CFG); 
  Transparency = GetCFGInt(szTransparency, 0, &CFG);
  CloseCFGr(&CFG);
};
//---------------------------------------------------------------------
void DrawWindowCoordinats(HWND wnd)
{
  
  CHAR st[64];
  RECT r;
  {
    GetWindowRect(wnd, &r);
    pp = ii->LayerPaint_Begin(k);
    wvsprintf(st, "%i x %i", (char*)&r);
    SetRectEmpty(&r);
    r.right = pp->size.cx;
    r.bottom = pp->size.cy;
    ii->DrawText(pp->DC, st, &r, (HFONT)GetStockObject(SYSTEM_FONT), DT_LEFT, 0x0000ff, TRUE, 0);
    ii->LayerPaint_End(pp);
    ii->ReDraw();
  };
};
//-----------------------------------------------------------------------------

LONG WINAPI WindowProc(HWND window, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  
  CHAR st[64+1];
  RECT r;
  TCFG CFG;
  int i;
  POINT p;
   
    switch (Msg)
    {
      case WM_MOVE:
      {
        DrawWindowCoordinats(window);
      };
      break;
      case WM_EXITSIZEMOVE:// end drag window and save window position
      {
        GetWindowRect(window, &r);
        RtlZeroMemory(&CFG, sizeof(TCFG));
        OpenCFGw(AData.PluginsCFG, &CFG);
        FindSection(szSection, 1, &CFG);
        p.x = r.left;
        p.y = r.top;
        SetCFGPoint(szXY, p, &CFG);
        CloseCFGw(AData.PluginsCFG, FALSE, &CFG);
      };
      
      
      break;
      case WM_KEYDOWN:
      {
        pp = ii->LayerPaint_Begin(k);
        lstrcpy(st, "KEYDOWN: ");
        i = lstrlen(st);
        st[i] = ((CHAR)(wParam));
        st[i+1] = '\x00';
        SetRectEmpty(&r);
        r.right = pp->size.cx;
        r.bottom = pp->size.cy;// r = layer rect  
        ii->DrawText(pp->DC, st, &r, (HFONT)GetStockObject(SYSTEM_FONT), DT_LEFT, 0x0000ff, TRUE, 0);
        ii->LayerPaint_End(pp);
        ii->ReDraw();
      };
      
      break;
      case WM_LBUTTONDOWN:// wParam - layer index
      {
        if (wParam == btn)
        {
          MessageBox(window, "Hello Aston developers!", "Hello", MB_TOPMOST);
        };
        return 1;
      };
      
      break;
      case WM_HSCROLL:// WParam = scrollbar position, LParam - scroll index
                      // show scrollbar position
      {
        wvsprintf(st, "%i", (char*)&wParam);
        SetRect(&r, 0, 0, 100, 100);
        pp = ii->LayerPaint_Begin(j);
        ii->DrawText(pp->DC, st, &r, (HFONT)GetStockObject(SYSTEM_FONT), DT_LEFT, 0x0000ff, TRUE, 0);
        ii->LayerPaint_End(pp);
        ii->ReDraw();
        return 1;
      };
      
      case WM_RBUTTONDOWN:
      {
        if (OpenMenu) return 1;
        OpenMenu = true;
        HMENU Menu;
        char Setup[MAX_PATH];
        GetCursorPos(&p);
        Menu = CreatePopupMenu();       
		AppendMenu(Menu, MF_STRING, 100, szSetupPlugin);
        ::SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0); 
        int u = TrackPopupMenuEx(Menu, TPM_RETURNCMD, p.x, p.y, window, NULL);
        DestroyMenu(Menu);
        ::SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0); 
        if (u == 100)                 // setup plug-in
        {
            Setup[0] = '/';
            lstrcpy((char*)&Setup[1], AData.Node->Path);
            SendMessage(AData.MainWindow, CM_SETUPASTON, 0, ((LONG)(&Setup[0])));

        }
        OpenMenu = false;
        return 1;
      };
      break;
    
    };
    
   return 0;

};

//-----------------------------------------------------------------------------


void WINAPI InitGlobalModule(const PAstonData Info)
{
  char path[MAX_PATH];
  RtlMoveMemory(&AData, Info, sizeof(TAstonData));
  LoadConfig();

  ii = (AstonWND *)CreateAstonWND(xy.x, xy.y, AData.Desktop, 
                                ZOrder, AWS_LAYERED | AWS_FADESTYLE |((ZOrder == 0) ? AWS_DRAWWALLPAPER : 0), 
                                &WindowProc, AData.Desktop, ((ZOrder == 0) ? 0 : Transparency));// create window
  if ((ii == NULL))
  {
    ShowError("Aston window wasn''t created");
    return;
  };
  if ((ii->GetVer() < 19200))// check version
  {
    ShowError("Old version AstonEx.dll Please update Aston");
    DestroyWindow(ii->hwnd());//  Destroy Window
    ii = NULL;
    return;
  };
  
  
  GetDefaultPicture(path, "Pic\\frame.jpg");
  index = ii->AddLayer(0, 0,0, path, LAYER_DRAG, ((ZOrder == 0) ? Transparency : 0));// add  background (zero layer)
  if ((index < 0))
  ShowError("Picture \"frame.jpg\" is not found!");
  
//---------------------------------------------------------------
  k = ii->CreateCustomLayer(0, 0, 0, 100, 20, LAYER_LAYERED, 0);// for draw window coordinates
  DrawWindowCoordinats(ii->hwnd());
  
//---------------------------------------------------------------
  RtlZeroMemory(&pic1, sizeof(TPicture));
  RtlZeroMemory(&pic2, sizeof(TPicture));
  RtlZeroMemory(&pic3, sizeof(TPicture));
  GetDefaultPicture(path, "Pic\\AA-play1.png");
  pic1.FileName = path;
  LoadImageEx(&pic1);
  GetDefaultPicture(path, "Pic\\AA-play2.png");
  pic2.FileName = path;
  LoadImageEx(&pic2);
  GetDefaultPicture(path, "Pic\\AA-play3.png");
  pic3.FileName = path; 
  LoadImageEx(&pic3);
  
  btn = ii->AddLayerPic3(0, 200, 20, &pic1, &pic2, &pic3, 0);// button with 3 state
  pic1.FileName = NULL;
  pic2.FileName = NULL;
  pic3.FileName = NULL;
  
//---------------------------------------------------------------
  GetDefaultPicture(path, "Pic\\pos_bar.png");
  s = ii->AddLayer(0, 10, 40, path, 0, 0);
  GetDefaultPicture(path, "Pic\\VSliderDot.png");
  b = ii->AddLayer(0, 0, 0, path, 0, 0);
  
  ii->MakeScrollBar(s, b, 10, 120, 50, 0);
  
  j = ii->CreateCustomLayer(0, 135, 35, 30, 20, LAYER_LAYERED, 0);// layer for draw scrollbar position 
//---------------------------------------------------------------
  ii->Show(1);
 };
//-----------------------------------------------------------------
void WINAPI DoneModule(void)
{
  if (ii != NULL)
  {
	  DestroyWindow(ii->hwnd());
  }
  FreePicture(&pic1);
  FreePicture(&pic2);
  FreePicture(&pic3);
};
//-----------------------------------------------------------------
PPluginInfo WINAPI GetPluginInfo(void)
{
    PPluginInfo result;
    PluginInfo.cbSize = sizeof(TPluginInfo);
    PluginInfo.szName = szName;
    PluginInfo.szDescription = szhelp;
    PluginInfo.szSection = szSection;
    PluginInfo.nKeyCount = sizeof(Keys)/sizeof(TKey);
    PluginInfo.Keys = (PKey)&Keys;
    result = &PluginInfo;
    return result;
};
